<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/
if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}

/**
* Module
*
* Show the index of the forum
*
* @author denadai2 <denadai2@gmail.com>
* @company RevokeSoft <denadai2@gmail.com>
* @package RevokeBB
*/
class Module extends rev_classes
{

	/**
    * Logs class
    * @access Private
    * @var class
    */
	var $logs;
	/**
    * Constructor of the module
    *
    * @param array $config
    * @param String $act
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */	
	function Module(& $config, $act)
	{
		$this->rev_classes($config, $act);
	
		if($this->user->info_user['admincp']!=1)
			$this->error->simple_error('no_perm');
			
		require 'inc/class_logs.php';
		$this->logs = new Log_handler($this->db,$this->user, $this->_config);
		
		if($_SESSION['admin']!=true)
		{
			$this->_code = 'adminlogin';
			if(!isset($_GET['error']))
				$error = 0;
			else
				$error = intval($_GET['error']);
					
			$this->skin->assign('error', $error);
			//remove admincp header menu
			$this->skin->assign('view_cp_menu', 1);
			$this->assign_all();
			$this->skin->content = $this->skin->fetch('admincp/header.tpl');
			$this->display_admin_skin(true);
			exit;
		}
				
	}

	/**
    * Execute the module
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */	
	function execute()
	{
		$this->skin->assign('view_cp_menu',0);
			
		if(!file_exists('admin/ad_'.$this->_code.'.php'))
			$this->error->admin_error('no_profile','index.php?admin&code=forums');
			
		require 'admin/ad_'.$this->_code.'.php';
		
		$this->act = 'admin';
		
		//fetch admin_usage
		if(!isset($_SESSION['ad_usage']))
		{
			$query = $this->db->execQuery($this->db->sql_build('fetch_special_config', 'ad_usage'));
			$row = $this->db->fetch_array($query);
			if(!is_serialized($row['conf_value']))
				$_SESSION['ad_usage'] = array();
			else
				$_SESSION['ad_usage'] = unserialize($row['conf_value']);
		}
		else
			$this->increase_usage();
		
		$this->assign_all();
		if($this->_code == 'index')
			$this->skin->content = $this->skin->fetch('admincp/header.tpl');
		$this->display_admin_skin(true);
	
	}

	/**
    * Get index stats
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */	
	function get_stats()
	{
		//----------------------------------
		// Statistics
		//----------------------------------
				
		$guests=0;
		$users=0;
		
		$query = $this->db->execQuery($this->db->sql_build('fetch_sessions'));
		
		$count=0;
		$temp=array();
		while($temp2=$this->db->fetch_array($query))
		{
			if($temp2['level'] < 1)
			{
				if($temp2['spider_name']!='0')
				{
					$temp2['user_id'] = 0;
					$temp2['username']= $temp2['spider_name'];
					$temp[] = $temp2;
				}
				$guests=$temp2['guests'];
			}
			else
			{
				$temp[] = $temp2;
				$users ++; 
			}
		
		}
		
		
		$this->skin->assign('online_users', $temp);
		$this->skin->assign('online_guests', $guests);
		$this->skin->assign('online_users2', $users);
	
	}
	
	/**
    * Increase usage
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */	
	function increase_usage()
	{
		if(!isset($_SESSION['ad_usage_num']))
			$_SESSION['ad_usage_num'] = 1;
		else
			$_SESSION['ad_usage_num']++;
			
		if(!isset($_SESSION['ad_usage'][$_GET['code']]))
			$_SESSION['ad_usage'][$_GET['code']] = 0;
		else
			$_SESSION['ad_usage'][$_GET['code']]++;
			
		if($_SESSION['ad_usage_num']%8 == 0)
			$this->db->execQuery($this->db->sql_build('update_config', array(serialize($_SESSION['ad_usage']), 'ad_usage')));
	
	}



}

?>