<?php
define( 'IN_REVOKE',1 );
require '../class_stats.php';

$stats = new stats_handler($a,$b);

$stats->cake_posts();

function imageSmoothArc( &$img, $cx, $cy, $w, $h, $color, $start, $stop) {
    // Written from scratch by Ulrich Mierendorff, 06/2006
    $fillColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 0 );
    $w /= 2;
    $h /= 2;
    $cdx = $w * cos(M_PI/4);
    $cdy = $h * sin(M_PI/4);
    
    $xStart = $w * cos($start);
    $yStart = $h * sin($start);
    $xStop = $w * cos(min(M_PI,$stop));
    $yStop = $h * sin(min(M_PI,$stop));
    if ( $start < M_PI/2 ) {
        $yy = 0;
        for ( $x = 0; $x <= $xStart; $x += 1 ) {
            if ( $x < $xStop ) {
                $y1 = $x/$xStop*$yStop;
            } else {
                $y1 = $h * sqrt( 1 - pow( $x,2 ) / pow( $w,2 ) );
            }
            $y2 = $x/$xStart*$yStart;
            $d1 = $y1 - floor($y1);
            $d2 = $y2 - floor($y2);
            $y1 = floor($y1);
            $y2 = floor($y2);
            imageLine($img, $cx + $x, $cy - $y1, $cx + $x, $cy - $y2, $fillColor);
            $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d1*100 );
            imageSetPixel($img, $cx + $x, $cy - $y1 - 1, $diffColor);
            $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d2*100 );
            imageSetPixel($img, $cx + $x, $cy - $y2 + 1, $diffColor);
            for ( $yy; $yy <= $y1; $yy += 1 ) {
                if ( $yy < $yStart ) {
                    $x1 = $yy/$yStart*$xStart;
                } else {
                    $x1 = $w * sqrt( 1 - pow( $yy,2 ) / pow( $h,2 ) );
                }
                $d1 = $x1 - floor($x1);
                $x1 = floor($x1);
                $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d1*100 );
                imageSetPixel($img, $cx + $x1 + 1, $cy - $yy, $diffColor);
                if ($stop < M_PI/2) {
                    $x2 = $yy/$yStop*$xStop;
                    $d2 = $x2 - floor($x2);
                    $x2 = floor($x2);
                    $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d2*100 );
                    imageSetPixel($img, $cx + $x2, $cy - $yy, $diffColor);
                }
            }
        }
    }
    if ( $start < M_PI && $stop > M_PI/2 ) {
        $yy = 0;
        for ( $x = 0; $x >= $xStop; $x -= 1 ) {
            if ( $x > $xStart ) {
                $y1 = $x/$xStart*$yStart;
            } else {
                $y1 = $h * sqrt( 1 - pow( $x,2 ) / pow( $w,2 ) );
            }
            $y2 = $x/$xStop*$yStop;
            $d1 = $y1 - floor($y1);
            $d2 = $y2 - floor($y2);
            $y1 = floor($y1);
            $y2 = floor($y2);
            imageLine($img, $cx + $x, $cy - $y1, $cx + $x, $cy - $y2, $fillColor);
            $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d1*100 );
            imageSetPixel($img, $cx + $x, $cy - $y1 - 1, $diffColor);
            $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d2*100 );
            imageSetPixel($img, $cx + $x, $cy - $y2 + 1, $diffColor);
            for ( $yy; $yy <= $y1; $yy += 1 ) {
                if ( $yy < $yStop ) {
                    $x1 = -$yy/$yStop*$xStop;
                } else {
                    $x1 = $w * sqrt( 1 - pow( $yy,2 ) / pow( $h,2 ) );
                }
                $d1 = $x1 - floor($x1);
                $x1 = floor($x1);
                $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d1*100 );
                imageSetPixel($img, $cx - $x1 - 1, $cy - $yy, $diffColor);
                if ( $start > M_PI/2 ) {
                    $x2 = $yy/$yStart*$xStart;
                    $d2 = $x2 - floor($x2);
                    $x2 = floor($x2);
                    $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d2*100 );
                    imageSetPixel($img, $cx + $x2, $cy - $yy, $diffColor);
                }
            }
        }
    }
    
    $xStart = $w * cos(max(M_PI,$start));
    $yStart = $h * sin(max(M_PI,$start));
    $xStop = $w * cos($stop);
    $yStop = $h * sin($stop);
    if ( $start < 3*M_PI/2 && $stop > M_PI) {
        $yy = 0;
        for ( $x = 0; $x >= $xStart; $x -= 1 ) {
            if ( $x > $xStop) {
                $y1 = $x/$xStop*$yStop;
            } else {
                $y1 = -$h * sqrt( 1 - pow( $x,2 ) / pow( $w,2 ) );
            }
            $y2 = $x/$xStart*$yStart;
            $d1 = $y1 - floor($y1);
            $d2 = $y2 - floor($y2);
            $y1 = floor($y1);
            $y2 = floor($y2);
            imageLine($img, $cx + $x, $cy - $y1, $cx + $x, $cy - $y2, $fillColor);
            $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d1*100 );
            imageSetPixel($img, $cx + $x, $cy - $y1 + 1, $diffColor);
            $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d2*100 );
            imageSetPixel($img, $cx + $x, $cy - $y2 - 1, $diffColor);
            for ( $yy; $yy >= $y1; $yy -= 1 ) {
                if ( $yy > $yStart ) {
                    $x1 = -$yy/$yStart*$xStart;
                } else {
                    $x1 = $w * sqrt( 1 - pow( $yy,2 ) / pow( $h,2 ) );
                }
                $d1 = $x1 - floor($x1);
                $x1 = floor($x1);
                $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d1*100 );
                imageSetPixel($img, $cx - $x1 - 1, $cy - $yy, $diffColor);
                if ($stop < 3*M_PI/2) {
                    $x2 = $yy/$yStop*$xStop;
                    $d2 = $x2 - floor($x2);
                    $x2 = floor($x2);
                    $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d2*100 );
                    imageSetPixel($img, $cx + $x2 + 1, $cy - $yy, $diffColor);
                }
            }
        }
        
    }
    if ( $start < 2*M_PI && $stop > 3*M_PI/2 ) {
        $yy = 0;
        for ( $x = 0; $x <= $xStop; $x += 1 ) {
            if ( $x < $xStart )  {
                $y1 = $x/$xStart*$yStart;
            } else {
                $y1 = -$h * sqrt( 1 - pow( $x,2 ) / pow( $w,2 ) );
            }
            $y2 = $x/$xStop*$yStop;
            $d1 = $y1 - floor($y1);
            $d2 = $y2 - floor($y2);
            $y1 = floor($y1);
            $y2 = floor($y2);
            imageLine($img, $cx + $x, $cy - $y1, $cx + $x, $cy - $y2, $fillColor);
            $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d1*100 );
            imageSetPixel($img, $cx + $x, $cy - $y1 + 1, $diffColor);
            $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d2*100 );
            imageSetPixel($img, $cx + $x, $cy - $y2 - 1, $diffColor);
            for ( $yy; $yy >= $y1; $yy -= 1 ) {
                if ( $yy > $yStop ) {
                    $x1 = $yy/$yStop*$xStop;
                } else {
                    $x1 = $w * sqrt( 1 - pow( $yy,2 ) / pow( $h,2 ) );
                }
                $d1 = $x1 - floor($x1);
                $x1 = floor($x1);
                $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d1*100 );
                imageSetPixel($img, $cx + $x1 + 1, $cy - $yy, $diffColor);
                if ( $start > 3*M_PI/2 ) {
                    $x2 = $yy/$yStart*$xStart;
                    $d2 = $x2 - floor($x2);
                    $x2 = floor($x2);
                    $diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d2*100 );
                    imageSetPixel($img, $cx + $x2 , $cy - $yy, $diffColor);
                }
            }
        }
    }
}

?>