<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/
if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}

/**
* Module
*
* Show the index of the forum
*
* @author denadai2 <denadai2@gmail.com>
* @company RevokeSoft <denadai2@gmail.com>
* @package RevokeBB
*/
class Module extends rev_classes
{

	/**
    * Constructor of the module
    *
    * @param array $config
    * @param String $act
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */	
	function Module(& $config, $act)
	{
		require 'inc/class_forum.php';
		$this->rev_classes($config, $act);
	}

	/**
    * Execute the module
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */	
	function execute()
	{
		switch($this->_code)
		{
			default:
					$this->skin->cache = true;
					//$this->lang->load('index');
					if(!$this->skin->is_cached('main.tpl', $this->lang->lang.$this->act.$this->user->info_user['level']))
					{
						// Non c' un file di cache disponibile, assegnamo le variabili qui.
						$forum = new Forum($this->db, $this->skin, $this->error, $this->_config, $this->lang, $this->user, $this->cache);
						$forum->show_index_forums();
					}
					$this->get_stats();
					break;
		}
		$this->assign_all();
		$this->display_skin();
	
	}

	/**
    * Get index stats
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */	
	function get_stats()
	{
		//----------------------------------
		// Statistics
		//----------------------------------
				
		$guests=0;
		$users=0;
		
		$query = $this->db->execQuery($this->db->sql_build('fetch_sessions'));
		
		$count=0;
		$temp=array();
		while($temp2=$this->db->fetch_array($query))
		{
			if($temp2['level'] < 1)
			{
				if($temp2['spider_name']!='0')
				{
					$temp2['user_id'] = 0;
					$temp2['username']= $temp2['spider_name'];
					$temp[] = $temp2;
				}
				$guests=$temp2['guests'];
			}
			else
			{
				$temp[] = $temp2;
				$users ++; 
			}
		
		}
		
		
		$this->skin->assign('online_users', $temp);
		$this->skin->assign('online_guests', $guests);
		$this->skin->assign('online_users2', $users);
	
	}




}

?>