<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/
if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}

/**
* Module
*
* Show the index of the forum
*
* @author denadai2 <denadai2@gmail.com>
* @company RevokeSoft <denadai2@gmail.com>
* @package RevokeBB
*/
class Module extends rev_classes
{

	/**
    * Captcha class
    * @access Private
    * @var class
    */
	var $captcha;
	
	/**
    * Constructor of the module
    *
    * @param array $config
    * @param String $act
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */	
	function Module(& $config, $act)
	{
		require 'inc/class_gd_ver.php';	
		$this->rev_classes($config, $act);
		$this->captcha = new gd_handler();
	}

	/**
    * Execute the module
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */	
	function execute()
	{
		switch($this->_code)
		{
			default:

				if(isset($_POST['nickname']))
				{
					$this->var_filtrer->add($_POST);
	
					$username=$this->var_filtrer->String('nickname');
					$email=$this->var_filtrer->String('email');
					$email2=$this->var_filtrer->String('email2');
					$website=$this->var_filtrer->String('website');
					$password=$this->var_filtrer->String('password');
					$password2=$this->var_filtrer->String('password2');
					
					if($username=='')
						$this->error->simple_error('spec_username');
					else
						if($email=='' || $email!=$email2 || eregi("^[a-zA-Z0-9_]+@[a-zA-Z0-9\-]+\.[a-zA-Z0-9\-\.]+$]", $email) )
							$this->error->simple_error('not_valid_email');
						else
							if($password=='' || $password!=$password2)
								$this->error->simple_error('check_password');
					
					if(!$this->captcha->verify_string($_POST['captcha']))
						$this->error->simple_error('no_captcha');
					
					
					if($this->user->username_exists($username))
						$this->error->simple_error('user_exists');
					
					
					$member = array($username, md5($password.'revoke4gurus'), $email, 'noavatar.gif', '', 1, 0, time() );
					
					
					$this->user->new_user($member, $error_string);
					
					
					$this->error->complete('index.php', $this->lang->lang_all['register']['main']['lang_done']);
				
				}
				break;
		}
		$this->assign_all();
		$this->display_skin();
	
	}


}

?>