<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/
if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}

/**
* Module
*
* Show the index of the forum
*
* @author denadai2 <denadai2@gmail.com>
* @company RevokeSoft <denadai2@gmail.com>
* @package RevokeBB
*/
class Module extends rev_classes
{

	/**
    * Forum class
    * @access Private
    * @var class
    */
	var $forum;

	/**
    * Constructor of the module
    *
    * @param array $config
    * @param String $act
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */	
	function Module(& $config, $act)
	{
		require 'inc/class_forum.php';
		$this->rev_classes($config, $act);
	}

	/**
    * Execute the module
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */	
	function execute()
	{
		
		switch($this->_code)
		{
			default:
				$this->var_filtrer->add($_GET);
				if(!isset($_GET['start']))
					$start = 0;
				else
					$start = $this->var_filtrer->Integer('start');
				
				//----------------------------------
				// Fetch forum infos
				//----------------------------------
				
				$fid=$this->var_filtrer->Integer('showforum');
				
				$query = $this->db->execQuery($this->db->sql_build('fetch_forum_by_id', $fid));
				if($this->db->num_rows($query)==0)
					$this->error->simple_error('no_forum');
					
				$this->forum = $this->db->fetch_array($query);
				
				if($this->forum['move_url']!='0')
				{
					$this->db->execQuery($this->db->sql_build('update_forum_redirect_hits', $fid));
					$this->error->complete($this->forum['move_url'], 'Reindirizzamento in corso...');
				}
				
				$this->get_nav($start);
				
				$forum = new Forum($this->db, $this->skin, $this->error, $this->_config, $this->lang, $this->user, $this->cache);
				
				if($this->forum['subforums'] > 0)
				{
					$forum->show_index_forums($this->forum['forum_id']);
				}
				
				$forum->show_forum($fid, $start);
				
					
				break;
		}
		$this->assign_all();
		$this->display_skin();
	
	}

	/**
    * Get index stats
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */	
	function get_nav($start)
	{
		//----------------------------------
		// Navigation
		//----------------------------------
		$query = $this->db->execQuery($this->db->sql_build('showforum_nav', array($this->forum['forum_id'], $this->user->info_user['level'])));
		$nav=$this->db->fetch_array($query);
		
		$nav['type'] = '<a href="index.php?showforum='.$nav['cat_id'].'" class="nav">'.$nav['cat_title'].'</a> =&gt;<a href="index.php?showforum='.$nav['forum_id'].'" class="nav">'.$nav['title'].'</a>';
		$this->skin->assign('nav', $nav);
		
		//can view, can read | can read, can start, can upload
		if(! ($nav['perm'][1] ) )
		{
			$query = $this->db->execQuery($this->db->sql_build('showforum_nav2', array($this->forum['forum_id'], $this->user->info_user['level'])));
			$nav=$this->db->fetch_array($query);
			
			$nav['type'] = '<a href="index.php?showforum='.$nav['forum_id'].'" class="nav">'.$nav['title'].'</a>';
			$this->skin->clear_assign('nav');
			$this->skin->assign('nav', $nav);
		
			if(! ($nav['perm'][1] ) )
				$this->error->login_error('no_perm');
		}
			
		//----------------------------------
		// View all the template
		//----------------------------------
		
		$this->skin->assign('forumid', $this->forum['forum_id']);
		$this->skin->assign('page', $this->skin->generate_pagination($this->_config['board_domain'].$this->_config['board_url'].'index.php?showforum='.$fid.'&start=', $num['tot'], 15, $start));
		$this->skin->assign('add_link', '');
	
	}
	


}


?>