<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/
if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}

/**
* Module
*
* Show the index of the forum
*
* @author denadai2 <denadai2@gmail.com>
* @company RevokeSoft <denadai2@gmail.com>
* @package RevokeBB
*/
class Module extends rev_classes
{

	/**
    * Thread id
    * @access Private
    * @var int
    */
	var $_tid;
	
	/**
    * Thread infos
    * @access Private
    * @var array()
    */
	var $thread;

	/**
    * newpost check
    * @access Private
    * @var class
    */
	var $_newpost;

	/**
    * mp check
    * @access Private
    * @var int
    */	
	var $popup;
	
	/**
    * Constructor of the module
    *
    * @param array $config
    * @param String $act
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */	
	function Module(& $config, $act)
	{
		$this->rev_classes($config, $act);
		//class uploads for type transformation
		require 'inc/class_uploads.php';
		$this->upload = new Upload($this->db, $this->error);
		
		require 'inc/class_parse.php';
		$this->parse = new Parse();
		
		if(isset($_GET['popup']))
			$this->popup = abs(intval($_GET['popup']));
		else
			$this->popup = -1;
		
	}

	/**
    * Execute the module
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */	
	function execute()
	{
		$this->var_filtrer->add($_GET);
		$this->_tid = $this->var_filtrer->Integer('showthread');
		
		$this->get_thread();
		
		switch($this->_code)
		{
			//pin a thread
			case '01': 
				if( !$this->check_mod_perms('pin_thread') )
					$this->error->simple_error('no_perm');
								
				$this->pin_thread(); 
				
				$this->error->complete('index.php?showthread='.$this->_tid, $this->lang->lang_all['showthread']['main']['pin_done']);
				break;
			//unpin a thread
			case '02':
				if( !$this->check_mod_perms('unpin_thread') )
					$this->error->simple_error('no_perm');
					
				$this->unpin_thread(); 
					
				$this->error->complete('index.php?showthread='.$this->_tid, $this->lang->lang_all['showthread']['main']['unpin_done']);
				break;
			//close a thread
			case '03':  
				if( !$this->check_mod_perms('close_thread') )
					$this->error->simple_error('no_perm');
					
				$this->close_thread(); 
					
				$this->error->complete('index.php?showthread='.$this->_tid, $this->lang->lang_all['showthread']['main']['closed_done']);	
				break;
			//download an attachment
			case '04':
				if( $this->user->info_user['level'] < 1 ) //if is not a guest
					$this->error->login_error('no_perm');
					
				$upload_id = $this->var_filtrer->Integer('upload');
				
				$query=$this->db->execQuery($this->db->sql_build('fetch_upload_by_upload_id', $upload_id));
				
				$temp=$this->db->fetch_array($query);
				
				if(!$this->user->has_visited($upload_id, 'upload')) 
					$this->db->execQuery($this->db->sql_build('update_upload_hits', $upload_id));
				
				header('Content-type: '.$temp['upload_type']);
				header('Content-Disposition: attachment; filename='.$temp['upload_name']);
				header('Content-Description: Download PHP');
				header('Content-Length: '.$temp['upload_size']);
				readfile('uploads/'.$temp['upload_file']);
				exit;
				break;
			//delete thread with confirm
			case '05':	
				if( !$this->check_mod_perms('delete_thread') )
					$this->error->simple_error('no_perm');
					
					
				if(!isset($_GET['confirm']))
				{
					$query = $this->db->execQuery($this->db->sql_build('fetch_thread_by_id', $this->_tid ));
					$temp = $this->db->fetch_array($query);
					$this->error->confirm($this->lang->lang_all['showthread']['main']['delete_confirm'].'<strong>'.$temp['title'].'</strong>?', 'index.php?showthread='.$this->_tid.'&code=05&confirm=1');
				}
				
				require 'inc/class_forum.php';
				
				$query=$this->db->execQuery($this->db->sql_build('fetch_fid_by_tid', $this->_tid));
				$temp=$this->db->fetch_array($query);
				
				$this->delete_thread(); 
				
				$forum= new Forum($this->db, $this->skin, $this->error, $this->_config, $this->lang, $this->user, $this->cache);
				
				$forum->sync_forum($temp['forumid']);
				
				$this->error->complete('index.php?showforum='.$temp['forumid'], $this->lang->lang_all['showthread']['main']['delete_post_done']);
				break;
			//move a thread
			case '06':
				if( !$this->check_mod_perms('move_thread') )
					$this->error->simple_error('no_perm');
					
				if(!isset($_GET['last']))
				{
					$query = $this->db->execQuery($this->db->sql_build('showthread_nav', array($this->_tid, $this->user->info_user['level'])));
					$nav=$this->db->fetch_array($query);
	
					//can view, can read | can read, can start, can upload

					/*if(! ($nav['perm'][2] ) )
						$this->error->login_error('no_perm'); */
	
					$this->skin->assign('nav', $nav);
					
					$query = $this->db->execQuery($this->db->sql_build('fetch_forum_list_move', $this->user->info_user['user_id'] ));
					
					while($vett=$this->db->fetch_array($query))
					{
						if( (!$vett['perm'][0]) && $this->user->info_user['admincp']!=1)
							continue;
							
						$menu[$vett['forum_id']] = $vett['title'];
					}
					
					$html = '<tr>
		 <td class="board-statistics-bg" style="width:10%;"><div align="center">Forum di destinazione: </div></td>
		 <td class="board-statistics-bg" style="width:10%;">'.menu_create('destforum', $menu, 0, 0).'</td>
		 </tr>';
		 
					$formaction = 'index.php?showthread='.$this->_tid.'&amp;code=06&amp;last=1';
					
					$this->error->confirm2($html, $formaction);
					
				}
				else
				{
					$destforum=intval($_POST['destforum']);
					
					require 'inc/class_forum.php';
					
					$query=$this->db->execQuery($this->db->sql_build('fetch_fid_by_tid', $this->_tid));
					
					$temp=$this->db->fetch_array($query);
					
					$this->move_thread($destforum); 
					
					$forum= new Forum($this->db, $this->skin, $this->error, $this->_config, $this->lang, $this->user, $this->cache);
					
					$forum->sync_forum($temp['forumid']);
					
					$forum->sync_forum($destforum);
					
					$this->error->complete('index.php?showforum='.$destforum, $this->lang->lang_all['showthread']['main']['move_done']);
				}
				break;
			//vote a poll	
			case '07':  
				$this->var_filtrer->add($_POST);
				$voted_choice = $this->var_filtrer->String('poll_vote');
				
				//permission control
				$query = $this->db->execQuery($this->db->sql_build('showthread_nav', array($this->_tid, $this->user->info_user['level'])));
				$nav=$this->db->fetch_array($query);
				
				if(! ($nav['perm'][3] ) )
					$this->error->login_error('no_perm');
				
				$query = $this->db->execQuery($this->db->sql_build('fetch_poll_by_tid', $this->_tid));
				
				if($this->db->num_rows($query) != 1)
					$this->error->simple_error('no_poll');
				else
					$vett = $this->db->fetch_array($query);
					
				$temp = unserialize($vett['questions']);
				
				
				$search = false;
				$count = count($temp);
				
				
				for($i=0; $i<$count; $i++)
				{
					if(@strstr($temp[$i][0], $_POST['poll_vote']))
					{
						$search = $i;
						break;
					}
				}
				//$search = array_search($voted_choice,$temp);
				
				if($search == false)
					$this->error->simple_error('err_poll');
					
				//total posts
				$temp[0][1]++;
				$temp[$i][1]++;
				
				$query = $this->db->execQuery($this->db->sql_build('update_poll_by_tid', array(serialize($temp), $vett['pid']) ));
				
				$query = $this->db->execQuery($this->db->sql_build('insert_voter', array( ip2long($_SERVER['REMOTE_ADDR']), time(), $this->_tid, $this->user->info_user['user_id'] )));
				
				$this->error->complete('index.php?showthread='.$this->_tid, $this->lang->lang_all['showthread']['main']['vote_done']);
				
				break;
			//delete a post	
			case '08':
				
				if( !$this->check_mod_perms('delete_post') )
					$this->error->simple_error('no_perm');
	
				$pid = $this->var_filtrer->Integer('post_id');
				
				$return = $this->delete_post($pid);
				
				require 'inc/class_forum.php';
				
				$query=$this->db->execQuery($this->db->sql_build('fetch_fid_by_tid', $this->_tid));
				
				$temp=$this->db->fetch_array($query);
				
				$forum = new Forum($this->db, $this->skin, $this->error, $this->_config, $this->lang, $this->user, $this->cache);
				
				$forum->sync_forum($temp['forumid']);
				
				if($return==0)
					$this->error->complete('index.php?showthread='.$this->_tid, $this->lang->lang_all['showthread']['main']['delete_post_done']);
				else
					$this->error->complete('index.php?showforum='.$this->thread['forumid'], $this->lang->lang_all['showthread']['main']['delete_post_done']);
				break;
			//open a thread
			case '09':
				if( !$this->check_mod_perms('open_thread') )
						$this->error->simple_error('no_perm');
						
					$this->close_thread(0); 
						
					$this->error->complete('index.php?showthread='.$this->_tid, $this->lang->lang_all['showthread']['main']['open_done']);	
					break;
				break;
			//newpost
			case '10':
				if(!isset($_POST['topicid']))
				{
					$this->get_nav(1);
					
					if(isset($_GET['quote']))
						$init_text = $this->quote_mode_on($this->var_filtrer->Integer('quote'));
					else
						$init_text='0';
						
					
						
					//fetch subscription if it is
					$query2 = $this->db->execQuery($this->db->sql_build('fetch_sub_thread_by_id', array($this->user->info_user['user_id'], $this->_tid) ) );
					
					$this->_newpost['type'] = 'newpost';
					$this->_newpost['forumid'] = 0;
					$this->_newpost['thread_id'] = $this->_tid;
					$this->_newpost['text'] = $init_text;
					$this->_newpost['sub'] = $this->db->num_rows($query2);
					$this->_newpost['title'] = $this->lang->lang_all['newpost']['main']['title'];
					
					if(isset($_GET['edit']))
					{
						$post_id = $this->var_filtrer->Integer('edit');
						$this->_newpost['formaction'] = 'index.php?showthread='.$this->_tid.'&amp;code=10&amp;edit='.$post_id;
						$this->_newpost['edit'] = 1;
						$query = $this->db->execQuery($this->db->sql_build('fetch_post_by_id', $post_id ));
						$vett = $this->db->fetch_array($query);
						
						if(!$this->check_mod_perms('edit_post')) 
							if( (time()-$this->_config['edit_time']) > $vett['dateline'])
								$this->error->simple_error('no_edit_time');
						
					}
					else
					{
						$this->_newpost['formaction'] = 'index.php?showthread='.$this->_tid.'&amp;code=10';
						$this->_newpost['edit'] = 0;
					}
					
					
					$this->skin->assign('newpost', $this->_newpost);
					
					$this->get_thread();
					$this->fetch_posts_by_tid(0, 1);
					$this->act = 'newpost';
					
				
				}
				else
				{
					if(!strstr($_SERVER['HTTP_REFERER'],$this->_config['board_domain']))
						$this->error->simple_error('no_perm');
				
					$this->var_filtrer->add($_POST);
					
					$this->_tid = $this->var_filtrer->Integer('topicid');
					$text = $this->var_filtrer->String('replybox');
					$title = $this->var_filtrer->String('title',0);
					$options = $this->var_filtrer->String('options');
					$subscribe = $this->var_filtrer->Integer('subscribe');
					$username = $this->var_filtrer->String('username',0);
					
					//---------------------------------
					// Perm control
					//---------------------------------
					$query = $this->db->execQuery($this->db->sql_build('showthread_nav', array($this->_tid, $this->user->info_user['level'])));
					$nav=$this->db->fetch_array($query);
					
					//can view, can read | can read, can start, can upload
					if(! ($nav['perm'][3] ) )
							$this->error->login_error('no_perm');
					
					$this->get_thread();		
					//--------------------------------
					// Check if the thread is moved or closed
					//--------------------------------	
					if( $this->thread['closed'] == 1 || $this->thread['move_url'] != 0 )
						$this->error->simple_error('closed_thread');
						
					//--------------------------------
					// Anti-flood control
					//--------------------------------
					if($this->user->info_user['user_id'] > 0 && !isset($_GET['edit']))
					{
						$query = $this->db->execQuery($this->db->sql_build('fetch_last_user_post_dateline', $this->user->info_user['user_id'] ));
						if($this->db->num_rows($query) > 0)
						{
							$temp_vett = $this->db->fetch_array($query);
							
							if(time() -30 < $temp_vett['dateline'] )
									$this->error->simple_error('antiflood');
						}
					}
					
					if(isset($_GET['edit']))
					{
						$post_id = abs(intval($_GET['edit']));
						
						$query = $this->db->execQuery($this->db->sql_build('fetch_post_by_id', $post_id ));
						$vett=$this->db->fetch_array($query);
						
						if(isset($_POST['poll_title']))
						{
							$keys = array_keys($_POST);
										
							$count = count($keys);
							$j=1;
							
							for($i=0; $i<$count;$i++)
								if(strstr($keys[$i], 'poll_val_') && $keys[$i] != 'poll_title')
									$temp_poll[$j++][1] = $_POST[$keys[$i]];
								elseif(strstr($keys[$i], 'poll_') && $keys[$i] != 'poll_title')
									$temp_poll[$j][0] = $_POST[$keys[$i]];	
				
							$j=1;
							for($i=0; $i<$count;$i++)
								if(strstr($keys[$i], 'poll_') && $keys[$i] != 'poll_title')
								{
								$temp_pollb[$j][0] = $_POST[$keys[$i]];
								$temp_pollb[$j++][1] = 0;
								}
					
							$temp_poll[0][0] = $_POST['poll_title'];
							$temp_poll[0][1] = 0;
							
							$temp_pollb[0][0] = $_POST['poll_title'];
							$temp_pollb[0][1] = 0;
					
							
							if($_POST['pid'])
								$query = $this->db->execQuery($this->db->sql_build('update_poll_by_pid', array(serialize($temp_poll), $_POST['pid'] ) ));
							else
							{
								$query = $this->db->execQuery($this->db->sql_build('insert_poll_by_tid', array($this->_tid, serialize($temp_pollb) ) ));
							
								$poll_id = $this->db->insert_id();
								
								$query = $this->db->execQuery($this->db->sql_build('update_pollid_by_tid', array($poll_id, $this->_tid ) ));
							}
							
						}
						elseif(isset($_POST['pid']))
						{
							$query = $this->db->execQuery($this->db->sql_build('delete_poll_by_pid', $_POST['pid'] ));
							$query = $this->db->execQuery($this->db->sql_build('update_pollid_by_tid', array('0', $this->_tid ) ));
						}
						
						
						if(!$this->check_mod_perms('edit_post')) 
						{ 
							if( (time()-$this->_config['edit_time']) > $vett['dateline'])
								$this->error->simple_error('no_edit_time');
							
							
							if($vett['user_id'] != $this->user->info_user['user_id'])
								$this->error->simple_error('no_edit_your');
						}
						
						$this->edit_post($post_id, $text);
					
					}
					else
					{
						if(strlen($text)<5)
							$this->error->simple_error('text_len');
						
						if($this->user->info_user['level'] < 1)
						{
							if(strlen($username)<2)
								$this->error->simple_error('spec_username');
							else
								if($this->user->username_exists($username))
									$this->error->simple_error('username_user');
								else
									$this->user->info_user['username'] = $username;
						}
						else
							$this->user->info_user['username'] = '0';
				
						//--------------------------------
						// Upload file
						//--------------------------------			
						if(strlen($_FILES['upload']['name'])>5)
						{
							//can view, can read | can read, can start, can upload
							if(! ($nav['perm'][4] ) )
								$this->error->login_error('upload_perm');
								
							$upid = $this->upload->process();
						}
						else
							$upid = 1;	
						
						$return_post = $this->new_post($title, $text, $this->user->info_user, 1, 0, $upid);	
					}
					if($this->user->info_user['level'] <= 5)
						$options='none';
					
					switch($options)
					{
						case 'pin': if($this->check_mod_perms('pin_thread')) $this->pin_thread(); break;
						case 'close': if($this->check_mod_perms('close_thread')) $this->close_thread(); break;
						case 'closepin': if($this->check_mod_perms('pin_thread') && $this->check_mod_perms('close_thread')) 
						$this->pin_thread(); $this->close_thread(); break;
					}
					
					if( $subscribe == 1 )
						$this->thread_subscribe($this->_tid);
						
					if($upid != 1)
						$this->db->execQuery($this->db->sql_build('fetch_post_text_pid', array($upid, $return_post) ));
	
					//---------------------------------
					// Go at posted post (lol)
					//---------------------------------
					$this->error->complete('index.php?showthread='.$this->_tid.'&view=lastposts#post-'.$return_post, $this->lang->lang_all['newpost']['main']['new_post'].$options);
					}

				break;	
			//newthread
			case '11':
				if(!isset($_POST['forumid']))
				{ 
					
					if(isset($_GET['mp']))
					{
						$query2 = $this->db->execQuery($this->db->sql_build('fetch_rand_forum' ) );
						$temp = $this->db->fetch_array($query2);
						$this->_tid = $temp['forum_id'];
						$this->_newpost['mp'] = 1;
						$dest_user = $this->user->get_infos($uid);

						if($dest_user['user_mp']==100)
							$this->error->simple_error('no_mp_space');
							
						if(! $this->user->user_exists($this->_tid) )
							$this->error->simple_error('no_profile');
							
						$this->get_nav(3);
					}
					else
					{
						$this->_newpost['mp'] = 0;
						$this->get_nav(2); 
					}
						
					//fetch subscription if it is
					$query2 = $this->db->execQuery($this->db->sql_build('fetch_sub_thread_by_id', array($this->user->info_user['user_id'], $this->_tid) ) );
					
					$this->_newpost['type'] = 'newthread';
					$this->_newpost['forumid'] = $this->_tid;
					$this->_newpost['thread_id'] = 0;
					$this->_newpost['text'] = 0;
					$this->_newpost['title'] = $this->lang->lang_all['newthread']['main']['title'];
					$this->_newpost['formaction'] = 'index.php?showthread='.$this->_tid.'&amp;code=11';
					$this->_newpost['edit'] = 0;
					$this->_newpost['sub'] = 0;
					
					
					$this->skin->assign('newpost', $this->_newpost);

					$this->act = 'newpost';
					
				}
				else
				{
					/*if(!strstr($_SERVER['HTTP_REFERER'],$this->_config['board_domain']))
						$this->error->simple_error('no_perm');*/
					
					$this->var_filtrer->add($_POST);
					$forumid=$this->var_filtrer->Integer('forumid');
					$text = $this->var_filtrer->String('replybox');
					$title=trim($this->var_filtrer->String('title', 0));
					$options=$this->var_filtrer->String('options');
					$subscribe=$this->var_filtrer->Integer('subscribe');
					$username = $this->var_filtrer->String('username',0);
					$mp = $this->var_filtrer->String('mp');
					
					if(strlen($title)<3)
						$this->error->simple_error('title_len');
						
					if(strlen($text)<5)
						$this->error->simple_error('text_len');
					
					if($this->user->info_user['level'] < 1)
					{
						if(strlen($username)<2)
							$this->error->simple_error('spec_username');
						else
							if($this->user->username_exists($username))
								$this->error->simple_error('username_user');
							else
								$this->user->info_user['username'] = $username;
					}
					else
						$this->user->info_user['username'] = '0';
					//--------------------------------
					// Upload file
					//--------------------------------			
					if(strlen($mp)<3 && strlen($_FILES['upload']['name'])>5)
						$upid = $this->upload->process();
					else
						$upid = 1;
						
						//if is an mp
						if(strlen($mp)>3)
						{
							//Guests can't use mp
							if($this->user->info_user['user_id'] == -1)
								$this->error->simple_error('no_perm');
								
							$postid=$this->new_post($title, $text, $this->user->info_user, 0, 1, 1);
							$array = explode(';',$mp,5);
							$num=count($array);
							for($i=0;$i<$num;$i++)
							{
								$tmp2 = $this->user->username2id($array[$i]);
								if($tmp2!=-1)
									$this->db->execQuery($this->db->sql_build('insert_mp_post_links', array($tmp2, $postid) ));
							}
							
						}
						else
							$return_thread = $this->new_thread($title, $text, 0, $forumid, $this->user->info_user, 0, $upid);

						
						if(strlen($mp)<3)
						{
							//--------------------------------
							// Insert poll into a thread
							//--------------------------------	
							if(isset($_POST['poll_title']))
							{
								$this->insert_poll($return_thread);
							}
							
							
							if( $this->user->info_user['level'] <= 5)
								$options='none';
							
							switch($options)
							{
								case 'pin': if($this->check_mod_perms('pin_thread')) $this->pin_thread(); break;
								case 'close': if($this->check_mod_perms('close_thread')) $this->close_thread(); break;
								case 'closepin': if($this->check_mod_perms('pin_thread') && $this->check_mod_perms('close_thread')) 
								$this->pin_thread(); $this->close_thread(); break;
							}
							
							if( $subscribe == 1 )
								$this->thread_subscribe( $this->_tid );
								
							if($upid != 1)
							{
								$this->db->execQuery($this->db->sql_build('fetch_post_text_pid', array($upid, $return_thread['post_id']) ));
							}
							$this->error->complete('index.php?showthread='.$return_thread['thread_id'], $this->lang->lang_all['newthread']['main']['lang_done']);
							
						}
						else
						{
							$query = $this->db->execQuery($this->db->sql_build('update_user_mp', array($postid, $this->user->info_user['user_id'])));
							$this->error->complete('index.php?usercp', $this->lang->lang_all['newmp']['main']['lang_done']);
							
						
						}
						
									
								
				}
				
				
				break;
			//edit post ajax save	
			case '12' : 
				if($this->check_mod_perms('edit_post'))
				{
					$post_id=$this->var_filtrer->Integer('pid'); 
					$this->var_filtrer->add($_POST);
					$this->edit_post($post_id, $this->var_filtrer->String('value'));
					echo $this->parse->parse_bbcode($this->fetch_post_text($post_id)); 
				}
				else
					echo 'You don\'t have the right to do this';
				exit;
				break;
			//edit post ajax	
			case '13' : 
				if($this->check_mod_perms('edit_post'))
				{
					$post_id=$this->var_filtrer->Integer('pid'); 
					$this->var_filtrer->add($_POST);
					echo $this->parse->parse_bbcode_simple($this->fetch_post_text($post_id)); 
				}
				else
					echo 'You don\'t have the right to do this';
				exit;
				break;
			
			
			
		
			default:
				
				if(!isset($_GET['start']))
					$start = 0;
				else
					$start = $this->var_filtrer->Integer('start');
					
				
				//cambiare! lol
				$this->skin->cache = false;	
				
				if(!$this->skin->is_cached('main.tpl', $act.$tid.$start.$this->user->info_user['level'])) 
				{
					
				
					$this->get_nav();
					
					$this->get_thread_infos();
					
					if($this->thread['thread_id'] == 1)
					{
						$this->thread['extra_perm2'] = 1;
						
						$query = $this->db->execQuery($this->db->sql_build('fetch_mp_post_links',$this->user->info_user['user_id'] ));
						
						if($this->db->num_rows($query) == 0)
							$this->error->simple_error('no_mp');
							
						$mp_link = $this->db->fetch_array($query);
						
						if($mp_link['view'] == 0)
						{
									
							$this->db->execQuery($this->db->sql_build('update_mp_state', $mp_link['id'] ));
							
						}
						$this->skin->assign('modmenu', '');
					}	
					else
					{
						$this->thread['extra_perm2'] = 0;
						//build the modcp menu
						if($_SESSION['mod_perms'.$this->thread['forumid']] != 0)
						{
							$temp = array();
							$i = 0;
							
							if($_SESSION['mod_perms'.$this->thread['forumid']]['pin_thread'] == 1  && $this->thread['sticky']==0)
							{
								$temp[$i]['code'] = '01';
								$temp[$i++]['text'] = 'Rileva Thread';
							}
							else
								if($_SESSION['mod_perms'.$this->thread['forumid']]['unpin_thread'] == 1  && $this->thread['sticky']==1)
								{
									$temp[$i]['code'] = '02';
									$temp[$i++]['text'] = 'Thread non in rilievo';
								}
							
							if($_SESSION['mod_perms'.$this->thread['forumid']]['close_thread'] == 1 && $this->thread['closed']==0)
							{
								$temp[$i]['code'] = '03';
								$temp[$i++]['text'] = 'Chiudi thread';
							}
							else
								if($_SESSION['mod_perms'.$this->thread['forumid']]['open_thread'] == 1 && $this->thread['closed']==1)
								{
									$temp[$i]['code'] = '09';
									$temp[$i++]['text'] = 'Apri thread';
								}
							
							if($_SESSION['mod_perms'.$this->thread['forumid']]['move_thread'] == 1)
							{
								$temp[$i]['code'] = '06';
								$temp[$i++]['text'] = 'Sposta thread';
							}
							
							if($_SESSION['mod_perms'.$this->thread['forumid']]['delete_thread'] == 1)
							{
								$temp[$i]['code'] = '05';
								$temp[$i++]['text'] = 'Elimina thread';
							}
							
							$num_temp = count($temp);
							$string = '';
							for($i=0;$i<$num_temp;$i++)
							{
								$string .= '<option value="'.$temp[$i]['code'].'" onclick="javascript:form.submit();">'.$temp[$i]['text'].'</option>';
							}
							
							$this->skin->assign('modmenu', $string);
							
							//delete unused variables
							unset($string);
							unset($temp);
						
						}
						else
							$this->skin->assign('modmenu', '');
					}
					
					
					$this->skin->assign('threadinfos', $this->thread);
					
					//set the flag of "visited" to 0 in subscribed thread
					$query=$this->db->execQuery($this->db->sql_build('update_thread_subscribe_sent', array($this->_tid, $this->user->info_user['user_id']) ));
					
					if(isset($_GET['view']))
					{
						$start = intval(($this->thread['reply'])/10)*10; //-1??
					}
					
					$this->fetch_posts_by_tid($start);
					
					$this->skin->assign('pages', $this->skin->generate_pagination($this->_config['board_domain'].$this->_config['board_url'].'index.php?showthread='.$this->_tid.'&start=', $this->thread['reply']+1, 10, $start));
					
					if(isset($_GET['popup']))
					{
						//set to saw the last mp
						$this->db->execQuery($this->db->sql_build('update_user_newmp', $this->user->info_user['user_id'] ));
						$this->assign_all();
						$this->skin->cache=false;
						$this->skin->content = $this->skin->fetch('showthread.tpl');
						$this->skin->display_all();
						exit;
					}
				}
					
				break;
				
		}
		$this->assign_all();
		$this->display_skin();
	
	}

	/**
    * Get index stats
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */	
	function get_nav($page=0)
	{
		//--------------------------------
		// Navigation
		//--------------------------------
		
		switch($page)
		{
			//showforum
			case 0:
				if($this->popup == -1)
				{
				$query = $this->db->execQuery($this->db->sql_build('showthread_nav', array($this->_tid, $this->user->info_user['level'])));
				$nav=$this->db->fetch_array($query);
				
				//can view, can read | can read, can start, can upload
				if(! ($nav['perm'][2] ) )
					$this->error->login_error('no_perm'); 
				}	
				break;
			//newpost
			case 1:
				$query = $this->db->execQuery($this->db->sql_build('showthread_nav', array($this->_tid, $this->user->info_user['level'])));
				$nav=$this->db->fetch_array($query);
	
				$nav['type'] = '<a href="#" class="nav">'.$this->lang->lang_all['newpost']['main']['title'].'</a>';
	
				//can view, can read | can read, can start, can upload
				if(! ($nav['perm'][3] ) )
					$this->error->login_error('no_perm');
				break;
			//newthread
			case 2:
				$query = $this->db->execQuery($this->db->sql_build('showforum_nav', array($this->_tid, $this->user->info_user['level'])));
				$nav=$this->db->fetch_array($query);
				
				$nav['type'] = '<a href="#" class="nav">'.$this->lang->lang_all['newthread']['main']['title'].'</a>';
				$nav['forumid'] = $this->_tid;
				
				//can view, can read | can read, can start, can upload
				if(! ($nav['perm'][3] ) )
					$this->error->login_error('no_perm');
				break;
			//newmp
			case 3:
				
				
				$nav['type'] = '<a href="#" class="nav">'.$this->lang->lang_all['newmp']['main']['title'].'</a>';
				$nav['forumid'] = $this->_tid;
				
				
				if($this->user->info_user['user_id'] <0 )
					$this->error->login_error('no_perm');
				break;
		}
		
		$this->skin->assign('nav', $nav);
		
		//---------------------------------
		// Moderators perms
		//---------------------------------
		
		$this->thread['forumid'] = $nav['forumid'];
		if(!isset($_SESSION['mod_perms'.$nav['forumid']]))
		{
			if($this->user->info_user['admincp'] == 1)
			{
				$_SESSION['mod_perms'.$nav['forumid']] = array(
						'mod_id	'			=>		1,
						'forum_id'			=>		1,
						'edit_post'			=>		1,
						'delete_post'		=>		1,
						'edit_thread'		=>		1,
						'delete_thread'		=>		1,
						'open_thread'		=>		1,
						'close_thread'		=>		1,
						'move_thread'		=>		1,
						'pin_thread'		=>		1,
						'unpin_thread'		=>		1
						);
			
			}
			else
			{
				$query = $this->db->execQuery($this->db->sql_build('fetch_forum_mod_perms', array($nav['forumid'], $this->user->info_user['user_id'])));
				
				if($this->db->num_rows($query)==0)
					$_SESSION['mod_perms'.$nav['forumid']] = 0;
				else
					$_SESSION['mod_perms'.$nav['forumid']] = $this->db->fetch_array($query);	
			}
		
		}
		
		$this->skin->assign('mod_perms', $_SESSION['mod_perms'.$this->thread['forumid']]);
	
	}
	
	/**
	* check the mod perm
	*
	* @param String $perm
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return boolean
	*/			
	function check_mod_perms($perm)
	{
		
		if(!isset($_SESSION['mod_perms'.$this->thread['forumid']][$perm]))
		{
			$query = $this->db->execQuery($this->db->sql_build('fetch_forums_by_tid', $this->_tid ));
			
			if($this->db->num_rows($query)==0)
				return false;
			
			$temp = $this->db->fetch_array($query);
		}
		
		return ($_SESSION['mod_perms'.$this->thread['forumid']][$perm] == 1); 	
	
	}


	/**
	* fetch posts having topic id
	*
	* @param int $tid
	* @author denadai2 <denadai2@gmail.com>
	* @since v 0.1
	* @access Public
	* @return Void
	*/			
	function fetch_posts_by_tid($start, $last_10=0) //$last_10 need in newpost
	{
		if($this->popup != -1)
			$query = $this->db->execQuery($this->db->sql_build('fetch_post_mp', array($this->_tid, $this->user->info_user['user_id']) ));
		else
			if($last_10==0)
				$query = $this->db->execQuery($this->db->sql_build('fetch_posts_by_tid', array($this->_tid,$start))); 
			else
				$query = $this->db->execQuery($this->db->sql_build('fetch_posts_by_tid_last_10', $this->_tid)); 

				
		$conta=1;
		
		//set the levels array
		$this->_config['board_levels'] = unserialize($this->_config['board_levels']);
		
		$timenow = time();
		
		while($vett=$this->db->fetch_array($query))
		{
			if($vett['user_id'] != -1 && $vett['user_id'] == $this->user->info_user['user_id'] && 
			(($this->_config['edit_time']+$vett['dateline']) > $timenow))
			
				$vett['can_edit'] = '1';
			else
				$vett['can_edit'] = '0';
			 
			$vett['dateline']=gmdate('d F Y H:i',$vett['dateline']);
			
			$vett['title'] = stripslashes($vett['title']);
			$vett['numpost'] = $conta++;
			$vett['user_yahoo'] = stripslashes($vett['user_yahoo']);
			$vett['user_msn'] = stripslashes($vett['user_msn']);
			$vett['user_website'] = stripslashes($vett['user_website']);
			
			$vett['user_sign'] = $this->parse->parse_bbcode(stripslashes($vett['user_sign']));
			$vett['text'] = $this->parse->parse_bbcode(stripslashes($vett['text']));
			
			$vett['image'] = stripslashes($vett['image']);
			$vett['online'] = intval((($vett['lastaction']+(15*60)) > $timenow ));
			$vett['thread_id'] = $this->_tid;
			
			$lvs = $this->user->generate_levels($vett['posts'], $vett['user_id']);
			$vett['levels'] = $lvs['name'];
			$vett['levels_img'] = $lvs['img'];

		
			if($vett['upload']!='1')
			{
				
				$vett['upload_type'] = $this->upload->filetypes2icons($vett['upload_type']);
			}
			
			
			$all_vett[]=$vett;
		}
		
		$this->skin->assign('posts', $all_vett);
		
	}

	/**
	* Get the thread from the db
	* @param none
	* @author denadai2 <denadai2@gmail.com> 
	* since v 1.0
	* @access Public
	* @return none
	*/		
	function get_thread()
	{
		if(!isset($this->thread['thread_id']))
		{
			if($this->popup == -1)
				$query = $this->db->execQuery($this->db->sql_build('fetch_thread_by_id', $this->_tid));
			else
				$query = $this->db->execQuery($this->db->sql_build('fetch_thread_by_id', 1));
			$this->thread = $this->db->fetch_array($query);
		}
		
	}
	
	/**
	* Get the thread infos
	* @param int $time
	* @author denadai2 <denadai2@gmail.com> 
	* since v 1.0
	* @access Public
	* @return none
	*/		
	function get_thread_infos($time=0)
	{
		//----------------------------------
		// Fetch thread infos
		//----------------------------------
		$this->get_thread();
					
		//user has visited the thread?
		if(!$this->user->has_visited($this->_tid,'')) 
			$this->update_views($this->_tid);
			
		$this->thread['dateline'] = date("d/m/Y h:i:s",$this->thread['dateline']);
		
		if($this->thread['pollid']!=0)
			$this->get_poll_infos();
		
	}
	
	/**
	* Get the poll infos
	* @param none
	* @author denadai2 <denadai2@gmail.com> 
	* since v 1.0
	* @access Public
	* @return none
	*/	
	function get_poll_infos()
	{
		//--------------------------------
		// Poll informations
		//--------------------------------	
		$query = $this->db->execQuery($this->db->sql_build('fetch_poll_and_voters_by_tid', $this->_tid ));
		$vett = $this->db->fetch_array($query);
		
		$query2 = $this->db->execQuery($this->db->sql_build('fetch_voter_by_id', array($this->user->info_user['user_id'], $this->_tid) ));
		$voted = $this->db->num_rows($query2);
		
		
		$temp_exp = unserialize($vett['questions']);
		
		$tot = count($temp_exp);
		
		$poll_info['title'] = $temp_exp[0][0];
		$poll_info['tid'] = $this->_tid;
		$poll_info['voted'] = $voted;
		
		for($i=1;$i<$tot;$i++)
		{
			
			$opt[$i-1]['title'] = $temp_exp[$i][0];
			$opt[$i-1]['votes'] = $temp_exp[$i][1];
			$score = ($temp_exp[0][1] == 0) ? 0 : intval((100*$temp_exp[$i][1])/$temp_exp[0][1]);
			$opt[$i-1]['score'] =  $score*2;
			$opt[$i-1]['perc'] = $score;
		
		}
		
		$this->skin->assign('poll_info', $poll_info);
		$this->skin->assign('poll_opt', $opt);
	
		
	}
	
	/**
	* Check if a 3d is visited
	* @param int tid
	* @author dierre <dierre@gmail.com> 
	* since v 1.0
	* @access Public
	* @return none
	*/	
	function update_views($tid)
	{
		$query = $this->db->execQuery($this->db->sql_build('update_visits', $tid));
	}
	
	/**
	* Check if a thread exists
	*
	* @param int $thread_id
	* @author denadai2 <denadai2@gmail.com>
	* @since v 0.1
	* @access Public
	* @return bool
	*/	
	function thread_exists($thread_id)
	{
		$query = $this->db->execQuery($this->db->sql_build('thread_exists', $thread_id));
		
		return($this->db->num_rows($query)==1);
	}
	
	/**
	* pin a thread
	*
	* @param int $thread_id
	* @author denadai2 <denadai2@gmail.com>
	* @since v 0.1
	* @access Public
	* @return Void
	*/	
	function pin_thread()
	{
		if(!$this->thread_exists($this->_tid))
			$this->error->simple_error('no_t_exists');
		
		$query = $this->db->execQuery($this->db->sql_build('update_sticky_thread', $this->_tid));
	}
	
	/**
	* unpin a thread
	*
	* @param int $thread_id
	* @author denadai2 <denadai2@gmail.com>
	* @since v 0.1
	* @access Public
	* @return Void
	*/	
	function unpin_thread()
	{
		if(!$this->thread_exists($this->_tid))
			$this->error->simple_error('no_t_exists');
		
		$query = $this->db->execQuery($this->db->sql_build('update_unsticky_thread', $this->_tid));
	}
	
	/**
	* close a thread
	*
	* @param int $thread_id
	* @author denadai2 <denadai2@gmail.com>
	* @since v 0.1
	* @access Public
	* @return Void
	*/	
	function close_thread($closed=1)
	{
		if(!$this->thread_exists($this->_tid))
			$this->error->simple_error('no_t_exists');
		
		$query = $this->db->execQuery($this->db->sql_build('update_closed_thread', array($closed,$this->_tid) ));
	}
	
	/**
	* Delete a thread
	*
	* @param int $tid
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/		
	function delete_thread()
	{
	
		$query = $this->db->execQuery($this->db->sql_build('thread_delete', $this->_tid)  );
		$query = $this->db->execQuery($this->db->sql_build('thread_posts_delete', $this->_tid) );
		
		$this->cache->RemoveFromCache('sql_index_forum-0');
		$prec = $this->skin->cache;
		$this->skin->cache = true;
		$this->skin->clear_all_cache();
		$this->skin->cache = $prec;
	}
	
	/**
	* Move a thread
	*
	* @param int $destforum
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/			
	function move_thread($destforum)
	{
		$query = $this->db->execQuery($this->db->sql_build('thread_move', array($destforum, $this->_tid))  );
		
		$this->cache->RemoveFromCache('sql_index_forum-0');
		$prec = $this->skin->cache;
		$this->skin->cache = true;
		$this->skin->clear_all_cache();
		$this->skin->cache = $prec;
	}
	
	/**
	* Delete a post
	*
	* @param int $tid
	* @param int $post_id
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return int
	*/		
	function delete_post($post_id)
	{
		$return = 0;
		$this->db->execQuery($this->db->sql_build('delete_post_by_post_id', $post_id)  );
		
		if($this->thread['firstpostid'] == $post_id)
		{
			$query = $this->db->execQuery($this->db->sql_build('select_first_post_by_tid', $this->_tid)  );
			if($this->db->num_rows($query)==0)
			{
				$this->delete_thread();
				$return = 1;
			}
			else
			{
				$vett = $this->db->fetch_array($query);
			
				$this->db->execQuery($this->db->sql_build('update_first_post_by_tid', array($vett['post_id'], $this->_tid)  ));
			}
		}
		
		$this->sync_thread($this->_tid);
		
		$this->cache->RemoveFromCache('sql_index_forum-0');
		$prec = $this->skin->cache;
		$this->skin->cache = true;
		$this->skin->clear_all_cache();
		$this->skin->cache = $prec;
		
		return $return;
	}
	
	/**
	* Syncronize the thread infoes
	*
	* @param int $tid
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/		
	function sync_thread($tid)
	{

		$query = $this->db->execQuery($this->db->sql_build('sync_thread',$tid));
		$temp=$this->db->fetch_array($query);
		
		if($temp['user_id'] == '-1')
			$temp['user_nick'] = $temp['username'];
		$query = $this->db->execQuery($this->db->sql_build('sync_thread_update', array($temp['user_nick'], $temp['user_id'], $tid)));
		
		if($this->sync_thread_count($tid)==1)
		{
			$query = $this->db->execQuery($this->db->sql_build('sync_thread_update', array($temp['user_nick'], $temp['user_id'], $tid)));
		}
	
	}

	/**
	* Syincronize the thread post count
	*
	* @param int $tid
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/	
	function sync_thread_count($tid)
	{
		$query = $this->db->execQuery($this->db->sql_build('sync_thread_count',$tid));
		$temp=$this->db->fetch_array($query);
		$query = $this->db->execQuery($this->db->sql_build('sync_thread_count_update', array($temp['posts'], $tid)));
		
		return $temp['posts'];
	}

	/**
	* Quote mode on?
	*
	* @param int $quote_id
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/		
	function quote_mode_on($quote_id)
	{
		$query = $this->db->execQuery($this->db->sql_build('fetch_quote_by_post_id', $quote_id));
		$temp = $this->db->fetch_array($query);
		if(isset($_GET['edit']))
		{
			$init_text = $this->parse->parse_bbcode_simple(stripslashes($temp['text']));
			
			if(!$this->check_mod_perms('edit_post'))  
				if($temp['user_id'] != $this->user->info_user['user_id'])
					$this->error->simple_error('no_edit_your');
				
			$query = $this->db->execQuery($this->db->sql_build('check_poll_by_topic_and_postid', array($this->_tid, $quote_id)));
			$poooool = $this->db->fetch_array($query);
			if($poooool['firstpostid']){
				if($poooool['pid']){
				$qst = unserialize($poooool['questions']);
				$keys = array_keys($qst);
					
			$count = count($keys);
			$j=1;
			
			for($i=0; $i<$count;$i++)
			{
					if($i!=0)
					$qsth .= "<div id='poll_{$i}'><p><input type=\"text\" name=\"poll_{$i}\" value=\"{$qst[$i][0]}\" />&nbsp;<input type=\"text\" name=\"poll_val_{$i}\" value=\"{$qst[$i][1]}\">&nbsp;<a href=\"#\" class=\"forumlink\" style=\"color:#FF0000\" onclick=\"remove_question('poll_{$i}');\">X</a></p></div>";
					
			}
					
						$pol = "<td class=\"board-categories-bg\"><td class=\"board-categories-bg\"><fieldset><legend>Poll Title</legend><input type=\"text\" name=\"poll_title\" value=\"{$qst[0][0]}\" /></fieldset><fieldset><legend>Poll Questions</legend><div id=\"poll_quest\">{$qsth}</div><a href=\"#\" onclick=\"add_question()\" class=\"forumlink\">Add a Question</a>
						<br /><a href=\"#\" onclick=\"remove_poll_form();\" class=\"forumlink\">Remove Poll</a><script type='text/javascript'>init_poll_id({$count});</script></td>";
					}else
						$pol = "<td class=\"board-categories-bg\">&nbsp;</td><td class=\"board-categories-bg\"><a href=\"#\" onclick=\"show_poll_form();\" class=\"forumlink\">Add a Poll</a></td>";
				}
					
			if(!$this->check_mod_perms('edit_post'))  
				if(($this->_config['edit_time']+$temp['dateline']) < time()  )
					$this->error->simple_error('no_edit_time');
			
			$this->_newpost['pol'] = $pol;
			$this->_newpost['pid'] = $poooool['pid'];
		}
		else
			$init_text = '[quote="('.$temp['user_nick'].' @ '.gmdate('d F Y H:i',$temp['dateline']).')"]'.stripslashes($temp['text']).'[/quote]';
	
		return $init_text;
	}
	
	/**
	* Insert a poll
	*
	* @param array $return_thread
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/		
	function insert_poll($return_thread)
	{
		$keys = array_keys($_POST);
										
		$count = count($keys);
		$j=1;
		
		for($i=0; $i<$count;$i++)
		{
			if(strstr($keys[$i], 'poll_') && $keys[$i] != 'poll_title')
			{
				$temp_poll[$j][0] = $_POST[$keys[$i]];
				$temp_poll[$j++][1] = 0;
			}
				
		}
		
		$temp_poll[0][0] = $_POST['poll_title'];
		$temp_poll[0][1] = 0;
		
		$query = $this->db->execQuery($this->db->sql_build('insert_poll_by_tid', array($return_thread['thread_id'], serialize($temp_poll) ) ));
		
		$poll_id = $this->db->insert_id();
		
		$query = $this->db->execQuery($this->db->sql_build('update_pollid_by_tid', array($poll_id, $return_thread['thread_id'] ) ));
	
	}

	/**
    * build new thread
    *
    * @param string $title, string $text, int $pool, int $forumid, int $userid, int $sticky
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return array()
    */
	function new_thread($title, $text, $pool, $forumid, $info_user, $sticky, $upid)
	{
		
		//---------------------------------
		// Insert Thread
		//---------------------------------
		
		$dateline=time();
		
		if(!isset($info_user['username']))
				$info_user['username'] = '0';
		
		$query = $this->db->execQuery($this->db->sql_build('new_thread', array($title, $info_user['user_id'], ($info_user['username']!='0') ? $info_user['username'] : $info_user['user_nick'], $forumid, ($info_user['username']!='0') ? $info_user['username'] : $info_user['user_nick'], $info_user['user_id'], $dateline, $dateline)));
		
		//---------------------------------
		// Insert Thread's Post
		//---------------------------------
		$this->_tid = $this->db->insert_id();
		$postid=$this->new_post('', $text, $info_user, 0, 0, $upid);
		
		
		$query = $this->db->execQuery($this->db->sql_build('thread_firstpost_update', array($postid, $this->_tid) ) );
		
		$query = $this->db->execQuery($this->db->sql_build('thread_threadcount_update', $forumid ) );
		//---------------------------------
		// Increase forum's threads count
		//---------------------------------
		$this->db->execQuery($this->db->sql_build('update_config', array(($this->_config['board_threads']+1), 'board_threads_update'))); 
		
		return array('thread_id' => $this->_tid, 'post_id' => $postid );
	}	
	
	
		/**
		* build new post
		*
		* @param int $topicid, string $title, string $text
		* @author denadai2 <denadai2@gmail.com>
		* @since v 0.1
		* @access Public
		* @return int
		*/		
		function new_post($title, $text, $info_user, $new_post=1, $check_mp, $upid)
		{
			if(!$this->thread_exists($this->_tid))
				$this->error->simple_error('generic');
				
			
			//---------------------------------
			// Increase post count
			//---------------------------------
			if( $info_user['user_id'] > 0 && $check_mp==0  )
				$query = $this->db->execQuery($this->db->sql_build('user_postcount_update', $info_user['user_id'] ) );
			
			//---------------------------------
			// Insert post
			//---------------------------------
			$dateline=time();
			
			$text = $this->parse->prepare_post($text);
			
			if(!isset($info_user['username']))
				$info_user['username'] = '0'; 

			$query = $this->db->execQuery($this->db->sql_build('insert_post', array( $this->_tid, $info_user['user_id'], $title, $text, $_SERVER['REMOTE_ADDR'], $dateline, $info_user['username'] , $check_mp, $upid )));
			
			$return = $this->db->insert_id();
			
			if($check_mp==1) //if it is an mp
				return $return;
				
			//---------------------------------
			// Increase forum's post count
			//---------------------------------
			$query = $this->db->execQuery($this->db->sql_build('fetch_title_fid_by_tid', $this->_tid));
			$threadinfo= $this->db->fetch_array($query);
			
			
			$query = $this->db->execQuery($this->db->sql_build('update_forum_stats', array($return, ($info_user['username']!='0') ? $info_user['username'] : $info_user['user_nick'], $info_user['user_id'], $threadinfo['title'], $this->_tid, $dateline, $threadinfo['forumid'])) );
			
			
			if($new_post==1)
				$query = $this->db->execQuery($this->db->sql_build('update_thread_stats', array($info_user['user_id'], ($info_user['username']!='0') ? $info_user['username'] : $info_user['user_nick'], $dateline, $this->_tid)));
				
			
			//---------------------------------
			// Increase forum's general post count
			//---------------------------------		
			$query = $this->db->execQuery($this->db->sql_build('increase_board_replies', ($this->_config['board_replies']+1) ));	
			
			
			$this->thread_subcriber_email($this->_tid);

			$this->cache->RemoveFromCache('sql_index_forum-0');
			$prec = $this->skin->cache;
			$this->skin->cache = true;
			$this->skin->clear_all_cache();
			$this->skin->cache = $prec;
			
			return $return;
		}


	/**
	* Send notifications emails to threads subscribers
	*
	* @param int $tid
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/				
	function thread_subcriber_email($tid)
	{
		$query = $this->db->execQuery($this->db->sql_build('fetch_thread_subscriber', array($tid, $this->user->info_user['user_id'] ) ) );
		
		if (strtoupper(substr(PHP_OS,0,3)=='WIN'))
			$eol="\r\n";
		elseif (strtoupper(substr(PHP_OS,0,3)=='MAC'))
			$eol="\r";
		else
			$eol="\n";
	
		$headers = 'From: '.$this->_config['board_name'].'<'.$this->_config['admin_email'].'>'.$eol;
		$headers .= 'Reply-To: '.$this->_config['board_name'].'<'.$this->_config['admin_email'].'>'.$eol;
		$headers .= 'Return-Path: '.$this->_config['board_name'].'<'.$this->_config['admin_email'].'>'.$eol;
		$headers .= "Bcc:";
		
		$last = '';
		
		if($this->db->num_rows($query)>0)
		{
			while($vett=$this->db->fetch_array($query))
			{
				$last = $vett;
				
				if($last!='')
					$headers = ' , ';
				
				$headers .= $vett['user_email'];	
			}
			
			@mail( $last['user_email'] ,$this->lang->lang_all['showthread']['main']['replyed'] . $last['title'], $this->lang->lang_all['showthread']['main']['sub_user'] .$last['title']." \n\n\n".$this->_config['board_domain'].$this->_config['board_url'].'index.php?showthread='.$last['thread_id'].'&view=lastposts'."\n\n", $headers );
			
			$query = $this->db->execQuery($this->db->sql_build('update_thread_subscriber', array($tid, $this->user->info_user['user_id'] ) ) );
		}
		
	}
	
	/**
	* Subscribe an user to a thread
	*
	* @param int $tid
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/				
	function thread_subscribe($tid)
	{
		if($this->user->info_user['user_id'] > 0)
		{
			$query = $this->db->execQuery($this->db->sql_build('unsubscribe_thread_by_uid', array($this->user->info_user['user_id'], $tid)  ) );
			
			$query = $this->db->execQuery($this->db->sql_build('subscribe_user_to_thread', array($tid, 1, $this->user->info_user['user_id'], 1)  ) );		
		}
		
	}
	
	/**
	* edit a post
	*
	* @param int $thread_id
	* @author denadai2 <denadai2@gmail.com>
	* @since v 0.1
	* @access Public
	* @return Void
	*/	
	function edit_post($post_id, $text)
	{
		/*if(!$this->thread_exists($post_id))
			$this->error->simple_error('no_t_exists');*/
		
		$query = $this->db->execQuery($this->db->sql_build('update_edit_post', array($this->parse->prepare_post($text), $post_id) ));
		
		return($query==true);
	}
		
	/**
	* Check if a thread exists
	*
	* @param int $thread_id
	* @author denadai2 <denadai2@gmail.com>
	* @since v 0.1
	* @access Public
	* @return bool
	*/	
	function fetch_post_text($post_id)
	{
		$query = $this->db->execQuery($this->db->sql_build('fetch_post_text_pid', $post_id ));
		$vett=$this->db->fetch_array($query);
		
		return $vett['text'];
	}


}

?>