<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/
if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}

/**
* Module
*
* Show the index of the forum
*
* @author denadai2 <denadai2@gmail.com>
* @company RevokeSoft <denadai2@gmail.com>
* @package RevokeBB
*/
class Module extends rev_classes
{

	/**
    * Constructor of the module
    *
    * @param array $config
    * @param String $act
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */	
	function Module(& $config, $act)
	{
		
		$this->rev_classes($config, $act);
	}

	/**
    * Execute the module
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */	
	function execute()
	{
		switch($this->_code)
		{
			default:
					if(!$this->user->info_user['can_view_profiles'])
						$this->error->simple_error('no_perm');
					
					$this->var_filtrer->add($_GET);	
						
					$this->get_profile($this->var_filtrer->Integer('user'));
					break;
		}
		$this->assign_all();
		$this->display_skin();
	
	}

	/**
    * Get Profile
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */	
	function get_profile($id)
	{
		if($id == $this->user->info_user['user_id'])
			$info_user = $this->user->info_user;
		else
			if($this->user->user_exists($id))	
				$info_user=$this->user->get_infos($id);
			else
				$this->error->simple_error('no_profile');
		
		
		if(!$this->user->has_visited($id,'_pf'))
			$query = $this->db->execQuery($this->db->sql_build('update_profile_views', $id)); 
		
		
		$info_user['user_sign'] = stripslashes($info_user['user_sign']);
		$info_user['lastaction'] = gmdate('d-m-Y H:i:s', $info_user['lastaction']);
		$info_user['joined'] = gmdate('d-m-Y H:i:s',$info_user['joined']);
		
		//set the levels array
		$this->_config['board_levels'] = unserialize($this->_config['board_levels']);
		$lvs = $this->user->generate_levels($info_user['posts'], $info_user['user_id']);
		$info_user['levels'] = $lvs['name'];
		$info_user['levels_img'] = $lvs['img'];
		$this->skin->assign('user2', $info_user);
	
	}


}

?>