<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/
if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}

/**
* Module
*
* Show the index of the forum
*
* @author denadai2 <denadai2@gmail.com>
* @company RevokeSoft <denadai2@gmail.com>
* @package RevokeBB
*/
class Module extends rev_classes
{

	/**
    * Constructor of the module
    *
    * @param array $config
    * @param String $act
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */	
	function Module(& $config, $act)
	{
		
		$this->rev_classes($config, $act);
	}

	/**
    * Execute the module
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */	
	function execute()
	{
		if($this->user->info_user['user_id'] < 1 && !( abs(intval($_GET['code'])) == 14) )
			$this->error->login_error('no_perm');
			
		switch($this->_code)
		{
		//show the list of mp
			case '02': 
			
					$query=$this->db->execQuery($this->db->sql_build('usercp_pvt', $this->user->info_user['user_id']));
					
					while($pvt=$this->db->fetch_array($query))
					{
						$pvt['date'] = gmdate('d F Y H:i',$pvt['dateline']);
						$all_vett[] = $pvt;
					}
					
					
					$this->skin->assign('count', $this->db->num_rows($query));
					$this->skin->assign('pvts', $all_vett);
					
					$this->assign_all();
					$this->skin->display('usercp/pvt.tpl');			
					exit;
					break;
			
			case '03':
					$this->user->info_user['user_sign'] = stripslashes($this->user->info_user['user_sign']);
					
					$this->assign_all();
					$this->skin->display('usercp/profile_opt.tpl');
					exit;
					break;
			
			//RSS Threads feed
			case '04': 
				
					require 'inc/class_rss.php';
					
					$query = $this->db->execQuery($this->db->sql_build('subscribed_threads', $this->user->info_user['user_id']));
					
					$rss = new UniversalFeedCreator();
					$rss->useCached();
					$rss->title = $this->_config['board_name'].' subscribed threads';
					$rss->description = $rss->title;
					$rss->link = $this->_config['board_domain'].$this->_config['board_url'];
					$rss->syndicationURL = $this->_config['board_domain'].htmlentities($_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING']);
					
					
					// get your news items from somewhere, e.g. your database:
					while($thread=$this->db->fetch_array($query))
					{
						$item = new FeedItem();
						$item->title = $thread['title'];
						$item->link = $this->_config['board_domain'].$this->_config['board_url'].'index.php?showthread='.$thread['thread_id'];
						$item->description = $thread['text'];
						$item->date = $thread['dateline'];
						$item->source = $this->_config['board_domain'].$this->_config['board_url'];
						$item->author = $thread['user_nick'];
						
						$rss->addItem($item);
					}
					header('Content-Type: text/xml');
					echo $rss->createFeed("RSS1.0"); 
					exit;
					break;
				
			case '05':
					$this->var_filtrer->add($_GET);
					
					$mode = $this->var_filtrer->Integer('mode');
					
					$this->user->update_avatar($mode);
					
					$this->error->complete('index.php?usercp', $this->lang->lang_all['usercp']['main']['avatar_uploaded']);
					
					break;
						
			case '06':
					$this->var_filtrer->add($_POST);
					$text = $this->var_filtrer->String('replybox');
					
					$this->user->update_sign($text);
		
					$this->error->complete('index.php?usercp', $this->lang->lang_all['usercp']['main']['sign_updated']);
					break;
			case '07':
					$keys = array_keys($_POST);
					
					$count = count($keys);
					
					$check = false;
					
					for($i=0; $i<$count;$i++)
					{
						if(strstr($keys[$i], 'msg_'))
						{
							$query = $this->db->execQuery($this->db->sql_build('delete_mp_by_id_toid', array(substr($keys[$i],4), $this->user->info_user['user_id']) ));
							$check = true;
							
						}
					}
					
					if($check == false)
						$this->error->simple_error('no_delete_mp');
					
					$this->error->complete('index.php?usercp', $this->lang->lang_all['usercp']['main']['lang_deleted']);
					break;
			case '08':
						
					$this->user->info_user['user_sign'] = htmlspecialchars(stripslashes($this->user->info_user['user_sign']));
					$this->user->info_user['user_location'] = $this->user->info_user['user_location'] == '0' ? '' : $this->user->info_user['user_location'];
					$this->user->info_user['user_yahoo'] = $this->user->info_user['user_yahoo'] == '0' ? '' : $this->user->info_user['user_yahoo'];
					$this->user->info_user['user_msn'] = $this->user->info_user['user_msn'] == '0' ? '' : $this->user->info_user['user_msn'];
					
					$this->assign_all();
					$this->skin->display('usercp/profile_general.tpl');
					exit;
					
					break;
			case '09':
					$this->var_filtrer->add($_POST);
					
					$vett = array();
					$vett[] = $this->var_filtrer->String('user_msn',0);
					$vett[] = $this->var_filtrer->String('user_yahoo',0);
					$vett[] = $this->var_filtrer->Integer('user_gender');
					$vett[] = $this->var_filtrer->String('user_location',0);
					$vett[] = $this->user->info_user['user_id'];
					
					if(strlen($vett[0]) < 3)
						$vett[0] = '0';
						
					if(strlen($vett[1]) < 3)
						$vett[1] = '0';
						
					if(strlen($vett[3]) < 3)
						$vett[3] = '0';
					
					$query = $this->db->execQuery($this->db->sql_build('update_profile_1', $vett ));
										
					$this->error->complete('index.php?usercp', $this->lang->lang_all['usercp']['main']['lang_profile_upd']);
					
					break;
			case '10':
					$this->var_filtrer->add($_POST);
					
					$email = $this->var_filtrer->String('user_email',0);
					$email2 = $this->var_filtrer->String('user_email2',0);
					
					if($email != $email2)
						$this->error->simple_error('email_coincide');
					
					$query = $this->db->execQuery($this->db->sql_build('update_profile_2', array($email, $this->user->info_user['user_id']) ));
										
					$this->error->complete('index.php?usercp', $this->lang->lang_all['usercp']['main']['lang_profile_upd']);
					
					break;
			//Subscribed thread delete
			case '11':
					$keys = array_keys($_POST);
					
					$count = count($keys);
					
					$check = false;
					
					for($i=0; $i<$count;$i++)
					{
						if(strstr($keys[$i], 'thread_'))
						{
							$query = $this->db->execQuery($this->db->sql_build('delete_sub_thread_by_id', array(substr($keys[$i],7), $this->user->info_user['user_id']) ));
							$check = true;
							
						}
					}
					
					if($check == false)
						$this->error->simple_error('no_delete_sub');
					
					$this->error->complete('index.php?usercp', $this->lang->lang_all['usercp']['main']['lang_sub_deleted']);
					
					break;
			//Visual options view
			case '12':
					$query = $this->db->execQuery($this->db->sql_build('fetch_languages'));
					while($vett=$this->db->fetch_array($query))
					{
						$all_langs[] = $vett;
					}
					$this->skin->assign('langs', $all_langs);
					
					$this->assign_all();
					$this->skin->display('usercp/visual_opt.tpl');
					exit;
					
					break;
			//Visual options set
			case '13':
					$this->var_filtrer->add($_POST);
					
					$wysiwyg = $this->var_filtrer->Integer('wysiwyg');
					$lang_name = $this->var_filtrer->String('lang_name',0);
					
					$query = $this->db->execQuery($this->db->sql_build('update_profile_3', array($wysiwyg, $lang_name, $this->user->info_user['user_id']) ));
										
					$this->error->complete('index.php?usercp', $this->lang->lang_all['usercp']['main']['lang_profile_upd']);
					break;
			//Active an user account
			case '14':
					$this->var_filtrer->add($_GET);
					
					$hash = $this->var_filtrer->String('h');
					$stamp = $this->var_filtrer->String('s');
					
					$this->user->activate_user($hash, $stamp);
										
					$this->error->complete('index.php', $this->lang->lang_all['usercp']['main']['activated']);
					break;
			//Send activation email
			case '15':
					if($this->user->info_user['status'] == 1)
						$this->error->simple_error('active_yes');
						
					$this->user->send_activation_email();
										
					$this->error->complete('index.php', $this->lang->lang_all['usercp']['main']['mail_act_sent']);
					break;
			
			//cake
			case '16':
					require 'inc/class_stats.php';
										
					$stats = new stats_handler($this->skin,$this->db);

					$stats->cake_posts($this->user->info_user['posts'], $this->_config['board_replies']);
					break;
					
					
			default:
					$query=$this->db->execQuery($this->db->sql_build('subscribed_threads', $this->user->info_user['user_id']));

					while($thread=$this->db->fetch_array($query))
					{
						$thread['dateline'] = gmdate('d F Y H:i',$thread['dateline']);
						$all_vett[] = $thread;
					}
					
					
					$this->skin->assign('threads', $all_vett);
					$this->skin->assign('count', $this->db->num_rows($query));
					break;
		}
		
		$this->assign_all();
		$this->display_skin();
	
	}


}

?>