<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/

class Forum
	{
	/**
    * information of selected forum
    * @access Private
    * @var array()
    */
	var $forum;
	
	/**
    * Database connection class
    * @access Private
    * @var class
    */
	var $db;
	
	/**
    * Skin class
    * @access Private
    * @var class
    */
	var $skin;
	
	/**
    * Error handler class
    * @access Private
    * @var class
    */
	var $error;
	
	/**
    * Language System class
    * @access Private
    * @var class
    */
	var $lang;
	
	/**
    * cache class
    * @access Private
    * @var class
    */
	var $cache;
	
	/**
    * Text parsing class
    * @access Private
    * @var class
    */
	var $parse;
	
	/**
    * Forum Constructor
    *
    * @param None
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return none
    */
	function Forum(& $db, & $skin, & $error, & $_config, & $lang, & $user, & $cache, $fid=0)
		{
		
		$this->db = & $db;
		$this->skin = & $skin;
		$this->error = & $error;
		$this->_config = & $_config;
		$this->lang = & $lang;
		$this->user = & $user;
		$this->cache = & $cache;
		
		require_once 'inc/class_parse.php';
		$this->parse = new Parse();
		
		if($fid!=0)
		{
			//----------------------------------
			// Load forum informations
			//----------------------------------
        	$query = $this->db->execQuery($this->db->sql_build('fetch_forum_by_id', $fid));
			$this->forum = $this->db->fetch_array($query);
			if($this->forum['move_url']!='0')
				$this->error->complete($this->forum['move_url'], 'Reindirizzamento in corso...');
			
		}
		
		/*if(!isset($this->forum['id']))
			$revoke->error();*/
			
		}
		

	/**
    * Show a forum by forum_id
    *
    * @param int $id, array() $user
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */			
	function show_forum($id, $start)
	{
		
		$query = $this->db->execQuery($this->db->sql_build('fetch_threads_and_posttext_by_id', array($id,$start) ));
		
			while($vett=$this->db->fetch_array($query))
			{
				
				if($vett['sticky']==1)
					$vett['title'] = 'In Rilievo: '.$vett['title'];
				else
					if($vett['pollid'] != 0)
						$vett['title'] = 'Poll: '.$vett['title'];
				
				$vett['datelinesav'] = $vett['dateline']; 
				
				$vett['dateline'] = gmdate('d F Y H:i', $vett['last_update']);
				
				if($this->user->info_user['user_id']<1)
				{
					if($vett['closed']==1)
						$vett['state'] = 8;
					else
						$vett['state'] = 2;
						
				}
				else
				{ 
					if($vett['closed'] == 1)
						$vett['state'] = 8;
					else
						if($vett['moved_id']!=0)
							$vett['state']=7;
						else
						{
							if(!$this->is_visited($vett['thread_id'], $vett['datelinesav']))
								$vett['state'] = 1;
							else
								$vett['state'] = 2;
						
							/*if($vett['poolid']!=0)
								$vett['state']=$vett['state']+4;
							else*/
								if($vett['reply'] >= 100)
								$vett['state']=$vett['state']+2;
						}
				
				} 
				
				if($vett['reply'] > 9)
				{
					$num_link = intval( ($vett['reply']+1) / 10);
					
					if( (($vett['reply']+1) / 10) > $num_link)
						$num_link++;
					
					$linkpage = '';
					
					for($i=0; ($i<3 && $i<$num_link); $i++)
					{
						$linkpage.= '<span class="minipagelink"><a href="index.php?showthread='.$vett['thread_id'].'&amp;start='.($i*10).'">'.($i+1).'</a></span>';
					}
					
					if($num_link > 4 )
						$linkpage.= '<span class="minipagelink"><a href="index.php?showthread='.$vett['thread_id'].'&amp;start='.(($num_link-1)*10).'">&gt;&gt;'.$num_link.'</a></span>';
					else
						if($num_link == 4)
							$linkpage.= '<span class="minipagelink"><a href="index.php?showthread='.$vett['thread_id'].'&amp;start=30">4</a></span>';
				}
				else
					$linkpage = '0';
					
				$vett['text']=substr($this->parse->remove_bbcode(stripslashes($vett['text'])),0,60);
				$vett['links']= $linkpage;
				 
				
				
				$all_vett[]=$vett;
			}
		
		$this->skin->assign('num_threads', $this->db->num_rows($query));	
		$this->skin->assign('threads', $all_vett);
		
		$query = $this->db->execQuery($this->db->sql_build('fetch_forums_lists', $this->user->info_user['level'] ));

		$menu='';
		$all_vett = array();
		while($vett=$this->db->fetch_array($query))
			$all_vett[] = $vett;
		
		$all_vett = $this->order_forum_jump_list($all_vett);
		
		$count = count($all_vett);
		for($i=0;$i<$count;$i++)
			if($all_vett[$i]['forum_id'] == $id)
				$menu.='<option value="'.$all_vett[$i]['forum_id'].'" onclick="document.asd.submit();" selected="selected">'.$all_vett[$i]['title'].'</option>';
			else
				$menu.='<option value="'.$all_vett[$i]['forum_id'].'" onclick="document.asd.submit();">'.$all_vett[$i]['title'].'</option>';
		
		$this->skin->assign('menu_forums', $menu);

		
	}	
	
	/**
    * Show index forums and cats
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */			
	function show_index_forums($forumid=-1)
	{

		$prec='';
		
		$count=0;
		$count2=0;
		if($forumid!=-1)
			$all_vett = false;
		else
		{
			//----------------------------------
			// SQL Cached vett init
			//----------------------------------
			if($this->user->info_user['level'] == 0)
				$all_vett = $this->cache->GetFromCache('sql_index_forum-0', 0, true);
			else
				$all_vett = false;
		}
			
		if($all_vett)
			$cached = true;
		else
		{
			//----------------------------------
			// Categories and Forums
			//----------------------------------
			if($forumid!=-1)
				$query = $this->db->execQuery($this->db->sql_build('fetch_subforums', array($this->user->info_user['level'], $forumid) ));
			else
				$query = $this->db->execQuery($this->db->sql_build('index_forums', $this->user->info_user['level']));
			$all_vett = array();
			$cached = false;
		//}

		while($vett=$this->db->fetch_array($query))
		{
			/*if($cached)
			{
				if($count == $tot)
					break;
				$vett = $all_vett[$count][$count2];
			}*/
			//else
				
			
			
			if( (!$vett['perm'][0]) && $this->user->info_user['admincp']!=1)
				continue;
			
			$vett['lastaction'] = gmdate('d F Y H:i',$vett['lastaction']);
				
			if($count==0 && $count2 == 0)
				$prec=$vett['cat_id'];
			else
			if($prec!=$vett['cat_id'])
			{
				$count++;
				$count2=0;
				$prec=$vett['cat_id'];
			}
			
			
				
			$vett['title']=stripslashes($vett['title']);
			
			
			if($vett['closed']==1)
			$vett['state']=8;
		else
			if($vett['move_url']!=0)
					$vett['state']=7;
				else
					{
					//	if($user['lastaction']>($vett['datelinesav']+10000))
					//		$vett['state']=2;
					//	else
							$vett['state']=1;
						
					}
			
			$all_vett[$count][$count2] = $vett;
			
			$count2++;
			
		}
		}
		
		$this->skin->assign('forums', $all_vett);
		
		if($forumid==-1)
		{
			//----------------------------------
			// SQL Cache write
			//----------------------------------
			if(!$cached && $this->user->info_user['level'] == 0)
				$this->cache->WriteToCache('sql_index_forum-0', $all_vett);
		}
		
	}
	
	/**
    * Show index forums and cats
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */			
	function show_admin_forums($parent=-1)
	{

		$prec='';
		$js = '';
		$all_js = '';
		$count=0;
		$count2=0;
		//----------------------------------
		// Categories and Forums
		//----------------------------------
		if($parent == -1)
			$query = $this->db->execQuery($this->db->sql_build('admin_index_forums_with_parent', $parent));
		else
			$query = $this->db->execQuery($this->db->sql_build('admin_index_forums', $parent));
		$all_vett = array();
		$cached = false;

		while($cached || ($vett=$this->db->fetch_array($query)))
		{
				
			
			
			if( (!$vett['perm'][0]) && $this->user->info_user['admincp']!=1)
				continue;
			
			$vett['lastaction'] = gmdate('d F Y H:i',$vett['lastaction']);
			
			
				
			if($count==0 && $count2 == 0)
			{
				$prec=$vett['cat_cat_id'];
				
				$js.= '
function updateOrder_'.$vett['cat_cat_id'].'()
            {
                var options = {
                                method : \'post\',
                                parameters : Sortable.serialize("list_'.$vett['cat_cat_id'].'"),
								onComplete : function(request) {
								alert("Forum Updated");
								//new Ajax.Updater(\'stats\', \'index.php\', {asynchronous:true, evalScripts:true});								
                        // turn off update message here
                    }
                              };
 
                new Ajax.Request(\'index.php?admin&code=forums&s=01&cid='.$vett['cat_cat_id'].'\', options);
            }
        
   Sortable.create("list_'.$vett['cat_cat_id'].'", {dropOnEmpty:true,containment:["firstlist","secondlist"], onUpdate : updateOrder_'.$vett['cat_cat_id'].' });';
			$all_js.= '"list_'.$vett['cat_cat_id'].'",';
			}
			
		
			if($prec!=$vett['cat_cat_id'])
			{
				
				$count++;
				$count2=0;
				$prec=$vett['cat_cat_id'];
				$js.= '
function updateOrder_'.$vett['cat_cat_id'].'()
            {
                var options = {
                                method : \'post\',
                                parameters : Sortable.serialize("list_'.$vett['cat_cat_id'].'"),
								onComplete : function(request) {
								alert("Forum Updated");
								//new Ajax.Updater(\'stats\', \'index.php\', {asynchronous:true, evalScripts:true});								
                        // turn off update message here
                    }
                              };
 
                new Ajax.Request(\'index.php?admin&code=forums&s=01&cid='.$vett['cat_cat_id'].'\', options);
            }
        
   Sortable.create("list_'.$vett['cat_cat_id'].'", {dropOnEmpty:true,containment:["firstlist","secondlist"], onUpdate : updateOrder_'.$vett['cat_cat_id'].' });

 ';
			$all_js.= '"list_'.$vett['cat_cat_id'].'",';
			}
			
				if($vett['forum_id']>0)
				$js .= 'new Ajax.InPlaceEditor(\'name_'.$vett['forum_id'].'\', \'index.php?admin&code=forums&s=02&fid='.$vett['forum_id'].'\');';

				
			$vett['title']=stripslashes($vett['title']);
			
			
			if($vett['closed']==1)
			$vett['state']=8;
		else
			if($vett['move_url']!=0)
					$vett['state']=7;
				else
					{
						
							$vett['state']=1;
						
					}
			
			$all_vett[$count][$count2] = $vett;
			
			
			$count2++;
			
			
		}
		if(count($all_vett)==0)
			$this->skin->assign('message', 'No forums or subforums foumd');
		else
			$this->skin->assign('message', '');
		$all_js[strlen($all_js)-1] = ' ';
		$js = str_replace('containment:["firstlist","secondlist"]', 'containment:['.$all_js.']', $js);
		$this->skin->assign('js', $js);
		$this->skin->assign('forums', $all_vett);
		
		/*$menu='';
		for($i=0;$i<=$count;$i++)
			$menu.='<option value="'.($i+1).'">'.($i+1).'</option>';
		
		$this->skin->assign('menu_cats', $menu);*/
		
	}	
		

	
	
	/**
	* Update forum order for admincp-ajax
	*
	* @param int $key
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/	
	function update_forum_order($key)
	{
        if (!isset($_POST[$key]) || !is_array($_POST[$key]))
            return;

        $ranking = 1;
		
		$category_id = substr($key, 5);
 
        foreach ($_POST[$key] as $cat_id) 
		{
			if($cat_id != '')
				$query = $this->db->execQuery($this->db->sql_build('update_forum_rank', array ($ranking, $category_id, $cat_id) ));
			
			
			$ranking++;
			
		}
		
		$this->cache->RemoveFromCache('sql_index_forum-0');
		$query = $this->db->execQuery($this->db->sql_build('fetch_all_groups' ));
		$prec = $this->skin->cache;
		$this->skin->cache = true;
		$this->skin->clear_all_cache();
		$this->skin->cache = $prec;
		
	}


	/**
	* rename a forum
	*
	* @param string $name, int $fid
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/	
	function rename_forum($name, $fid)
	{
		$query = $this->db->execQuery($this->db->sql_build('forum_rename', array ($name, $fid) ));
		
		$this->cache->RemoveFromCache('sql_index_forum-0');
$query = $this->db->execQuery($this->db->sql_build('fetch_all_groups' ));
				$prec = $this->skin->cache;
		$this->skin->cache = true;
		$this->skin->clear_all_cache();
		$this->skin->cache = $prec;
	}
	
	/**
	* Syncronize forum lastthread and threads-posts count
	*
	* @param int $fid
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/	
	function sync_forum($fid)
	{
	
		$query = $this->db->execQuery($this->db->sql_build('sync_forums_lastthread',$fid));
		$last = $this->db->fetch_array($query);
		$query = $this->db->execQuery($this->db->sql_build('sync_forums_lastthread_update', array($last['lastposter'], $last['lastposterid'], $last['title'], $last['thread_id'], $last['last_update'], $fid)));
		
		$this->sync_forum_threads($fid);
		
		$this->cache->RemoveFromCache('sql_index_forum-0');
$query = $this->db->execQuery($this->db->sql_build('fetch_all_groups' ));
				$prec = $this->skin->cache;
		$this->skin->cache = true;
		$this->skin->clear_all_cache();
		$this->skin->cache = $prec;
	}

	/**
	* Syncronize forum threads-posts count
	*
	* @param int $fid
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/	
	function sync_forum_threads($fid)
	{
		$query = $this->db->execQuery($this->db->sql_build('sync_forums_count_all', $fid));
		$forum=$this->db->fetch_array($query);
		$query = $this->db->execQuery($this->db->sql_build('update_forum_count', array($forum['replies'], $forum['threads'], $fid) ));
		
		$this->cache->RemoveFromCache('sql_index_forum-0');
$query = $this->db->execQuery($this->db->sql_build('fetch_all_groups' ));
				$prec = $this->skin->cache;
		$this->skin->cache = true;
		$this->skin->clear_all_cache();
		$this->skin->cache = $prec;
	}
	
	/**
	* Create a new forum
	*
	* @param array $array
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return bool
	*/	
	function new_forum($array)
	{
		$query = $this->db->execQuery($this->db->sql_build('new_forum', array($array['title'], $array['description'], $array['move_url'], $array['catid'])));
		$forum_id=$this->db->insert_id();
		$query2= $this->db->execQuery($this->db->sql_build('fetch_all_groups'));
		while($vett=$this->db->fetch_array($query2))
		{
			$this->db->execQuery($this->db->sql_build('insert_forum_perm', array($vett['gid'], $array['perm_'.$vett['gid']], $forum_id)));
		}
		
		$this->cache->RemoveFromCache('sql_index_forum-0');

		$prec = $this->skin->cache;
		$this->skin->cache = true;
		$this->skin->clear_all_cache();
		$this->skin->cache = $prec;
		
		return $query;
	}
	
	/**
	* Create a new forum
	*
	* @param array $array
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return bool
	*/	
	function update_forum($fid, $array)
	{
		$query = $this->db->execQuery($this->db->sql_build('update_forum', array($array['title'], $array['description'], $array['move_url'], $fid)));
		
		$query2= $this->db->execQuery($this->db->sql_build('fetch_all_groups'));
		while($vett=$this->db->fetch_array($query2))
		{
			$this->db->execQuery($this->db->sql_build('update_forum_perm', array($array['perm_'.$vett['gid']], $fid, $vett['gid'])));
		}
		
		$this->cache->RemoveFromCache('sql_index_forum-0');
		
		$prec = $this->skin->cache;
		$this->skin->cache = true;
		$this->skin->clear_all_cache();
		$this->skin->cache = $prec;
		
		return $query;
	}
	
	/**
	* Create a new category
	*
	* @param array $array
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return bool
	*/	
	function new_category($name)
	{
		$query = $this->db->execQuery($this->db->sql_build('new_cat', $name ));
		
		
		$this->cache->RemoveFromCache('sql_index_forum-0');
		$query = $this->db->execQuery($this->db->sql_build('fetch_all_groups' ));
		$prec = $this->skin->cache;
		$this->skin->cache = true;
		$this->skin->clear_all_cache();
		$this->skin->cache = $prec;
		
		return $query;
	}
	
	/**
	* Delete a forum
	*
	* @param int $fid
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return bool
	*/	
	function delete_forum($fid)
	{
		$query = $this->db->execQuery($this->db->sql_build('delete_forum', $fid ));
		$query2= $this->db->execQuery($this->db->sql_build('delete_perms_by_fid', $fid));
		
		$this->cache->RemoveFromCache('sql_index_forum-0');
		$query = $this->db->execQuery($this->db->sql_build('fetch_all_groups' ));
		$prec = $this->skin->cache;
		$this->skin->cache = true;
		$this->skin->clear_all_cache();
		$this->skin->cache = $prec;
		
		return $query;
	}
	
	/**
	* Check if the thread is "new"
	* @param int tid
	* @param int time
	* @author denadai2 <denadai2@gmail.com>
	* since v 1.0
	* @access Public
	* @return none
	*/	
	function is_visited($tid, $time=0)
	{
		
		if($time < $_SESSION['lastaction'] || $this->user->has_visited($tid, '', 0))
			return true;
		
		//$_SESSION['tid_view'][] = $tid;
		return false;
	}	
	
	/**
	* Make a menu for automatic jump into a forum
	* @param array $all_vett
	* @author denadai2 <denadai2@gmail.com>
	* since v 1.0
	* @access Public
	* @return array()
	*/		
	function order_forum_jump_list($all_vett)
	{
		$count = count($all_vett);
		
		for($i=0;$i<$count;$i++)
		{
		
			if(substr($all_vett[$i]['title'],0,6) == '&nbsp;')
				continue;
				
			//find the position of the parent
			$pos = multiarray_search($all_vett, 'forum_id', $all_vett[$i]['parent_id']);
			
			if($pos != -1)
			{
				
				$tabs='';
				//count how many tag to insert
				$str_len = strlen($all_vett[$pos]['title']);
				for($j=0;$j<$str_len && $j<38;$j=$j+12)
					if(substr($all_vett[$pos]['title'],$j,12)=='&nbsp;&nbsp;')
						$tabs .= '&nbsp;&nbsp;';
						
				$tabs.= '&nbsp;&nbsp;';
				$all_vett[$i]['title'] = $tabs.$all_vett[$i]['title'];
				
				$temp = $all_vett[$i];
				
				for($j=$pos+1;$j<=$count;$j++)
				{
					$all_vett[$j] = $temp;
					$temp = $all_vett[$j+1];
				}
				
				
				$count++;
				//if it was before the parent
				if($pos>$i)
				{
					
					for($j=$i;$j<$count-1;$j++)
					{
						$all_vett[$j] = $all_vett[$j+1];
					}
					
				}
				
				
				unset($all_vett[$count]);
				$count--;
				//reset
				$i=-1;
			}
		
		}
		
		$count = count($all_vett);
		
		for($i=0;$i<$count;$i++)
		{
			if($all_vett[$i]=='')
				unset($all_vett[$i]);
		}
		
		
		return $all_vett;
	}

	/**
	* Get all mods of a forum
	* @param int fid
	* @author denadai2 <denadai2@gmail.com>
	* since v 1.0
	* @access Public
	* @return array
	*/		
	function get_all_mods($fid)
	{
		$query = $this->db->execQuery($this->db->sql_build('fetch_mods_by_fid', $fid ));
		if($this->db->num_rows($query)==0)
			return array();
			
		$vett2 = array();
		
		while($vett = $this->db->fetch_array($query))
			$vett2[] = $vett;
		
		return $vett2;
	}

	/**
	* Move all threads from a forum to another forum
	* @param int $from
	* @param int $to
	* @author denadai2 <denadai2@gmail.com>
	* since v 1.0
	* @access Public
	* @return none
	*/		
	function move_all_threads($from, $to)
	{
		$this->db->execQuery($this->db->sql_build('move_all_threads', array($to, $from) ));
		$this->sync_forum($to);
	}

	/**
	* Move all subforums from a forum to another forum
	* @param int $from
	* @param int $to
	* @author denadai2 <denadai2@gmail.com>
	* since v 1.0
	* @access Public
	* @return none
	*/		
	function move_all_subforums($from, $to)
	{
		$this->db->execQuery($this->db->sql_build('move_all_subforums', array($to, $from) ));
		$this->sync_forum($to);
	}
	
}


?>