<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/

if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}

class gd_handler 
{
	/**
    * image
    * @access Private
    * @var image?!
    */
    var $im = NULL;
	
	/**
    * Random string
    * @access Private
    * @var String
    */
    var $string = NULL;
	
	/**
    * height of the captcha image
    * @access Private
    * @var int
    */
    var $height;
	
	/**
    * width of the captcha image
    * @access Private
    * @var int
    */
    var $width;


	/**
	* GD construnctor
	*
	* @param none
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/
    function gd_handler ($default=true) 
	{
        if($default)
		{
			session_start();
			$this->height =150;
			$this->width = 35;
		}
        
    }
 
 	/**
	* Generete a random string
	*
	* @param none
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/   
	function generate_string () 
	{ 
        // Set session variable
		unset($_SESSION['gd_string']);
        $_SESSION['gd_string'] = substr(sha1(mt_rand()), 17, 6);
		
		$this->string = $_SESSION['gd_string'];
    }
	
 	/**
	* Verify the string with random string
	*
	* @param String $gd_string
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return bool
	*/ 
    function verify_string ($gd_string) 
	{
        // Check if the original string and the passed string match...
        return($_SESSION['gd_string'] == $gd_string);
    }

 	/**
	* Create captcha image
	*
	* @param none
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/    
    function create_image () 
	{
        // Seed string
        $this->generate_string();

        $this->im = imagecreatetruecolor($this->height, $this->width); // Create image
        
        // Get width and height
        $img_width = imagesx($this->im);
        $img_height = imagesy($this->im);
        
        // Define some common colors
        $black = imagecolorallocate($this->im, 0, 0, 0);
		$white = imagecolorallocate($this->im, 255, 255, 255);
        
        // Background
        imagefilledrectangle($this->im, 0, 0, $img_width, $img_height, $white);
		
		
		// select random font size
		$count=strlen($this->string);
		for($i=0;$i<$count;$i++)
		{
			$FontSize = rand(18, 28);
			$Angle=rand(-30, 30);
			imagefttext($this->im,$FontSize,$Angle,(($img_width - (strlen($this->string)-$i * 200)) / 9), (($img_height +25) / 2),$black,'inc/VeraIt.ttf',$this->string[$i]);
		}
        
    }
	
 	/**
	* Output the captcha image
	*
	* @param none
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/ 
    function output_image() 
	{
        $this->create_image(); // Generate image

        header("Content-type: image/jpeg"); // Tell the browser the data is a JPEG image
        
        imagejpeg($this->im); // Output Image
        imagedestroy($this->im); // Flush Image
    }

 	/**
	* Create the thumb
	*
	* @param String $sorgente, String $name, int $qualita
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/ 
    function create_thumb($sorgente, $name, $qualit=100)
    {
        if (!file_exists($sorgente))
        {
            echo "L'immagine non esiste!";
        }
        else
        {
            $size = getimagesize($sorgente);

			if($size[1]<150)
				{
				$lar=$size[0];
				$alt=$size[1];
				$alt2=$alt;
				$lar2=$lar;
				}
			else
				{
				$rap = $size[1] / 150;
				$lar = $size[0] / $rap;
				$alt=150;
				$alt2=135;
				$lar2=$size[0]/($size[1] / 135);
				}

            $resize = imagecreatetruecolor($lar, $alt);

            if ($qualit > 100)
            {
                echo "Qualit massima: 100!";
            }
            else
            {

				//ob_start();
                switch ($size["mime"])
                {
                    case "image/jpeg":
						$im = imagecreatefromjpeg($sorgente);
						imagecopyresampled($resize, $im, ($lar-$lar2)/2, 0, 0, 0, $lar2, $alt2, $size[0], $size[1]);
						$this->Miniatura($resize,$size,$lar,$alt,$sorgente);
						imagejpeg($resize, 'uploads/images/thumb_'.$name, $qualit);
						imagejpeg(imagecreatefromjpeg($sorgente), 'uploads/images/'.$name,$qualit);
                    break;

                    case "image/png":
                    	$qualit=9;
						$im = imagecreatefrompng($sorgente);
						imagecopyresampled($resize, $im, 0, 0, 0, 0, $lar, $alt, $size[0], $size[1]);
						$this->Miniatura($resize,$size,$lar,$alt,$sorgente);
						imagepng($resize, 'uploads/images/thumb_'.$name, $qualit);
						imagepng(imagecreatefrompng($sorgente), 'uploads/images/'.$name,$qualit);
                    break;

					case "image/gif":
						$im = imagecreatefromgif($sorgente);
						imagecopyresampled($resize, $im, 0, 0, 0, 0, $lar, $alt, $size[0], $size[1]);
						$this->Miniatura($resize,$size,$lar,$alt,$sorgente);
						imagegif($resize, 'uploads/images/thumb_'.$name, $qualit);
						imagegif(imagecreatefromgif($sorgente), 'uploads/images/'.$name,$qualit);
                    break;
                }
				
                imagedestroy($im);


            }
        }
    }

 	/**
	* Create the real thumb
	*
	* @param img $resize, int $size, int $lar, int $alt, String $sorgente
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return none
	*/ 
	function Miniatura(& $resize,$size,$lar,$alt,$sorgente)
	{
		$black=imagecolorallocate($resize, 0, 0, 0);
		$white=imagecolorallocate($resize, 255, 255, 255);
	
		imageline($resize,0,0,$lar,0, $black);
		imageline($resize,0,0,0,$alt, $black);
		imageline($resize,$lar-1,0,$lar-1,$alt-1, $black);
	
		$peso=(int)(filesize($sorgente)/1024);
		imagefilledrectangle ( $resize, 0, $alt-18, $lar, $alt, $black );
		$stringa=$size[0].'X'.$size[1].' '.$peso.' kb';
		imagestring($resize, 3, $lar/2-(strlen($stringa)*3), $alt-16, $stringa, $white);
	}
	
 	/**
	* Save a file from an url
	*
	* @param String $url
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return String
	*/ 	
	function http_get_file($url,  & $err)
	{
		$fd = @fopen ($url, "r");
		$error = & $err;
		if(!$fd)
			$error->simple_error('invalid_url');
			
		$buffer = '';
		
		while (!feof ($fd)) 
			$buffer.= fgets($fd, 4096);	
			
		fclose ($fd);
		
		return $buffer;
	}	

 	/**
	* Antialiased arc function
	*
	* @param String $url
	* @author Ulrich Mierendorff
	* @since v 1.0
	* @access Public
	* @return String
	*/ 	
	function imageSmoothArc( &$img, $cx, $cy, $w, $h, $color, $start, $stop) 
	{
		$fillColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 0 );
		$w /= 2;
		$h /= 2;
		$cdx = $w * cos(M_PI/4);
		$cdy = $h * sin(M_PI/4);
		
		$xStart = $w * cos($start);
		$yStart = $h * sin($start);
		$xStop = $w * cos(min(M_PI,$stop));
		$yStop = $h * sin(min(M_PI,$stop));
		if ( $start < M_PI/2 )
		{
			$yy = 0;
			for ( $x = 0; $x <= $xStart; $x += 1 ) 
			{
				if ( $x < $xStop )
					$y1 = $x/$xStop*$yStop;
				else
					$y1 = $h * sqrt( 1 - pow( $x,2 ) / pow( $w,2 ) );
				
				$y2 = $x/$xStart*$yStart;
				$d1 = $y1 - floor($y1);
				$d2 = $y2 - floor($y2);
				$y1 = floor($y1);
				$y2 = floor($y2);
				imageLine($img, $cx + $x, $cy - $y1, $cx + $x, $cy - $y2, $fillColor);
				$diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d1*100 );
				imageSetPixel($img, $cx + $x, $cy - $y1 - 1, $diffColor);
				$diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d2*100 );
				imageSetPixel($img, $cx + $x, $cy - $y2 + 1, $diffColor);
				for ( $yy; $yy <= $y1; $yy += 1 ) 
				{
					if ( $yy < $yStart ) 
						$x1 = $yy/$yStart*$xStart;
					else
						$x1 = $w * sqrt( 1 - pow( $yy,2 ) / pow( $h,2 ) );
			
					$d1 = $x1 - floor($x1);
					$x1 = floor($x1);
					$diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d1*100 );
					imageSetPixel($img, $cx + $x1 + 1, $cy - $yy, $diffColor);
					if ($stop < M_PI/2)
					{
						$x2 = $yy/$yStop*$xStop;
						$d2 = $x2 - floor($x2);
						$x2 = floor($x2);
						$diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d2*100 );
						imageSetPixel($img, $cx + $x2, $cy - $yy, $diffColor);
					}
				}
			}
		}
		if ( $start < M_PI && $stop > M_PI/2 ) 
		{
			$yy = 0;
			for ( $x = 0; $x >= $xStop; $x -= 1 ) 
			{
				if ( $x > $xStart )
					$y1 = $x/$xStart*$yStart;
				else
					$y1 = $h * sqrt( 1 - pow( $x,2 ) / pow( $w,2 ) );
			
				$y2 = $x/$xStop*$yStop;
				$d1 = $y1 - floor($y1);
				$d2 = $y2 - floor($y2);
				$y1 = floor($y1);
				$y2 = floor($y2);
				imageLine($img, $cx + $x, $cy - $y1, $cx + $x, $cy - $y2, $fillColor);
				$diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d1*100 );
				imageSetPixel($img, $cx + $x, $cy - $y1 - 1, $diffColor);
				$diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d2*100 );
				imageSetPixel($img, $cx + $x, $cy - $y2 + 1, $diffColor);
				for ( $yy; $yy <= $y1; $yy += 1 )
				{
					if ( $yy < $yStop )
						$x1 = -$yy/$yStop*$xStop;
					else
						$x1 = $w * sqrt( 1 - pow( $yy,2 ) / pow( $h,2 ) );
				
					$d1 = $x1 - floor($x1);
					$x1 = floor($x1);
					$diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d1*100 );
					imageSetPixel($img, $cx - $x1 - 1, $cy - $yy, $diffColor);
					if ( $start > M_PI/2 ) 
					{
						$x2 = $yy/$yStart*$xStart;
						$d2 = $x2 - floor($x2);
						$x2 = floor($x2);
						$diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d2*100 );
						imageSetPixel($img, $cx + $x2, $cy - $yy, $diffColor);
					}
				}
			}
		}
		
		$xStart = $w * cos(max(M_PI,$start));
		$yStart = $h * sin(max(M_PI,$start));
		$xStop = $w * cos($stop);
		$yStop = $h * sin($stop);
		if ( $start < 3*M_PI/2 && $stop > M_PI)
		{
			$yy = 0;
			for ( $x = 0; $x >= $xStart; $x -= 1 )
			{
				if ( $x > $xStop)
					$y1 = $x/$xStop*$yStop;
				else
					$y1 = -$h * sqrt( 1 - pow( $x,2 ) / pow( $w,2 ) );
				
				$y2 = $x/$xStart*$yStart;
				$d1 = $y1 - floor($y1);
				$d2 = $y2 - floor($y2);
				$y1 = floor($y1);
				$y2 = floor($y2);
				imageLine($img, $cx + $x, $cy - $y1, $cx + $x, $cy - $y2, $fillColor);
				$diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d1*100 );
				imageSetPixel($img, $cx + $x, $cy - $y1 + 1, $diffColor);
				$diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d2*100 );
				imageSetPixel($img, $cx + $x, $cy - $y2 - 1, $diffColor);
				for ( $yy; $yy >= $y1; $yy -= 1 ) 
				{
					if ( $yy > $yStart )
						$x1 = -$yy/$yStart*$xStart;
					else
						$x1 = $w * sqrt( 1 - pow( $yy,2 ) / pow( $h,2 ) );
					
					$d1 = $x1 - floor($x1);
					$x1 = floor($x1);
					$diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d1*100 );
					imageSetPixel($img, $cx - $x1 - 1, $cy - $yy, $diffColor);
					if ($stop < 3*M_PI/2)
					{
						$x2 = $yy/$yStop*$xStop;
						$d2 = $x2 - floor($x2);
						$x2 = floor($x2);
						$diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d2*100 );
						imageSetPixel($img, $cx + $x2 + 1, $cy - $yy, $diffColor);
					}
				}
			}
			
		}
		if ( $start < 2*M_PI && $stop > 3*M_PI/2 )
		{
			$yy = 0;
			for ( $x = 0; $x <= $xStop; $x += 1 )
			{
				if ( $x < $xStart )
					$y1 = $x/$xStart*$yStart;
				else
					$y1 = -$h * sqrt( 1 - pow( $x,2 ) / pow( $w,2 ) );
				
				$y2 = $x/$xStop*$yStop;
				$d1 = $y1 - floor($y1);
				$d2 = $y2 - floor($y2);
				$y1 = floor($y1);
				$y2 = floor($y2);
				imageLine($img, $cx + $x, $cy - $y1, $cx + $x, $cy - $y2, $fillColor);
				$diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d1*100 );
				imageSetPixel($img, $cx + $x, $cy - $y1 + 1, $diffColor);
				$diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d2*100 );
				imageSetPixel($img, $cx + $x, $cy - $y2 - 1, $diffColor);
				for ( $yy; $yy >= $y1; $yy -= 1 )
				{
					if ( $yy > $yStop )
						$x1 = $yy/$yStop*$xStop;
					else
						$x1 = $w * sqrt( 1 - pow( $yy,2 ) / pow( $h,2 ) );
					
					$d1 = $x1 - floor($x1);
					$x1 = floor($x1);
					$diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], 100 - $d1*100 );
					imageSetPixel($img, $cx + $x1 + 1, $cy - $yy, $diffColor);
					if ( $start > 3*M_PI/2 ) 
					{
						$x2 = $yy/$yStart*$xStart;
						$d2 = $x2 - floor($x2);
						$x2 = floor($x2);
						$diffColor = imageColorExactAlpha( $img, $color[0], $color[1], $color[2], $d2*100 );
						imageSetPixel($img, $cx + $x2 , $cy - $yy, $diffColor);
					}
				}
			}
		}
	}
	

}
?>