<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/

class Language
	{
	
	/**
    * languages dir
    * @access Private
    * @var string
    */
	var $path='languages/';
	
	/**
    * selected language
    * @access Private
    * @var string
    */
	var $lang;
	
	/**
    * array of language strings
    * @access Public
    * @var array
    */
	var $language;
	
	var $lang_all;

	/**
    * Set a language
    *
    * @param string $language
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return bool
    */	
	function setlanguage($language='italian')
	{
	if($this->language_exists($language))
		{
		$this->lang=$language;
		$this->load();
		return true;
		}
	else
		return false;
	}
	
	/**
    * check if a language exists
    *
    * @param string $language
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return bool
    */
	function language_exists($language)
		{
		return file_exists($this->path.$language.'/');
		}

	/**
    * load the selected array
    *
    * @param string $section
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return bool
    */		
	function load($add='')
		{
		if(file_exists($this->path.$this->lang.'/main'.$add.'.php'))
			require $this->path.$this->lang.'/main'.$add.'.php';
		else
			return false;
			
		$this->lang_all=$lang;
		//$this->language=$lang[$section]['main'];
		return true;
		}
		
	/**
    * return the lang in a xslt format
    *
    * @param string $section
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return bool
    */		
	function lang2xslt($section)
	{
		/*$temp='';
		
		while (list($chiave, $valore) = each($this->lang_all[$section])) 
   			$temp .= "<$chiave>$valore</$chiave>";
		
	return $temp;*/
	}

	/**
    * Load a specific array from a file
    *
    * @param string $file
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return bool
    */		
	function load_file($file)
		{
		if(file_exists($this->path.$this->lang.'/'.$file.'.php'))
			require $this->path.$this->lang.'/'.$file.'.php';
		else
			return false;
			
		$this->language=$lang;
		return true;
		}

	/**
    * Transform xml in a php file
    *
    * @param string $xml
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return nonr
    */	
	function xml2php($filelocation)
	{
		
		
		$contents = implode('', file($filelocation)); 
		$array = $this->xml2array($contents);
		
		$array = $array['array'];
		
		$namelang = $array['C']['index']['general']['language'];
		$authorlang = $array['C']['index']['general']['language'];
		
		if(file_exists('languages/'.$namelang))
			echo 'the '.$namelang.' languages exists';
		
		@mkdir('languages/'.$namelang,0777);
		
		for($u=0;$u<2; $u++)
		{
		$f=fopen('languages/'.$namelang.'/main.php','w');	
		fwrite($f,'<?php'."\n"."\n");
			$count=count($array['C']);
			
			$temp1=array_keys($array['C']);
				for($i=0;$i<$count;$i++) //main
				{
			
					$count2=count($array['C'][$temp1[$i]]);
					
					$temp2=array_keys($array['C'][$temp1[$i]]);
					
					
					
						for($j=0; $j<$count2;$j++) //forums
						{
							$count3=count($array['C'][$temp1[$i]][$temp2[$j]]); 
							$temp3=array_keys($array['C'][$temp1[$i]][$temp2[$j]]);
							
							fwrite($f,'$lang[\''.$temp1[$i].'\'][\''.$temp2[$j].'\'] = array(		'."\n\n");
							for($k=0; $k<$count3;$k++) //main
							{
							
								if( $k < ( $count3 - 1 ) )
										$temp=',';
									else
										$temp='';
								
									fwrite($f,'				\''.$temp3[$k].'\'		=>		\''.addslashes($array['C'][$temp1[$i]][$temp2[$j]][$temp3[$k]]).'\''.$temp."\n");
				
							}
								
							fwrite($f,'
											);'."\n\n");
						}
						
					
					
					
				}
			fwrite($f,'?>');
			fclose($f);
		}
		
		//errirs.php
				$count2=count($array['D']);
				$f=fopen('languages/'.$namelang.'/errors.php','w');	
				fwrite($f,'<?php'."\n"."\n");
				fwrite($f,'$lang = array(		'."\n\n");
				$temp4=array_keys($array['D']);
				for($k=0; $k<$count2;$k++) //main
				{
					if( $k < ( $count2 - 1 ) )
							$temp=',';
						else
							$temp='';
					
						fwrite($f,'				\''.$temp4[$k].'\'			=>		\''.addslashes($array['D'][$temp4[$k]]).'\''.$temp."\n");
	
				}
			fwrite($f,'
											);'."\n\n");
	
		return array($namelang, $namelang, $authorlang);
	}

	/**
    * Transform all php files in language directory in xml
    *
    * @param String $lang_name
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return String
    */	
	function php2xml($lang_name)
	{
		$num = 0;
		$dirpath = $this->path.$lang_name;
		require "$dirpath/main.php";
		$array[chr(67+$num++)]=$lang;
		require "$dirpath/errors.php";
		$array[chr(67+$num++)]=$lang;
				
		
		require 'inc/core_ext/assoc_array2xml.php';
		
		$string = $this->array2xml($array);
	
		return $string;
	}

	/**
    * Indent the code
    *
    * @param int $level
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return String
    */
	function indent($level)
	{
		$indent = "";
		for($ix = 1; $ix <= $level; $ix++)
		{
			$indent .= " ";
		}
		return("\n".$indent);
	}
	
	/**
    * Import a language file
    *
    * @param String $filelocation
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return none
    */
	function import_lang($filelocation)
	{
		
		$this->xml2php($filelocation);
		
	}
	
	/**
    * Export a language file
    *
    * @param String $string
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return File
    */
	function export_lang($string)
	{
		$xml=$this->php2xml($string);
		//if(strlen($xml)>7)
		$filelocation='lang_'.time().rand(0,150).'.xml';
		$f=fopen($filelocation,'w');
		fwrite($f,$xml);
		fclose($f);
		header('HTTP/1.1 200 OK');
		header('Date: ' . date("D M j G:i:s T Y"));
		header('Last-Modified: ' . date("D M j G:i:s T Y"));
		header("Content-Type: application/force-download"); // changed to force download
		header("Content-Lenght: " . (string)(filesize($filelocation)));
		header("Content-Transfer-Encoding: Binary"); // added
		header("Content-Disposition: attachment; filename=\"$filelocation\""); // added to remove spaces in filename when saving, it seemed to cause some problems with spaces.
		readfile($filelocation);
		unlink($filelocation);
		exit;
	}

	/**
    * Convert an array into the xml format
    *
    * @param array $array
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Private
    * @return String
    */	
	function array2xml($array)
	{
		
		$this->text="<?xml version=\"1.0\" encoding=\"iso-8859-1\"?><array>";
		$this->text.= $this->array_transform($array);
		$this->text .="</array>";
		return $this->text;
	}

	/**
    * Convert an array into the xml format
    *
    * @param array $array
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Private
    * @return String
    */	
	function array_transform($array)
	{
		//global $array_text;
		foreach($array as $key => $value)
		{
			if(!is_array($value))
				$this->text .= "<$key>$value</$key>";
			 else
			 {
				$this->text.="<$key>";
				 $this->array_transform($value);
				 $this->text.="</$key>";
			 }
		}
		return $array_text;

	}
	
	/**
    * Transform an XML string to associative array XML Parser Functions
    *
    * @param String $xml
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Private
    * @return array
    */
	function xml2array($xml)
	{
		$this->depth=-1;
		$this->xml_parser = xml_parser_create();
		xml_set_object($this->xml_parser, $this);
		xml_parser_set_option ($this->xml_parser,XML_OPTION_CASE_FOLDING,0);//Don't put tags uppercase
		xml_set_element_handler($this->xml_parser, "startElement", "endElement");
		xml_set_character_data_handler($this->xml_parser,"characterData");
		xml_parse($this->xml_parser,$xml,true);
		xml_parser_free($this->xml_parser);
		
		return $this->arrays[0];
	}

	/**
    * Start an element
    *
    * @param resource $parser
    * @param String $name	
	* @param String $attrs
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Private
    * @return none
    */	
	function startElement($parser, $name, $attrs)
	{
		$this->keys[]=$name; //We add a key
		$this->node_flag=1;
		$this->depth++;
	}

	/**
    * Put datas into element
    *
    * @param resource $parser
    * @param String $data
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Private
    * @return none
    */		
	function characterData($parser,$data)
	{
		$key=end($this->keys);
		$this->arrays[$this->depth][$key]=$data;
		
		$this->node_flag=0; //So that we don't add as an array, but as an element
	}

	/**
    * Start an element
    *
    * @param resource $parser
    * @param String $name	
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Private
    * @return none
    */		
	function endElement($parser, $name)
	{ 
		$key=array_pop($this->keys);
		//If $node_flag==1 we add as an array, if not, as an element
		if($this->node_flag==1)
		{
			$this->arrays[$this->depth][$key]=$this->arrays[$this->depth+1];
			unset($this->arrays[$this->depth+1]);
		}
		$this->node_flag=1;
		$this->depth--;
	}
		
}
?>