<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/
if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}

class Parse
{

	/**
	* stats_handler constructor
	*
	* @param array $classes
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return Void
	*/	
	function Parse()
	{
		require 'inc/core_ext/highlight.php';
	}
	
	/**
	* Strip forbidden tags and delegate tag-source check to removeEvilAttributes()
	*
	* @param string $source
	* @author tREXX <www.trexx.ch>
	* @since v 0.1
	* @access Public
	* @return string
	*/	
	function removeEvilTags($source)
	{
	   
	   return preg_replace('/<(.*?)>/ie', "'<'.$this->removeEvilAttributes('\\1').'>'", $source);
	}
	
	/**
	* Strip forbidden attributes from a tag
	*
	* @param string $source
	* @author tREXX <www.trexx.ch>
	* @since v 0.1
	* @access Public
	* @return string
	*/
	function removeEvilAttributes($tagSource)
	{
	   $stripAttrib = 'javascript:|onclick|ondblclick|onmousedown|onmouseup|onmouseover|'.
				   'onmousemove|onmouseout|onkeypress|onkeydown|onkeyup';
	   return stripslashes(preg_replace("/$stripAttrib/i", 'forbidden', $tagSource));
	}
		
			/**
    * prepare the text for insert
    *
    * @param string $text
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return String
    */		
	function prepare_post($text)
	{
		//---------------------------------
		// XSS FOBIAAA!!!!
		//---------------------------------			 
		$text = preg_replace('#</*(applet|meta|xml|blink|link|style|script|embed|object|iframe|frame|frameset|ilayer|layer|bgsound|title|base)[^>]*>#i',"",$text);			 
		$text = preg_replace('#(<[^>]+[\s\r\n\"\'])(on|xmlns)[^>]*>#iU',"$1>",$text);
		$text = preg_replace('#([a-z]*)[\x00-\x20]*=[\x00-\x20]*([\`\'\"]*)[\\x00-\x20]*j[\x00-\x20]*a[\x00-\x20]*v[\x00-\x20]*a[\x00-\x20]*s[\x00-\x20]*c[\x00-\x20]*r[\x00-\x20]*i[\x00-\x20]*p[\x00-\x20]*t[\x00-\x20]*:#iU','$1=$2nojavascript...',$text);
		$text = preg_replace('#([a-z]*)[\x00-\x20]*=([\'\"]*)[\x00-\x20]*v[\x00-\x20]*b[\x00-\x20]*s[\x00-\x20]*c[\x00-\x20]*r[\x00-\x20]*i[\x00-\x20]*p[\x00-\x20]*t[\x00-\x20]*:#iU','$1=$2novbscript...',$text);
		$text = preg_replace('#([a-z]*)[\x00-\x20]*=[\x00-\x20]*([\`\'\"]*)[\\x00-\x20]*j[\x00-\x20]*a[\x00-\x20]*v[\x00-\x20]*a[\x00-\x20]*s[\x00-\x20]*c[\x00-\x20]*r[\x00-\x20]*i[\x00-\x20]*p[\x00-\x20]*t[\x00-\x20]*:#iU','$1=$2nojavascript...',$text);
		$text = preg_replace('#([a-z]*)[\x00-\x20]*=([\'\"]*)[\x00-\x20]*v[\x00-\x20]*b[\x00-\x20]*s[\x00-\x20]*c[\x00-\x20]*r[\x00-\x20]*i[\x00-\x20]*p[\x00-\x20]*t[\x00-\x20]*:#iU','$1=$2novbscript...',$text);
	
		//$text = $this->limit_strlen($text);			
		$text = $this->removeEvilTags($text);
		//$text = htmlspecialchars($text);
		$text = nl2br($text);
		$text = stripslashes(stripslashes($text));
		
		/* LINK RECOGNIZE nofollow...
		if(preg_match_all('<\s*a\s+[^>]*href\s*=\s*[\"\']?([^\"\' >]+)[\"\' >]', $text, $links)
		{
		
		}*/
		
		/*if (preg_match_all ('/img[\s]+[^>]*?src[\s]?=[\s\"\']+(.*?)[\"\']+.*?>/', $text, $regs)) 
		{
			if(is_array($regs))
			{
			require 'inc/class_gd_ver.php';
			$gd= new gd_handler();
			$num=count($regs[1]);
			for($i=0;$i<$num;$i++)
			{
				list($width, $height, $type, $attr) = getimagesize($regs[1][$i]);
				if($width>400 || $height>300)
				{
					$extension=explode('.',$regs[1][$i]);
					$name=time().'.'.$extension[count($extension)-1];
					$gd->create_thumb($regs[1][$i], $name);
					$temp=$regs[0][$i];
					$regs[0][$i]=str_replace($regs[1][$i], 'uploads/images/thumb_'.$name, $regs[0][$i]);
					//add url of big image
					$text=str_replace('<'.$temp, '<a href="uploads/images/'.$regs[1][$i].'"><'.$regs[0][$i].'</a>', $text);
				}
			}
			
			}
		
			
		}*/
		
		$text=addslashes($text);
		
		return $text;
	}
		
	/**
    * Text parsing for posts
    *
    * @param string $string
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return string
    */
	function parse_bbcode_simple($string)
	{
		
		$patterns = array(
	
							'`\[b\](.+?)\[/b\]`is',
							'`\[i\](.+?)\[/i\]`is',
							'`\[u\](.+?)\[/u\]`is',
							'`\[strike\](.+?)\[/strike\]`is',
							'`\[color=#([0-9]{6})\](.+?)\[/color\]`is',
							'`\[email\](.+?)\[/email\]`is',
							'`\[img\](.+?)\[/img\]`is',
							'`\[url=([a-z0-9]+://)([\w\-]+\.([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^ \"\n\r\t<]*?)?)\](.*?)\[/url\]`si',
							'`\[url\]([a-z0-9]+?://){1}([\w\-]+\.([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^ \"\n\r\t<]*)?)\[/url\]`si',
							'`\[url\]((www|ftp)\.([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^ \"\n\r\t<]*?)?)\[/url\]`si',
							'`\[indent](.+?)\[/indent\]`is',
							'`\[size=([1-6]+)\](.+?)\[/size\]`is',
							'`\[color=(.+?)\](.+?)\[/color\]`is',
							"/^](http:\/\/|ftp:\/\/)([^\s,]*)/i"
	
						);
		
		$replaces =  array(
		
							'<strong>\\1</strong>',
							'<em>\\1</em>',
							'<span style="border-bottom: 1px dotted">\\1</span>',
							'<strike>\\1</strike>',
							'<span style="color:#\1;">\2</span>',
							'<a href="mailto:\1">\1</a>',
							'<img src="\1" alt="" style="border:0px;" />',
							'<a href="\1\2">\6</a>',
							'<a href="\1\2">\1\2</a>',
							'<a href="http://\1">\1</a>',
							'<pre>\\1</pre>',
							'<h\1>\2</h\1>',
							'<span style="color:\1">\2</span>',
							"<a href='$1$2' rel=\"nofollow\">$1$2</a>"
							);

		$string = preg_replace($patterns, $replaces , $string);
		return $string;
	}	
	/**
    * Text parsing for posts
    *
    * @param string $string
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return string
    */
	function parse_bbcode($string)
	{
		

		$patterns = array(
	
							'`\[b\](.+?)\[/b\]`is',
							'`\[i\](.+?)\[/i\]`is',
							'`\[u\](.+?)\[/u\]`is',
							'`\[strike\](.+?)\[/strike\]`is',
							'`\[color=#([0-9]{6})\](.+?)\[/color\]`is',
							'`\[email\](.+?)\[/email\]`is',
							'`\[img\](.+?)\[/img\]`is',
							'`\[url=([a-z0-9]+://)([\w\-]+\.([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^ \"\n\r\t<]*?)?)\](.*?)\[/url\]`si',
							'`\[url\]([a-z0-9]+?://){1}([\w\-]+\.([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^ \"\n\r\t<]*)?)\[/url\]`si',
							'`\[url\]((www|ftp)\.([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^ \"\n\r\t<]*?)?)\[/url\]`si',
							'/\[align\=(left|center|right)\](.*?)\[\/align\]/is',  
							'`\[indent](.+?)\[/indent\]`is',
							'`\[size=([1-6]+)\](.+?)\[/size\]`is',
							"#\[code(=(.*?))?\](.*?)\[/code\]#se",
							'`\[quote\](.+?)\[/quote\]`is',
							'`\[color=(.+?)\](.+?)\[/color\]`is',
							"/^](http:\/\/|ftp:\/\/)([^\s,]*)/i",
							'`\[youtube\](.+?)\[/youtube\]`is',
						);
		
		$replaces =  array(
		
							'<strong>\\1</strong>',
							'<em>\\1</em>',
							'<span style="border-bottom: 1px dotted">\\1</span>',
							'<strike>\\1</strike>',
							'<span style="color:#\1;">\2</span>',
							'<a href="mailto:\1" rel="nofollow">\1</a>',
							'<img src="\1" alt="" style="border:0px;" />',
							'<a href="\1\2" rel="nofollow">\6</a>',
							'<a href="\1\2" rel="nofollow">\1\2</a>',
							'<a href="http://\1" rel="nofollow">\1</a>',
							'<div style="text-align: $1;">$2</div>',  
							'<pre>\\1</pre>',
							'<h\1>\2</h\1>',
							"'$2<div class=\"board-topic-code-title\">Code</div>
			<div class=\"board-topic-code\">'.(('$2' == 'PHP') ? highlight_string(str_replace('<br />','',html_entity_decode(stripslashes('<?php $3'), ENT_QUOTES)), true) : syntax_highlight(str_replace('<br />','',html_entity_decode(stripslashes('$3'), ENT_QUOTES)), '$2')).'</div>'",
							'<div class="board-topic-quote-title">Quote</div><div class="board-topic-quote"><em>$1</em></div>',
							'<span style="color:\1">\2</span>',
							"<a href='$1$2' rel=\"nofollow\">$1$2</a>",
							"<object type=\"application/x-shockwave-flash\" style=\"width: 425px; height:350px;\" data=\"\\1\">
							<param name=\"movie\" value=\"\\1\" /><param name=\"wmode\" value=\"transparent\" /></object>"
							);

		$string = preg_replace($patterns, $replaces , $string);
		$string = $this->bbcode_quote($string);
		return $string;
	}
	
	/**
    * Text parsing for quotes
    *
    * @param string $string
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return string
    */	
	function bbcode_quote ($str)
	{  
		$open = '</p><div class="board-topic-quote-title">Quote $1</div><div class="board-topic-quote"><em>';  
		$close = '</em></div><p>';  
	  
		// How often is the open tag?  
		preg_match_all ('/\[quote=&quot;(.*?)&quot;\]/i', $str, $matches);  
		$opentags = count($matches['0']);  
	  
		// How often is the close tag?  
		preg_match_all ('/\[\/quote\]/i', $str, $matches);  
		$closetags = count($matches['0']);  
	  
		// Check how many tags have been unclosed  
		// And add the unclosing tag at the end of the message  
		$unclosed = $opentags - $closetags;  
		for ($i = 0; $i < $unclosed; $i++)
			$str .= '</div></blockquote>';   
	  
		// Do replacement  
		$str = preg_replace ('/\[quote=&quot;(.*?)&quot;\]/is', $open, $str);  
		$str = str_replace ('[/' . 'quote]', $close, $str);  
	  
		return $str;  
	} 


	/**
    * Text parsing for posts
    *
    * @param string $string
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return string
    */
	function remove_bbcode($string)
	{
		
		return preg_replace("[\[(.*?)\]]", "", strip_tags($string));
	}

}

?>