<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/

if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}

class Search
{
	
	/**
    * Database connection class
    * @access Private
    * @var class
    */
	var $db;
	
	/**
    * Skin class
    * @access Private
    * @var class
    */
	var $skin;
	
	/**
    * Error handler class
    * @access Private
    * @var class
    */
	var $error;
	
	/**
    * config array
    * @access Public
    * @var array()
    */
	var $_config;
	
	/**
    * Search Constructor
    *
    * @param class $classes
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return none
    */
	function Search( & $db, & $skin, & $error, & $_config)
	{
		
		$this->db= & $db;
		$this->skin= & $skin;
		$this->error= & $error;
		$this->_config= & $_config;
			
	}
		
	/**
    * Do a fast thread search
    *
    * @param String $string
    * @param Integer $start
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return none
    */	
	function fast_thread_search($string, $start, $stop)
	{
	if($start > '0')
		$str = ($start - 1)*$stop;
	else
		$str = 0;
		
		//$string = $this->prepare_sstring($string);
		
		
		$query = $this->db->execQuery($this->prepare_query('revokebb_posts.text', $string, 0, array($str, $stop) ));
		
		
		while($vett = $this->db->fetch_array($query))
		{
			if($vett['sticky']==1)
					$vett['title']='In Rilievo: '.$vett['title']; 
				
				$vett['datelinesav']=$vett['dateline']; 
				
				$vett['dateline']=gmdate('d-m-Y H:i:s',$vett['dateline']);
				
				if($this->user->info_user['user_id']<1)
				{
					if($vett['closed']==1)
						$vett['state']=8;
					else
						$vett['state']=2;
				}
				else
				{
					if($vett['closed']==1)
						$vett['state']=8;
					else
						if($vett['moved_id']!=0)
							$vett['state']=7;
						else
						{
							if($this->user->info_user['lastaction']>($vett['datelinesav']+10000))
								$vett['state']=2;
							else
								$vett['state']=1;
						
							if($vett['poolid']!=0)
								$vett['state']=$vett['state']+4;
							else
								if($vett['reply']>=100)
								$vett['state']=$vett['state']+2;
						}
				
				} 
				 
				
				$vett['text'] = substr(strip_tags(html_entity_decode(stripslashes($vett['text']))),0,60);
			
				if(false == isset($top_score) && isset($vett['score']))
				{
					$top_score = $vett['score'];
				}
	
				if(isset($vett['score']))
				{
				   $vett['score'] = round($vett['score'] / $top_score * 100);
				}
			
				$all_vett[]=$vett;
		}
		
		$query = $this->db->execQuery($this->prepare_query('revokebb_posts.text', $string, 0, array($str, $stop), 0 ));
		$tot = $this->db->num_rows($query);
		
		$this->skin->assign('num_threads', $tot);	
		$this->skin->assign('threads', $all_vett);
		$this->skin->assign('search', 1);
		$this->skin->assign('form', '<form action="'.$this->_config['board_domain'].$this->_config['board_url'].'index.php?search" method="post">');
		$this->skin->assign('formpost', '</form>');
		$this->skin->assign('page', $this->skin->generate_pagination($this->_config['board_domain'].$this->_config['board_url'].'index.php?search&amp;search='.$search_name, $tot, $stop, $start));
		$this->skin->assign('hid', "<input type='hidden' value='".$string."' name='search' />");
		
		
	}

	/**
    * Full thread serach (advanced)
    *
    * @param String $string
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return none
    */		
	function full_thread_search($string, $nam, $match, $oby, $typ, $dat, $start, $stop, $frm, $search_name, $frum)
	{
		$arr['typ'] = $typ;
		$arr['start'] = $start;
		$arr['mpp'] = $stop;
		$arr['oby'] = $oby;
		$arr['dat'] = $dat;
		$arr['frm'] = $frm;
		
		/*$query = $this->db->execQuery($this->db->sql_build('fetch_search_cache', array(md5($search_name.$search_string.$dat.$start.$stop), addslashes(serialize($arr)),$start) ));*/
			
		/*if($this->db->num_rows($query) == 1)
		{
			$temp = $this->db->fetch_array($query);
			$all_vett = unserialize(stripslashes($temp['query_cache']));
		}
		else
		{*/ 
			if(strlen($string)<4 && strlen($search_name)>2)
				$query = $this->db->execQuery($this->prepare_query('', '', 1, array($dat, $nam, $oby, $typ, $start, $stop ) ));
			else
				{
				
				$query = $this->db->execQuery($this->prepare_query($match, $string, 2, array($dat, $nam, 'revokebb_threads.thread_id', $typ, $start, $stop ) ));
				//$query = $this->db->execQuery($this->db->sql_build('full_search_topics', array($match, $string, $match, $string, $dat, $nam, $frm, $oby, $typ, $str, $stop ) ));
				
				}
			
			while($vett = $this->db->fetch_array($query))
			{
				if($vett['sticky']==1)
						$vett['title']='In Rilievo: '.$vett['title']; 
					
					$vett['datelinesav']=$vett['dateline']; 
					
					$vett['dateline']=gmdate('d-m-Y H:i:s',$vett['dateline']);
					
					if($this->user->info_user['user_id']<1)
					{
						if($vett['closed']==1)
							$vett['state']=8;
						else
							$vett['state']=2;
					}
					else
					{
						if($vett['closed']==1)
							$vett['state']=8;
						else
							if($vett['moved_id']!=0)
								$vett['state']=7;
							else
							{
								if($this->user->info_user['lastaction']>($vett['datelinesav']+10000))
									$vett['state']=2;
								else
									$vett['state']=1;
							
								if($vett['poolid']!=0)
									$vett['state']=$vett['state']+4;
								else
									if($vett['reply']>=100)
									$vett['state']=$vett['state']+2;
							}
					
					} 
					 
					
					$vett['text'] = substr(strip_tags(html_entity_decode(stripslashes($vett['text']))),0,60);
				
					if(false == isset($top_score) && isset($vett['score']))
					{
						$top_score = $vett['score'];
					}
		
					if(isset($vett['score']))
					{
					   $vett['score'] = round($vett['score'] / $top_score * 100);
					}
				
					$all_vett[]=$vett;
			}
			/*$this->db->execQuery($this->db->sql_build('insert_search_cache', array(md5($search_name.$search_string.$dat.$start.$stop),time(),addslashes(serialize($arr)), $this->user->info_user['user_id'], $_SERVER['REMOTE_ADDR'], addslashes(serialize($all_vett)), $start) ));
			}*/
		
		if(strlen($string)<4 && strlen($search_name)>2)
			$query = $this->db->execQuery($this->prepare_query('', '', 1, array($dat, $nam, $oby, $typ, $start, $stop ),0 ));
		else
			$query = $this->db->execQuery($this->prepare_query($match, $string, 2, array($dat, $nam, 'revokebb_threads.thread_id', $typ, $start, $stop ),0 ));
			
		
		$tot = $this->db->num_rows($query);
		
		
		
		$this->skin->assign('num_threads', $tot);	
		$this->skin->assign('threads', $all_vett);
		$this->skin->assign('search', 1);
		$this->skin->assign('page', $this->skin->generate_pagination($this->_config['board_domain'].$this->_config['board_url'].'index.php?search&amp;search_name='.$search_name.'&amp;typ='.$typ.'&amp;oby='.$oby.'&amp;mpp='.$stop.'&amp;dat='.$dat.'&amp;frum='.$frum.'&amp;start=', $tot, $stop, $start));
	}
	

	function prepare_post($match, $string)
	{
		if(strlen($string)>2)
		{
			$array = explode(', ',$match);
			$str_array = explode(' ',$string);
			$string = ' ';
			$num_match = count($array);
			$num_str = count($str_array);
			for($i=0;$i<$num_match;$i++)
			{
				for($j=0;$j<$num_str;$j++)
				{
					$string .= $array[$i].' LIKE \'%'.$str_array[$j].'%\' AND ';
				}	
			}
			$string = substr($string,0,-5);
		}
		return $string;
	}
	
	function prepare_query($match, $string, $type, $array_others, $limit=1)
	{
		$add=array(); 
		switch($this->file_config['dbtype'])
		{
			case 'mysqli': 
						$add[0] = ', MATCH ('.$match.') AGAINST ( \''.$string.'\') as score ';
						$add[1] = ' MATCH ('.$match.') AGAINST (  \''.$string.'\' IN BOOLEAN MODE) ';
						$add[2] = ' HAVING  score > 0.2 ';
						$add[3] = 'score Desc,';
						break;
			default: 	$add[0] = ''; 
						$add[1] = $this->prepare_post($match, $string);
						$add[2] = '';
						$add[3] = '';
						break;
		
		}
		
		//print_r($add); 
					
		switch($type)
		{
			//simple search
			case '0': 	
					$tables = 'revokebb_threads.thread_id, revokebb_threads.title, revokebb_threads.lastposterid,
					revokebb_threads.lastposter, revokebb_threads.pollid, revokebb_threads.forumid,
					revokebb_threads.postusername, revokebb_threads.postuserid, revokebb_threads.dateline,
					revokebb_threads.reply, revokebb_threads.visible, revokebb_threads.sticky,
					revokebb_threads.views, revokebb_threads.closed, revokebb_threads.firstpostid,
					revokebb_posts.text, revokebb_posts.post_id, revokebb_posts.upload';
				$from = 'revokebb_threads Inner Join revokebb_posts ON revokebb_posts.thread_id =
					revokebb_threads.thread_id';
				$where = '';
				$group='GROUP BY
revokebb_threads.thread_id ';
				if($limit!=0)
					$others = ' LIMIT '.$array_others[0].','.$array_others[1];
				else
					$others='';
				break;
			//full name and nick
			case '1': 
				$tables = 'revokebb_threads.thread_id, revokebb_threads.title, revokebb_threads.lastposterid, revokebb_threads.lastposter, revokebb_threads.pollid, revokebb_threads.forumid, revokebb_threads.postusername, revokebb_threads.postuserid, revokebb_threads.dateline, revokebb_threads.reply, revokebb_threads.visible, revokebb_threads.sticky,
	revokebb_threads.views, revokebb_threads.closed, revokebb_threads.firstpostid, revokebb_posts.text, revokebb_posts.upload, revokebb_posts.post_id';
			
			$from = 'revokebb_threads
Inner Join revokebb_posts ON revokebb_posts.thread_id =
revokebb_threads.thread_id';
			$where = 'revokebb_threads.dateline > '.$array_others[0].' AND '. $array_others[1].' ';
			
				$group='GROUP BY
revokebb_threads.thread_id ';

			if($limit!=0)
				$others = 'Order By '.$add[3].'
'.$array_others[2].' '.$array_others[3].',
revokebb_threads.last_update Desc LIMIT '.$array_others[4].','.$array_others[5];
			else
				$others='';
			break;
			//full search
			case '2': 
		
			$tables = 'revokebb_threads.thread_id, revokebb_threads.title, revokebb_threads.lastposterid, revokebb_threads.lastposter, revokebb_threads.pollid, revokebb_threads.forumid, revokebb_threads.postusername, revokebb_threads.postuserid, revokebb_threads.dateline, revokebb_threads.reply, revokebb_threads.visible, revokebb_threads.sticky,
revokebb_threads.views, revokebb_threads.closed, revokebb_threads.firstpostid, revokebb_posts.text, revokebb_posts.upload, revokebb_posts.post_id';
			
						$from = 'revokebb_threads
Inner Join revokebb_posts ON revokebb_posts.thread_id =
revokebb_threads.thread_id';
						$where = 'revokebb_threads.dateline > '.$array_others[0].' AND '. $array_others[1].' AND ';
					
				$group='GROUP BY
revokebb_threads.thread_id ';
						if($limit!=0)
							$others =  'Order By '.$add[3].'
'.$array_others[2].' '.$array_others[3].',
revokebb_threads.last_update Desc LIMIT '.$array_others[4].','.$array_others[5];
						else
							$others='';
						break;

		}
		if($group=='' && $add[2]!='')
			$group = 'GROUP BY';
		//echo 'Select '.$tables.$add[0].' From '.$from.' Where '.$where.$add[1].' '.$group.$add[2].$others.'<br>';
		return 'Select '.$tables.$add[0].' From '.$from.' Where '.$where.$add[1].' '.$group.$add[2].$others;
	
	}
	
	
	
}


?>