<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/
if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}

class stats_handler
{
	/**
    * Skin class
    * @access Private
    * @var class
    */
	var $skin;

	/**
    * Database connection class
    * @access Private
    * @var class
    */
	var $db;

	/**
	* stats_handler constructor
	*
	* @param array $classes
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return Void
	*/	
	function stats_handler( & $skin, & $db)
	{
		require 'inc/class_gd_ver.php';
		
		$this->skin = & $skin;
		$this->db = & $db;
		
		$this->gd = new gd_handler();
	}
	
	/**
	* cake_graph generator for posts
	*
	* @param int $posts
	* @param int $total
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return Void
	*/	
	function cake_posts($posts, $total)
	{
		
		// create image
		$img = imagecreatetruecolor( 310, 100 );
		// allocate some solors
		$background    = imagecolorallocate($img, 233, 238, 248);
		$black = imagecolorallocate($img, 0x00, 0x00, 0x00);
		
		imagefill($img,0,0, $background);
		// make the 3D effect
		for ($i = 40; $i < 50; $i++) {
		   $this->gd->imageSmoothArc(&$img, 70, $i, 100, 50, array(145, 176, 104), 0, 0.25*M_PI );
		   $this->gd->imageSmoothArc(&$img, 70, $i, 100, 50, array(145, 176, 104), 0.25*M_PI, 0.41*M_PI );
		   $this->gd->imageSmoothArc(&$img, 70, $i, 100, 50, array(145, 176, 104),0.41*M_PI, 2*M_PI);
		}
		
		//imageSmoothArc( &$img, 170, 130, 100, 50, array(254, 50, 0), 45, 55  );
		$asd = (2*M_PI*($posts-0))/$total;
		$perc = floor((100*($posts))/$total);
		$this->gd->imageSmoothArc( &$img, 70, 40, 100, 50, array(255, 164, 52), 0, $asd);
		$this->gd->imageSmoothArc( &$img, 70, 40, 100, 50, array(183, 217, 120), $asd, 2*M_PI );
		imagestring ( &$img, 2, 120, 10, $perc.'%' , $black);
		imagestring ( &$img, 2, 130, 40, (100-$perc).'%' , $black);
		imagerectangle ( &$img, 160, 10, 300, 60, $black );
		//your posts
		imagerectangle ( &$img, 170, 20, 180, 30, $black );
		imagefilledrectangle ( &$img, 171, 21, 179, 29, imagecolorallocate($img, 255, 164, 52) );
		imagestring ( &$img, 2, 190, 19, 'Your posts' , $black);
		//your posts
		imagerectangle ( &$img, 170, 40, 180, 50, $black );
		imagefilledrectangle ( &$img, 171, 41, 179, 49, imagecolorallocate($img, 183, 217, 120) );
		imagestring ( &$img, 2, 190, 39, 'Total posts' , $black);
		
		header( 'Content-Type: image/png' );
		imagepng( $img );
	}
		
	/**
	* week posts graph
	*
	* @param int $graph
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return Void
	*/	
	function week_posts($graph=0)
	{
		$this->date_graph($graph, 1);
	}

	/**
	* month posts graph
	*
	* @param int $graph
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return Void
	*/	
	function month_posts($graph=0)
	{
		$this->date_graph($graph, 2);
	}

	/**
	* year posts graph
	*
	* @param int $graph
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return Void
	*/	
	function year_posts($graph=0)
	{
		$this->date_graph($graph, 3);
	}

	/**
	* date
	*
	* @param int $graph
	* @param int $mode
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return Void
	*/
	function date_graph($graph, $mode)
	{
		switch($mode)
		{
		case 1: {
		$NUM=7;
				$tuttedate = array_fill(0,7,0);
					
				$arr = getdate();
				if($arr['wday'] == 0)
					$arr['wday'] = 7;
				
				$prec = mktime(0,0,0,$arr['mon'],($arr['mday']-$arr['wday'])+1,$arr['year']);
				
				$thisday = date('w');
				
				
				$query = $this->db->execQuery($this->db->sql_build('fetch_posts_dateline', array('%w', time(), $prec) ));
				while($array=$this->db->fetch_array($query))
				{
					$tuttedate[intval($array['lol'])] = $array['posts'];
				}
				
		
				if($graph==0)
				{
					for($i=0; $i<7; $i++)
						$vett[$i]['num']=$tuttedate[($i+1)%7];
					$temp_lang = explode('-', $this->lang->lang_all['admincp']['stats']['days']);
				}
				else
				{	
					$save = array_shift($tuttedate);
					
					$tuttedate[] = $save;
					$_GET['uKeys'] = 'Mon-Tue-Wed-Thu-Fri-Sat-Sun';
				}
				
			}break;
		case 2: {
		
				$arr = getdate();
				
				$NUM=$arr['mday'];
				$tuttedate = array_fill(0,$NUM,0);
					
				
				if($arr['wday'] == 0)
					$arr['wday'] = 7;
				
				$prec = mktime(0,0,0,$arr['mon'],1,$arr['year']);
				
				
				$query = $this->db->execQuery($this->db->sql_build('fetch_posts_dateline', array('%d', time(), $prec) ));
				
				while($array=$this->db->fetch_array($query))
				{
					$tuttedate[intval($array['lol'])] = $array['posts'];
				}
				
				$ukeys = array(1);
				
				for($i=1; $i< $NUM; $i++)
					$ukeys[$i] = $ukeys[$i-1]+1;
		
				if($graph!=0)
					$_GET['uKeys'] = '   '.implode('-   ', $ukeys); 
					//$_GET['uKeys'] = 'Jan-Feb-Mar-Apr-May-Jun-Jul-Aug-Sep-Oct-Nov-Dec ';
					
				$ukeys = array(1);
				for($i=1; $i< $NUM; $i++)
					$ukeys[$i] = $ukeys[$i-1]+1;
					
				$temp_lang = $ukeys;
				
				for($i=0; $i< $NUM ; $i++)
					$vett[$i]['num']=$tuttedate[$i];
					
				
				
			}break;
			case 3: {
		
				$arr = getdate();
				
				$NUM=$arr['mon'];
				$tuttedate = array_fill(0,$NUM,0);
					
				
				if($arr['wday'] == 0)
					$arr['wday'] = 7;
					
				$prec = mktime(0,0,0,1,1,$arr['year']);
				
				
				$query = $this->db->execQuery($this->db->sql_build('fetch_posts_dateline', array('%m',time(), $prec) ));
				
				while($array=$this->db->fetch_array($query))
				{
					$tuttedate[intval($array['lol'])-1] = $array['posts'];	
				}
				
				
				
				$ukeys = array(2006);
				
				for($i=1; $i< $NUM; $i++)
					$ukeys[$i] = $ukeys[$i-1]+1;
					
				if($graph!=0)
					$_GET['uKeys'] = '   '.implode('-   ', $ukeys); 
					//$_GET['uKeys'] = 'Jan-Feb-Mar-Apr-May-Jun-Jul-Aug-Sep-Oct-Nov-Dec ';
					
				$ukeys = array(1);
				for($i=1; $i< $arr['mon']; $i++)
					$ukeys[$i] = $ukeys[$i-1]+1;
					
				$temp_lang = $ukeys;
				
				for($i=0; $i<$NUM ; $i++)
					$vett[$i]['num']=$tuttedate[$i]; 
				
			}break;	
		}	
		
				
				if($graph==0)
				{

					for($i=0;$i<$NUM;$i++)
						$vett[$i]['day']= $temp_lang[$i];
						
					$vett[0]['score'] = '--';
	
					for($i=1;$i<$NUM;$i++)
					{
						if($vett[$i-1]['num'] != 0)
							$vett[$i]['score']=round(($vett[$i]['num']-$vett[$i-1]['num'])/$vett[$i-1]['num']*100,1);
						else
							$vett[$i]['score'] = $vett[$i]['num']*100;
							
						if($vett[$i]['score']>=0)
							$vett[$i]['score'] = '+'.$vett[$i]['score'];
						
					}
					$this->skin->assign('stat1',$vett);
					
				}
				else
				{
					if(array_sum($tuttedate) == 0)
					{
						$img = new graph3D(350,220);
						
						$img->drawRow('No datas to draw the graph');
						
						$img->show();
						exit;
					}
					
					$ukeys = array(1);
					for($i=1; $i< $NUM; $i++)
						$ukeys[$i] = $ukeys[$i-1]+1;
					
					$_GET['tNums'] = implode('-',$tuttedate);;
					$_GET['uNums'] = implode('-', array_fill(0, $NUM,0));
					$_GET['tKeys'] = implode('-', $ukeys);
				
				} 
	}


}

?>