<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/
	
class database
	{
	/**
    * database connection
    * @access Private
    * @var ?
    */
	var $db;
	
	/**
    * Connection configs
    * @access Private
    * @var array->string
    */
	var $config;
	
	/**
    * Working uery
    * @access Private
    * @var ?
    */
	var $now_query;
	
	/**
    * number of executed queries
    * @access Public
    * @var int
    */
	var $num_query;
	
	/**
    * Database Constructor
    *
    * @param None
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */
	function database($CONFIG)
		{
		$this->db=0;
		$this->now_query=0;
		$this->num_query=0;
		
		$this->config=$CONFIG;
		}
	
	/**
    * Connect to database
    *
    * @param string $database
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */
	function connect()
		{
		$this->db=sqlite_open('C:\Programmi\xampp\apache\bin\\'.$this->config['dbname']);
		echo $sqliteerror;
		if(!is_resource($this->db))
			{
			echo 'Errore connessione database';
			exit;
			}
		
		}

	/**
    * close the database connection
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */		
	function disconnect(){
		sqlite_close($this->db);
	}
	
	/**
    * Switch database
    *
    * @param string $database
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */	
	function switch_db($database)
		{
		/*if(!mysql_select_db($database,$this->db))
			{
			echo 'Selezione database fallita';
			exit;
			}*/
		}
	
	
	/**
    * Execute a query
    *
    * @param ? $query
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */
	function execQuery($query)
		{
		$this->num_query=$this->num_query+1;
		if($this->config['prefix'] != 'revokebb_')
			$query = str_replace('revokebb_', $this->config['prefix'], $query);
			
		$query2=sqlite_query($this->db,$query);
		if(!$query2 || $query2 == NULL)
			{
			echo 'Unable to Perform the query: '.$query.'<br>'.sqlite_error_string(sqlite_last_error($this->db));
			exit;
			}
		else
		return $query2;
		}
		
	/**
    * Put the results in an array
    *
    * @param ? $query
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return array()
    */
	function fetch_array($query)
		{
		return $this->clearname(sqlite_fetch_array($query, SQLITE_ASSOC));
		}

	/**
    * Return the num of the rows selected
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return integer
    */
	function num_rows($query)
	{
		return sqlite_num_rows($query);
	}
		
	function insert_id()
	{
		return sqlite_last_insert_rowid($this->db);
	}


	/**
    * This function runs the template through sprintf and passes any given parameters.
    *
    * @param string $template, array $params
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return ?query
    */		
	function sql_build($template, $params=array()) 
	{
	  	require 'sqlite_queries.php';
	  	if (isset($sql_templates[$template])) 
			{
			// TODO: verify given parameter count matches params for template.
			if (is_array($params)) 
				{
		  		$sql = vsprintf($sql_templates[$template], $params);
				} 
			else 
				{
		  		$sql = sprintf($sql_templates[$template], $params);
				}
			return $sql;
	  		}
	  	return false;
	}

	/**
    * Clear the table names (revokebb_threads.title)... to title
    *
    * @param array() $array
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return array()
    */			
	function clearname($array)
	{

		if(is_array($array))
			foreach ($array as $key => $value)
			{
				//if you want to keep the old element with its key remove the following line
				unset($array[$key]);
	
				//now we clean the key from the dot and tablename (alise) and set the new element
				if(strstr($key,'.'))
					$key = substr($key, strpos($key, '.')+1);
				$array[$key] = $value;
			}
		return $array;
	}

	/**
    * Return the mysql version infos
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return array()
    */	
	function info_version()
	{
	return sqlite_libversion();
	
	}
	
	/**
    * Close the mysql connection
    *
    * @param none
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return void
    */	
	function close()
	{
	return sqlite_close($this->db);
	
	}
	
	function fatal_error($query)
	{
		echo '<html><head><title>RevokeBB Fatal error</title></head><body><div align="center"><p>&nbsp;</p><h3>Error!</h3>
<p>&nbsp;</p>
<div style="font-size:12px; font-family:verdana; width:500px; padding: 2px; color: #F40000; margin: 2px; background-color: #FFC4C4; border: 1px solid #F40000;">Error on query: '.$query.'<br />'.mysql_error().'</div></div></body></html>';
		exit;
	}


}

 
?>