<?php
	/*
		This code is under Common Creative Lesser Gnu Public License
		For more infos please go to this address:
		http://creativecommons.org/licenses/LGPL/2.1/
		
		+--------------------------------+
		|   DO NOT MODIFY THIS HEADERS   |
		+--------------------------------+---------------+
		|   Written by daniele_dll                       |
		|   Email: daniele_dll@yahoo.it                  |
		|   WebSite: www.phpsoft.it - forum.phpsoft.it   |
		+------------------------------------------------+
		
		+--------------------------------------------------------------------------------+
		|   Version: 1.0 RC2, Relased at 13/09/2004 19:23 (GMT + 1 + Day Light Saving)   |
		+--------------------------------------------------------------------------------+
		
		+----------------+
		|   Requisites   |
		+----------------+-----+
		|   MySQL => 3.23.28   |
		|     PHP => 4.00.06   |
		+----------------------+
		
		+------------+
		|  Credits   |
		+------------+--------------------------------------------------------------------------+
		|   - Thanks to GM that have helped me with Reg Exp to delete comments, very hard! :D   |
		|   - Thanks to GM for headers in MySQL_DumpDB::download_dump method                    |
		+---------------------------------------------------------------------------------------+
	*/
	
	// Set debug mode True or False
	$CONF_DEBUG_MODE = FALSE;
	
	// Check Debug Mode
	if ($CONF_DEBUG_MODE == TRUE) {
		
		// Set error reporting
		error_reporting(E_ALL);
		
	}
	
	class MySQL_DumpDB {
	
		// List of tables to dump
		// Each element of this array contain arrays. Keys of this array are
		//	- name
		//	- params
		var $_TABLES = array();
		
		// Comments:
		//	- HEADER	
		//	- FOOTER	
		//	- USE	
		var $_COMMENTS = array(
			"header" => "",
			"footer" => "",
			"use" => ""
		);
	
		// Selected Database
		var $selected_db = "";
	
		// This var content DB DUMP
		var $db_dump = "";
		
		var $db;
	
		/**
		 * MySQL_DumpDB::MySQL_DumpDB()
		 * Constructor
		 * 
		 * @return 
		 */
		function MySQL_DumpDB(& $db) {
			$this->__default_COMMENT();
			$this->db = & $db;
		}
		
		/**
		 * MySQL_DumpDB::select_db()
		 * Select Database
		 * 
		 * @param $dbname			// @string	Name of database. MUST EXISTS
		 * @param $reset_anyway		// @boolean if TRUE, change db if table list isn't empty
		 * 							//			default is FALSE
		 * 
		 * @return 					// @boolean	Return TRUE if it can change, if not FALSE
		 */
		function select_db($dbname, $reset_anyway = FALSE) {
		
			// Check if $dbname var isin't empty or if table list isn't empty
			// If is selected...and RESET ANYWAY is TRUE, change database
			
			if ((!isset($dbname) || !$dbname) || (isset($this->selected_db) && $this->selected_db && count($this->_TABLES) > 0  && $reset_anyway)) {
			
				// If one of these conditions is FALSE, get out
				return FALSE;
			}
	
			// Check if DB Exists
			$query = $this->db->execQuery("SHOW DATABASES LIKE \"{$dbname}\"");
	
			// Get the number of lines returned from query
			if ($this->db->num_rows($query) != 1) {
			
				// If the number returned isn't equal at 1, there is an error!
				// If ZERO database don't exists
				// If MORE THAN ONE there is more than a database. so it can't select DB!
				return FALSE;
			}
	
			// If all OK select new DB
			$res = mysql_select_db($dbname);
			
			// Check for errors
			if (!$res) {
			
				// If mysql return an error get out
				return FALSE;
			}
	
			// All OK! Set DB NAME and empty TABLE LIST
			$this->selected_db = $dbname;
	
			// Empty Table Array
			$_TABLES = NULL;
			$_TABLES = array();
			
			// get out
			return TRUE;
		}
		
		/**
		 * MySQL_DumpDB::define_COMMENT()
		 * Define Comments in DATABASE DUMP
		 * 
		 * @param $type				// @string	Name of the COMMENT TYPE
		 * @param $content			// @string	Content of the selected comment
		 * @return 					// @boolean	Return TRUE if is all Ok, if not return FALSE
		 */
		function define_COMMENT($type, $content) {
		
			// Check if $type and $content aren't empty
			if ((!isset($type) || !$type) || (!isset($content) || !$content)) {
			
				// If yes get out
				return FALSE;
			}
			
			// Convert to lower type string
			$type = strtolower($type);
			
			// Check for this type of comment in KEYS list
			if (!in_array($type, array_keys($this->_COMMENTS))) {
		
				// If not return false
				return FALSE;
			}
			
			// If yes return TRUE
			$this->_COMMENTS[$type] = $content;
			
			// Get out
			return TRUE;
		}
		
		/**
		 * MySQL_DumpDB::add_tables()
		 * Add one or more tables to TABLE LIST
		 * 
		 * @param $tbl_mixed			// @array\@string	this must contain an array or a
		 * 								//					string. If string only one table
		 * 								//					If array more tables
		 * 								//					If array element has a sub array
		 * 								//					with two or three elements these
		 *								//					must be in this order (lasts can
		 *								//					be excanged without problems)
		 * 								//					 FIRST: Table name
		 *								//					SECOND: Export or not Datas
		 * 								//					 THIRD: Where SQL Statements
		 * @return 						// @boolean			If all OK return TRUE
		 */
		function add_tables($tbl_mixed = NULL) {
		
			// Check for Selected Default DB
			if (!isset($this->selected_db) || !$this->selected_db) {
			
				// Error! Get Out
				return FALSE;
			}
			
			// Check for Var
			if (!isset($tbl_mixed) || !$tbl_mixed) {
			
				// If not, Get Out
				return FALSE;
			}
	
			// Make array that will contain table list
			$tbl_list = array();
			
			// Check if the var is a string or an array
			if (!is_array($tbl_mixed)) {
			
				// If isin't an array add to the list as a single table
				$tbl_list[0]['nome'] = $tbl_mixed;
				$tbl_list[0]['params'] = "";
			} else {
			
				// If is an array trasform it in table destination array
				$key = 0;
			
				// Cicle array
				while (list($key,$value) = each($tbl_mixed)) {
				
					// If it contain an array
					if (is_array($value)) {
					
						// get table name and table query commands
						$key_array = array_keys($value);
						$tbl_list[$key]['nome'] = $value[$key_array[0]];
						
						// Check if second param is a SQL COMMAND or if is a BOOLEAN
						if (count($key_array) >= 2) {
							if (is_string($value[$key_array[1]])) {
								$tbl_list[$key]['params'] = (string) $value[$key_array[1]];
							} elseif (is_bool($value[$key_array[1]])) {
								$tbl_list[$key]['dump_data'] = (bool) $value[$key_array[1]];
							}
						}	
							
						// Check for 3 param...if bool is dumpdata flag, if is string is a SQL STATEMENT
						if (count($key_array) >= 3) {
							if (is_string($value[$key_array[2]])) {
								$tbl_list[$key]['params'] = (string) $value[$key_array[2]];
							} elseif (is_bool($value[$key_array[2]])) {
								$tbl_list[$key]['dump_data'] = (bool) $value[$key_array[2]];
							}
						}
						
						// If isin't set PARAMS Key, set IT
						if (!isset($tbl_list[$key]['params'])) {
							$tbl_list[$key]['params'] = "";
						}
						
						// If isin't set DUMP_DATA Key, set IT
						if (!isset($tbl_list[$key]['dump_data'])) {
							$tbl_list[$key]['dump_data'] = TRUE;				
						}
					} else {
					
						// if not set only name and other default value
						$tbl_list[$key]['nome'] = $value;
						$tbl_list[$key]['params'] = "";
						$tbl_list[$key]['dump_data'] = TRUE;
					}
					
					// Incremente Key Counter
					$key++;
				}			
			}
			
			// Reset table counter ad key
			$tbl_added = 0;
			$key = 0;
	
			// Cicle table list
			while (list($key, $tbl_name) = each($tbl_list)) {
			
				// Check if table name is full
				if (!isset($tbl_name['nome']) || !$tbl_name['nome']) {
				
					// If not continue
					continue;
				}
				
				// Check that table exists
				$query = $this->db->execQuery("SHOW TABLE STATUS FROM `{$this->selected_db}` LIKE \"{$tbl_name['nome']}\"");
	
				// Count number of returned rows
				if ($this->db->num_rows($query) != 1) {
				
					// If the number returned isn't equal at 1, there is an error!
					// If ZERO database don't exists
					// If MORE THAN ONE there is more than a database. so it can't select DB!
					continue;
				}
	
				// Add name of the table to class table list
				$this->_TABLES[$key]['nome'] = $tbl_name['nome'];
				$this->_TABLES[$key]['params'] = $tbl_name['params'];
				
				// Check to see if class must export data too
				if (!isset($tbl_name['dump_data'])) {
					
				    // No param passed, so, for default, set data export to true
					$this->_TABLES[$key]['dump_data'] = TRUE;
					
				} else {
				    
				    // Param passed, so it is used
					$this->_TABLES[$key]['dump_data'] = $tbl_name['dump_data'];
					
				}
			
				// Increment counter
				$key++;
				$tbl_added++;
			}
			
			// Returun the number of added tables
			return $tbl_added;
		}
		
		/**
		 * MySQL_DumpDB::dump_database()
		 * Add all tables of a DATABASE instead of a single table
		 * 
		 * @param $dbname			// @string	Name of database. Must EXISTS
		 * @param $reset_anyway		// @boolean if TRUE, change db if table list isn't empty
		 * 							//			default is FALSE
		 * 
		 * @return 					// @boolean	Return the number of added tables if all is
		 * 							// 			ok, if not return FALSE
		 */
		function dump_database($dbname, $reset_anyway = TRUE, $dump_data = TRUE) {
		
			// Check for empty dbname
			if (!isset($dbname) || !$dbname) {
			
				// if yes exit
				return FALSE;
			}
			
			// Try to set SELECTED DB
			if (!$this->select_db($dbname, $reset_anyway)) {
			
				// if fail get out
				return FALSE;
			}
			
			// List tables
			$query = $this->db->execQuery("SHOW TABLE STATUS FROM {$dbname}");
	
			// Cicle results
			$key = "";
			while ($database = $this->db->fetch_array($query)) {
			
				// Add Tables
				$key=count($this->_TABLES);
				$this->_TABLES[$key]['nome'] = $database["Name"];
				$this->_TABLES[$key]['params'] = "";
				$this->_TABLES[$key]['dump_data'] = $dump_data;
			}
			
			// All ok...return TRUE
			return TRUE;
		}
		
		/**
		 * MySQL_DumpDB::export_dump()
		 * Execute Dump
		 * 
		 * @param $drop_tbl			// @boolean	Drop Table statement added if var is TRUE
		 * @param $use_db			// @boolean	Add USE DB statement if var is boolean
		 * @return 					// @boolean	Return TRUE if all is OK
		 */
		function export_dump($drop_tbl = TRUE, $use_db = FALSE, $use_backquote = FALSE) {
		
			// Check for tables in list and check for selected db
			if (count($this->_TABLES) == 0 || !$this->selected_db || !isset($this->selected_db)) {
				return FALSE;
			}
		
			// Empty SQL_DUMP var
			$sql_backup = "";
		
			// Add HEADER comment
			$sql_backup .= $this->_COMMENTS['header'];
			$sql_backup .= "\n";
			
			// if USE_DB is TRUE add it
			if ($use_db) {
			
				// Add USE Comment
				$sql_backup .= $this->_COMMENTS['use'] . "\n";
				$sql_backup .= "\n";
	
				// Add SQL USE command
				$sql_backup .= "USE {$this->selected_db}\n";
				$sql_backup .= "\n";
			}
			
			// Set BackQuote
			if ($use_backquote) {
				// BackQuote Enabled
				$this->db->execQuery("SET SQL_QUOTE_SHOW_CREATE = 1;");
			} else {
				// BackQuote Disabled
				$this->db->execQuery("SET SQL_QUOTE_SHOW_CREATE = 0;");
			}
			
			// Cicle table array
			reset($this->_TABLES);
			
			while (list($key, $tbl_name) = each($this->_TABLES)) {
			
				// Set time limit
				@set_time_limit(120);
				
				// Extract Fields Info
				$res_fields_info = @$this->db->execQuery("SHOW COLUMNS FROM {$tbl_name['nome']};");
				
				// Reset Fields Info array 
				$fld_infos = array();
				
				// Cicle fields infos
				while($fld_infos_row = $this->db->fetch_array($res_fields_info)) {
					$fld_infos[$fld_infos_row['Field']] = $fld_infos_row['Type'];
				}
				
				// Get CREATE TABLE QUERY
				$res_tbl_create = @mysql_fetch_row(@$this->db->execQuery("SHOW CREATE TABLE {$tbl_name['nome']};"));
	
				// Set table name
				$tbl_infos['nome'] = $tbl_name['nome'];
	
				// Set TABLE CREATION STATEMENT
				$tbl_infos['query'] = $res_tbl_create[1];
	
				// Get all records in table
				$query_insert = $this->db->execQuery("SELECT * FROM {$tbl_infos['nome']} " . $tbl_name['params'] . ";");
				
				// If get an error, continue
				if (!$res_tbl_create || !$query_insert) {
					continue;
				}
		
				// Replace all EOL in HEX FORM
				$tbl_infos['query'] = str_replace("\x0a","\n", $tbl_infos['query']);
				$tbl_infos['query'] = str_replace("\x0d","\r", $tbl_infos['query']);
			
				// If DROP_TBL is TRUE
				if ($drop_tbl) {
				
					// Drop table if it exists in destination DB
	
					// Add comment
					$sql_backup .= "#\n";
					$sql_backup .= "# DROP TABLE, IF EXISTS, {$tbl_infos['nome']} AND RE\\CREATE IT \n";
					$sql_backup .= "# RECORDS: " . $this->db->num_rows($query_insert) . "\n";
					$sql_backup .= "#\n";
					$sql_backup .= "\n";
					
					// Add SQL Statement
					$sql_backup .= "DROP TABLE IF EXISTS {$tbl_infos['nome']};\n";
				} else {
				
					// DROP FLAG disabled
					
					// Add comment
					$sql_backup .= "#\n";
					$sql_backup .= "# CREATE TABLE {$tbl_infos['nome']}\n";
					$sql_backup .= "# RECORDS: " . $this->db->num_rows($query_insert) . "\n";
					$sql_backup .= "#\n";
					$sql_backup .= "\n";
				}
	
				// Add SQL CREATE TABLE Statement
				$sql_backup .= "{$tbl_infos['query']};\n";
				$sql_backup .= "\n";
		
				// If all go OK and query to select all records return records dump datas
				if (!$query_insert || $this->db->num_rows($query_insert) == 0) {
					// An error...can't continue!'
					continue;
				}
				
				// If don't dump data is true continue in while
				if (!$tbl_name['dump_data']) {
					continue;
				}
				
				// If all is OK continue to work
				$sql_backup .= "#\n";
				$sql_backup .= "# INSERT STATEMENT FOR {$tbl_infos['nome']}\n";
				$sql_backup .= "#\n";
				$sql_backup .= "\n";
		
				// Fetch data from SELECT QUERY
				while ($res_tbl_create = mysql_fetch_row($query_insert)) {
				
					// Set Time limit
					@set_time_limit(120);
	
					// Init vars
					$_COLNAMES = array();
					$_VALUES = array();
					
					// Extract values from query result and create query
					while (list($key,$value) = each($res_tbl_create)) {				
	
						// Extract COLUMN Type Infos
						$field_info = mysql_fetch_field($query_insert,$key);
						
						// Add col name to the list
						$_COLNAMES[] = $field_info->name;
	
						// If value is a number or is boolean
						if ($field_info->numeric || is_bool($value)) {
									
							// Write it without ''
							$_VALUES[] = !$value ? "0" : $value ;
						} elseif(!isset($value) || !$value) {
							if ($field_info->not_null) {
							
								// If VALUE is NULL and column don't support it write value with ''
								$_VALUES[] = "''";
							} else {
							
								// Can write null
								$_VALUES[] = "N" . "ULL";		// This is a little work around
																// if you write NULL php add a NULL value
																// i need to write NULL into var :D
							}
						} elseif (
								$fld_infos[$field_info->name] == 'tinyblob' ||
								$fld_infos[$field_info->name] == 'blob' ||
								$fld_infos[$field_info->name] == 'mediumblob' ||
								$fld_infos[$field_info->name] == 'longblob'
							) {
							
							// If is a BLOB field...make an HEX
							$_VALUES[] = '0x' . bin2hex($value);
							
						} else {
						
							// Check dangerous CHARS
							$value = str_replace("#","\#", $value);
							$value = str_replace("--","\--", $value);
	
							// Sostituisce NULL, \n, \r, e \Z
							$value = str_replace("\x00","\0", $value);
							$value = str_replace("\x0a","\n", $value);
							$value = str_replace("\x0d","\r", $value);
							$value = str_replace("\x1a","\Z", $value);
	
							// Add SLASHES
							$value = addslashes($value);
							
							// Write value
							$_VALUES[] = "'{$value}'";
						}
					}
					
					// Implode all
					$colnames = implode(",",$_COLNAMES);
					$values = implode(",",$_VALUES);
	
					// Create INSERT STATEMENT
					if ($use_backquote) {
					
						// Add BACKQUOTES
						$sql_backup .= "INSERT INTO `{$tbl_infos['nome']}` ($colnames) VALUES ($values);\n";
					} else {
					
						// Don't Add BACKQUOTES
						$sql_backup .= "INSERT INTO {$tbl_infos['nome']} ($colnames) VALUES ($values);\n";
					}
					
					// Reset Arrays
					$_COLNAMES = NULL;
					$_VALUES = NULL;
					$colnames = NULL;
					$values = NULL;
				}
		
				// Add a EOL
				$sql_backup .= "\n";		
			}
			reset($this->_TABLES);
			
			// If FOOTER exists
			if ($this->_COMMENTS['footer']) {
			
				// add IT to dump
				$sql_backup .= "\n";
				$sql_backup .= $this->_COMMENTS['footer'];
			}
	
			// Set DUMP
			$this->db_dump = $sql_backup;
			
			// Return TRUE
			return TRUE;
		}
		
		/**
		 * MySQL_DumpDB::import_dump()
		 * Imposta dump
		 * 
		 * @param $selectdb					// Select Destination DB
		 * @param $stop_if_error			// Stop to work if a query fail
		 * @param $createdb_if_not_exists	// Create Destination DB if it don't exists! YOU NEED PRIVILEGES TO DO THIS!
		 * @return 							// TRUE: if all is ok - ARRAY: if there are error, return a bidimensional array
		 * 									//                      ['data']	-> Unix TimeStamp Of failed query
		 * 									//                      ['num']		-> Line of failed Query in DUMP
		 * 									//                      ['query']	-> Query
		 * 									//                      ['err_str']	-> Error String
		 * 									//                      ['err_num']	-> Error Number
		 */
		 
		function import_dump($selectdb = "", $stop_if_error = TRUE, $createdb_if_not_exists = FALSE) {
			// If dump is compressed, decompress it
			$this->set_dump($this->db_dump);
		
			// Init Vars
			$errors = array();
	
			// Check if DUMP in var is full
			if (!$this->db_dump) {
			
				// Empty...
				return FALSE;
			}
	
			// If selected db isn't selected...
			if (!$selectdb) {
			
				// ...set default db
				$selectdb = $this->selected_db;
			}
	
			// Il if is empty
			if (!$selectdb) {
			
				// get out
				return FALSE;
			}
	
			// Check if DB exists
			$query = $this->db->execQuery("SHOW DATABASES LIKE \"{$selectdb}\"");
			if ($this->db->num_rows($query) == 0) {
			
				// If not exist and CREATEDB flag is TRUE...create it
				if ($createdb_if_not_exists) {
					$res = $this->db->execQuery("CREATE DATABASE {$selectdb}");
					if (!$res) {
					
						// if get error get out
						return FALSE;
					}
				} else {
				
					// else...get out
					return FALSE;
				}
			} elseif ($this->db->num_rows($query) > 1) {
			
				// If the number returned isn't equal at 1, there is an error!
				// If ZERO database don't exists
				// If MORE THAN ONE there is more than a database. so it can't select DB!
				return FALSE;
			}
	
			// Try to select DB
			$res = mysql_select_db($selectdb);
			if (!$res) {
			
				// If fail return FALSE
				return FALSE;
			}
			
			// Init array
			$dump_rows = array();
	
			// Explode SQL DUMP in a array ... parsing all file
			$tmpVar = $this->__deletecomments($this->db_dump);
			$dump_rows = $this->__splitSqlDump($tmpVar);
			
			// Check for lines
			if (!is_array($dump_rows) && $dump_rows == FALSE) {
			
				// If dump is empty get out
				return FALSE;
			}
			
			// There are lines...make import
			$key_dump = 0;
	
			// Execue DUMP Query
			while (list($key, $dump_line) = each($dump_rows)) {
	
				// If empty get out
				if (!$dump_line) {
					continue;
				}
				
				// Execute dump
				$res = $this->db->execQuery($dump_line);
				if (!$res) {
				
					// If there is errore, add to error list, the query
					$errors[$key_dump]["data"] = time();
					$errors[$key_dump]["num"] = ($key+1);
					$errors[$key_dump]["query"] = $dump_line;
					$errors[$key_dump]["err_str"] = mysql_error();
					$errors[$key_dump]["err_num"] = mysql_errno();
					$key_dump++;
				}
				
				// if STOP IF ERROR FLAG is TRUE
				if (!$res && $stop_if_error) {
				
					// return ERRORS
					return $errors;
				}
			}
	
			// Check for errors
			if (count($errors) != 0) {
			
				// If there are errors return ERRORS ARRAY
				return $errors;
			} else {
			
				// If not return TRUE
				return TRUE;
			}
		}
		
		/**
		 * MySQL_DumpDB::get_dump()
		 * Read DUMP from class
		 * 
		 * @param $isGZip		// Compress DUMP in GZip file format
		 * @param $isBZip2		// Compress DUMP in BZip2 file format
		 * @return				// FALSE: if empty - STRING: if there is DUMP
		 */
		function get_dump($isGZip = FALSE, $isBZip2 = FALSE) {
		
			// Return MySQL DUMP
			if (!$this->db_dump) {
			
				// If empty return FALSE
				return FALSE;
			}
			
			// Set DUMP in a var
			$ris = $this->db_dump;
			
			// If isGZip FLAG is TRUE, Create GZip			
			if ($isGZip) {
	
				// Check for GZip Extension
				if(!function_exists("gzencode")) {
					return FALSE;
				}
				
				// Encode using GZip
				$ris = gzencode($ris, 9);
	
			// If isBZip2 FLAG is TRUE, Create BZip2			
			} elseif ($isBZip2) {
	
				// Check for BZ2 Extension
				if(!function_exists("bzcompress")) {
					return FALSE;
				}
				
				// Compress using BZip2
				$ris = bzcompress($ris, 9);
			}
			
			// If all is ok return DUMP
			return $ris;
		}
		
		
		/**
		 * MySQL_DumpDB::set_dump()
		 * Set DUMP into CLASS (use it to set DUMP to import in MySQL)
		 * 
		 * @param $db_dump		// Dump
		 * @param $overwrite	// If there is a DUMP, overwrite IT
		 * @return 				// Boolean	FALSE: something fails - TRUE: all OK
		 */
		function set_dump($db_dump, $overwrite = TRUE, $isGZip = FALSE, $isBZip2 = FALSE) {
		
			// Trim DUMP
			$db_dump = trim($db_dump);
			
			// Check if DUMP was passed
			if (!isset($db_dump) || !$db_dump) {
				// If not FAIL
				return FALSE;
			}
			
			// Check if DUMP exists, if YES...and OVERWRITE FLAG is FALSE, exit
			if ($this->db_dump && !$overwrite) {
				return FALSE;
			}
			
			// Check if it is compressed (Try to reknown HEADERS)
			
			// GZIP Header --> 031|139|008 (use this with CHR)
			// Check for GZIP Header
			if (($db_dump{0} == chr(31) && $db_dump{1} == chr(139) && $db_dump{2} == chr(8)) || $isGZip) {
			
				// Is a GZIP compressed file
				if (!function_exists("gzinflate")) {
					return FALSE;
				}
				
				// Decompress DUMP
				$db_dump = @gzinflate(substr($db_dump,10,-4));
			}
			
			// Check for BZIP Header --> BZh
			if (($db_dump{0} == "B" && $db_dump{1} == "Z" && $db_dump{2} == "h") || $isBZip2) {
			
				// Is a BZIP compressed file
				if (!function_exists("bzdecompress")) {
					return FALSE;
				}
				
				// Decompress DUMP
				$db_dump = @bzdecompress($db_dump);
			}
	
			// If OVERWRITE FLAG is TRUE or DUMP isn't EMPTY, write DUMP
			$this->db_dump = $db_dump;
			
			// Return TRUE
			return TRUE;
		}
		
		/**
		 * MySQL_DumpDB::config_reset()
		 * Reset Config
		 * 
		 * @return 		// Ever TRUE
		 */
		function config_reset() {
		
			//Empty Comments
			$this->_COMMENTS['header'] = NULL;
			$this->_COMMENTS['footer'] = NULL;
			$this->_COMMENTS['use'] = NULL;
			
			// Set DEFAULT Comment
			$this->__default_COMMENT();
			
			// Empty SELECTED DB
			$this->selected_db = "";
			
			// Empty Table List
			$this->_TABLES = NULL;
			$this->_TABLES = array();
	
			// Empty Dump
			$this->db_dump = "";
			
			// Return TRUE
			return TRUE;
		}
		
		/**
		 * MySQL_DumpDB::save_dump()
		 * Save DUMP in a file
		 * 
		 * @param $filename				// FileName
		 * @param $isGZip				// If is TRUE, compress it in GZIP format
		 * @param $isBZip2				// If is TRUE, compress it in BZIP2 format
		 * @return 
		 */
		function save_dump($filename, $isGZip = TRUE, $isBZip2 = FALSE) {
		
			// Get DUMP (Compressed or not)
			$ris = $this->get_dump($isGZip, $isBZip2);
	
			// Add GZIP\BZIP2 extension to file
			if ($isGZip) {
			
				// GZIP extension
				$filename .= ".gz";
			} elseif ($isBZip2) {
			
				// BZIP2 extension
				$filename .= ".bz2";
			}
		
			// Open file	
			$fp = @fopen($filename, "wb");
			
			// Check if fail 
			if (!$fp) return FALSE;
			
			// Write UN\COMPRESSED Dump to FILE
			$res = @fwrite($fp, $ris, strlen($ris));
			
			// Check if fail
			if (!$res) return FALSE;
			
			// Close FILE
			@fclose ($fp);
			
			// Ritorna TRUE
			return TRUE;
		}
		
		/**
		 * MySQL_DumpDB::download_dump()
		 * 
		 * @param $filename				// Filename. If is empty it will generate something like:
		 * 								//		sqldump_DD_MM_YYYY.gz\bz2
		 * @param $isGZip				// If is TRUE, compress it in GZIP format
		 * @param $isBZip2				// If is TRUE, compress it in BZIP2 format
		 * @return 						// TRUE: if all is OK, FALSE: if something goes wrong
		 */
		function download_dump($filename = "", $isGZip = TRUE, $isBZip2 = FALSE) {
		
			// If filename is empty, generate it
			if ($filename == "") {
				$filename = "sqldump_" . date("d_m_Y") . ".sql";
	
				// Add GZIP\BZIP2 extension to file
				if ($isGZip) {
				
					// GZIP extension
					$filename .= ".gz";
				} elseif ($isBZip2) {
				
					// BZIP2 extension
					$filename .= ".bz2";
				}
			}
			
			// Get DUMP (Compressed or not)
			$ris = $this->get_dump($isGZip,$isBZip2);
			
			// Invia gli HEADER al browser
			header("Content-type: application/octet-stream");
			header("Content-disposition: attachment; filename={$filename}; size=" . strlen($ris));
			header("Content-length: " . strlen($ris));
			
			// Send DUMP Content to browser
			echo $ris;
			flush();
			
			// Return TRUE
			return TRUE;
		}
		
		/*
			---===[ Internal Functions ]===---
		*/
		
		/**
		 * MySQL_DumpDB::__deletecomments()
		 * Delete comments from DUMP
		 * 
		 * @param $dump			// MySQL Dump
		 * @return 				// Decommented MySQL Dump
		 */
		function __deletecomments($dump) {
			
			// Delete all SINGLE LINE Comments
			$dump = preg_replace("/(#|--).*?(\r\n|\r|\n)/","",$dump);
			
			// Delete all MULTI LINE Comments
			$dump = preg_replace("/\/\*.*?\*\//s","",$dump);
			
			// Return DUMP
			return $dump;
		}
	
		/**
		 * MySQL_DumpDB::__splitSqlDump()
		 * Split DUMP Data
		 * 
		 * @param $dump			// MySQL Dump
		 * @return 				// Query Array
		 */
		function __splitSqlDump($dump) {
			
			// Init Vars
			$char = "";
			$string_start = "";
			
			// Get Dump Lenght
			$dump_len = strlen($dump);
			
			// init Query Array
			$dumpArr = array();
			
			// Set Flags
			$in_string = FALSE;
			
			// Miscs
			$dump = trim($dump);
			
			// Start to cicle DUMP
			for ($i = 0; $i < $dump_len; ++$i) {
			
				// Get char from dump
				$char = $dump{$i};
				
				// Check for FLAGS
				if ($in_string) {
					
					// Check if String Start-End is a backquote
					if ($char == "`" && $string_start == $char) {
					
						// Set Flag to false
						$in_string = FALSE;
						$string_start = "";
						continue;
						
					// Check if is a Single Quote or a Quote without backslash before it
					} elseif ($string_start == $char && $dump{($i-1)} != "\\") {
						
						// Set Flag to false
						$in_string = FALSE;
						$string_start = "";
						continue;
					}
					
				// Isi't in string
				} else {
				
					// Check for BackQuotes, Single Quotes and Quotes, if yes
					if ($char == "\"" || $char == "'" || $char == "`") {
						
						// Set STRING Flag to TRUE
						$in_string = TRUE;
						
						// Set STRING STARTER CHAR
						$string_start = $char;
	
					// Search for Query Delimitator					
					} elseif ($char == ";") {
						
						// If found it, add query to Query Array
						$dumpArr[] = substr($dump,0,$i);
						
						// Calculate new start pos
						$start_pos = min($i+1, $dump_len);
						
						// Get DUMP without query line
						$dump = ltrim(substr($dump, $start_pos));
						
						// Set DUMP Lenght
						$dump_len = strlen($dump);
						
						// If isin't ZERO
						if ($dump_len) {
						
							// Set $i to -1, so restart from 0 the next cicle
							$i = -1;
						} else {
						
							// If not, dump is empty, no more queries! Return Dump Array
							return $dumpArr;
						}
					}
				}
			}
			
			// If DUMP string isn't empty,
			if ($dump) {
			
				// Add the string to Dump Array
				$dumpArr[] = $dump;
			}
			
			// Check if Dump Array is empty
			if (count($dumpArr) == 0) {
			
				// If is empty no delimiters founded, so add all DUMP to a single query string
				$dumpArr[] = $dump;
			}
			
			// Check if Dump Array is empty
			if (count($dumpArr) == 0) {
			
				// If yes no query in dump, get out
				return FALSE;
			}
			
			// Return Dump Array
			return $dumpArr;
		}
		
		/**
		 * MySQL_DumpDB::__default_COMMENT()
		 * Private Function: set default comment
		 * 
		 * @return 		// Ever TRUE
		 */
		function __default_COMMENT() {
		
			// Prepare vars
			$header = "";
			$footer = "";
			$use = "";
			
			// Set DEFAULT content of HEADER COMMENT
			$header .= "# Database Dump :" . "\n";
			$header .= "#     Data: " . date ("d/m/Y") . "\n";
			$header .= "#     Time: " . date ("H:i:s") . "\n";
			$header .= "#\n";
			$header .= "# Unixtime: " . time() . "\n";
			$header .= "#\n";
			$header .= "# From '{$_SERVER['HTTP_HOST']}'\n";
			$header .= "#\n";
			$header .= "# PHP Infos:\n";
			$header .= "#\tVersion: " . phpversion() . "\n";
			if (php_sapi_name()) {
				$header .= "#\tUsing `" . ucfirst(php_sapi_name()) . "` SAPI Module\n";	
			}
			$header .= "#\n";
			$header .= "# MYSQL Infos: \n";
			$header .= "#\t    Version: " . mysql_get_server_info() . "\n";	
			$header .= "#\t  Host Info: " . mysql_get_host_info() . "\n";	
			$header .= "#\tClient Info: " . mysql_get_client_info() . "\n";	
			
			// Set DEFAULT content of FOOTER COMMENT
			$footer .= "######################################\n";
			$footer .= "#                                    #\n";
			$footer .= "#    Class Written by daniele_dll    #\n";
			$footer .= "#                                    #\n";
			$footer .= "#    E-Mail: daniele_dll@yahoo.it    #\n";
			$footer .= "#   WebSite: http://www.phpsoft.it   #\n";
			$footer .= "#                                    #\n";
			$footer .= "######################################\n";
			
			// Set DEFAULT content of USE COMMENT
			$use .= "#\n";
			$use .= "# SELECT DESTINATION DB\n";
			$use .= "#\n";
			
			// SET VARS in class
			$this->define_COMMENT("header", $header);
			$this->define_COMMENT("use", $use);	
			$this->define_COMMENT("footer", $footer);	
		}
	}

?>
