<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/
if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}


/**
* create a menu
*
* @param string $nom
* @param int $val
* @param int $tab
* @param int $stes
* @author Mix <mix@my-board.net>
* @since v 1.0
* @access Public
* @return String
*/	
function menu_create($nom, $val, $tab = 0, $stes = 0)
{
	$men = "<select name='".$nom."'>";
	$count = 0;
	foreach($val as $key => $str)
	{
		if($count == $tab)
			$sel = " selected='selected' ";
		else
			$sel = "";
			
		if($stes == 1)
			$men .= "<option value = '{$str}'{$sel}>{$str}</option>";
		else
			$men .= "<option value = '{$key}'{$sel}>{$str}</option>";
		
		$count++;
	}
	
	$men .= "</select>";
	return $men;
}

/**
* compile a insert mysql string
*
* @param array $data
* @author Mix <mix@my-board.net>
* @since v 1.0
* @access Public
* @return Array
*/	
function compile_insert($data) 
{
    
    $field_names  = "";
	$field_values = "";
		
	foreach ($data as $k => $v)
	{
		$v = preg_replace( "/'/", "\\'", $v );
			
		$field_names  .= "$k,";
		$field_values .= "'$v',";
	}
		
	$field_names  = preg_replace( "/,$/" , "" , $field_names  );
	$field_values = preg_replace( "/,$/" , "" , $field_values );
		
	return array( 'NOME'  => $field_names,
				  'VAL'   => $field_values,
				);
}

/**
* compile an update mysql string
*
* @param array $data
* @author Mix <mix@my-board.net>
* @since v 1.0
* @access Public
* @return String
*/	
function compile_update($data) 
{
		
	$return_string = "";
		
	foreach ($data as $k => $v)
	{
		$v = preg_replace( "/'/", "\\'", $v );
		$return_string .= $k . "='".$v."',";
	}
		
	$return_string = preg_replace( "/,$/" , "" , $return_string );
		
	return $return_string;
}

/**
* Sort a 2d array in base of a field in ASC mode or DESC mode ($reverse)
*
* @param array $records
* @param String $field
* @param bool $reverse
* @author richard <richard@happymango.me.uk>
* @since v 1.0
* @access Public
* @return array()
*/	
function record_sort($records, $field, $reverse=false)
{
   $hash = array();
  
   foreach($records as $record)
   {
       $hash[$record[$field]] = $record;
   }
  
   ($reverse)? krsort($hash) : ksort($hash);
  
   $records = array();
  
   foreach($hash as $record)
   {
       $records []= $record;
   }
  
   return $records;
}

/**
* Search in a 2d array
*
* @param array $arrayVet
* @param String $campo
* @param ? $valor
* @param bool $reverse
* @author erick.xavier <erick.xavier@gmail.com>
* @since v 1.0
* @access Public
* @return array()
*/	
//
function multiarray_search($arrayVet, $campo, $valor)
{
   while(isset($arrayVet[key($arrayVet)]))
   {
       if($arrayVet[key($arrayVet)][$campo] == $valor)
           return key($arrayVet);
       
       next($arrayVet);
   }
   return -1;
}

/**
* check if a data is serialized or not
*
* @param mixed $data    variable to check
* @author denadai2 <denadai2@gmail.com>
* @since v 1.0
* @return boolean
*/
function is_serialized($data)
{
    if (trim($data) == "")
        return false;
   
    if (preg_match("/^(i|s|a|o|d)(.*);/si",$data))
        return true;
   
    return false;
} 

?>