<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/
if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}

class rev_classes
{

	/**
    * Database connection class
    * @access Private
    * @var class
    */
	var $db;
	
	/**
    * config array
    * @access Public
    * @var array()
    */
	var $_config;
	
	/**
    * file config array
    * @access Public
    * @var array()
    */
	var $file_config;
	
	/**
    * var filtrer class
    * @access Public
    * @var class
    */
	var $var_filtrer;
	
	/**
    * skin class
    * @access Public
    * @var class
    */
	var $skin;
	
	/**
    * lang class
    * @access Public
    * @var class
    */
	var $lang;
	
	/**
    * error class
    * @access Public
    * @var class
    */
	var $error;
	
	/**
    * user class
    * @access Public
    * @var class
    */
	var $user;
	
	/**
    * cache class
    * @access Public
    * @var class
    */
	var $cache;	
	
	/**
    * RevokeBB start time script
    * @access Private
    * @var int
    */
	var $time_count;

	/**
    * RevokeBB action page
    * @access Public
    * @var String
    */	
	var $act;

	/**
	* rev_classes constructor
	*
	* @param array CONFIG
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return Void
	*/	
	function rev_classes($CONFIG, $act)
	{
		
		$this->cache = new CacheEngine();
		$this->act = $act;
		$this->file_config = $CONFIG;
		
		$this->time_count = $this->microtime_float();
		
		//---------------------------------
		// Database initialisation
		//---------------------------------
		$this->db=new database($CONFIG);
		$this->db->connect();
		
		//---------------------------------
		// Board Configs initialisation
		//---------------------------------
		$this->_config = $this->cache->GetFromCache('sql_conf', 0, true);
		if(!$this->_config)
		{
			$query=$this->db->execQuery($this->db->sql_build('fetch_configs'));
			while($row=$this->db->fetch_array($query))
			{
				$this->_config[$row['conf_name']] = $row['conf_value'];
				$this->_config[$row['conf_name'].'_def'] = $row['conf_default'];
			}
			$this->cache->WriteToCache('sql_conf', $this->_config);
		}
		else
		{
			$query=$this->db->execQuery($this->db->sql_build('fetch_configs_cacheon'));
			while($row=$this->db->fetch_array($query))
			{
				$this->_config[$row['conf_name']] = $row['conf_value'];
				$this->_config[$row['conf_name'].'_def'] = $row['conf_default'];
			}
		}
		
		$this->var_filtrer = new var_filtrer();
		//---------------------------------
		// Skin initialisation
		//---------------------------------
		$this->skin = new Skin($this->_config);	
		
		//---------------------------------
		// Language initialisation
		//---------------------------------
		$this->lang = new Language();
		$this->lang->setlanguage($CONFIG['lang']);
		
		
		$this->error = new Status($this->lang, $this->skin, $this->_config);
		
		$this->user = new User($this->db, $this->skin, $this->lang, $this->_config, $this->file_config, $this->error, $this->cache, $this->act);
		
		$this->error->info_user = & $this->user->info_user;
		
		//---------------------------------
		// Code insert
		//---------------------------------
		if($_SESSION['admin']==false)
		{
			if(!isset($_GET['code']))
				$this->_code = 0;
			else
			{
				$this->var_filtrer->add($_GET);
				$this->_code = $this->var_filtrer->Integer('code');
				
			}
		}
		else
		{
			if(!isset($_GET['code']))
				$this->_code = 'index';
			else
			{
				$this->var_filtrer->add($_GET);
				$this->_code = $this->var_filtrer->String('code',0);
			}
		}		
		
	}
	
	/**
    * Assing all system variables to the skin
    *
    * @param None
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */
	function assign_all()
	{
		if($this->act == 'newthread' || $this->act == 'newmp')
			$this->skin->assign('act', 'newpost.tpl');
		else
			$this->skin->assign('act', $this->act.'.tpl');
			
		$this->skin->assign('user', $this->user->info_user);
		$this->skin->assign('config', $this->_config);

		$this->skin->assign('mode', array('modcp' => intval($_SESSION['modcp']), 'admin' => intval($this->user->info_user['admincp'] == 1)));
		$this->skin->assign('footer', $this->footer());
		$this->skin->assign('lang', $this->lang->lang_all);
		
		
		
	
	}

	/**
    * Forum skin view
    *
    * @param None
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */
	function display_skin()
	{
		
			
		$this->skin->content = $this->skin->fetch('main.tpl', $this->lang->lang.$this->act.$add.$this->user->info_user['level']);
		
		$this->skin->cache = false;
		
		if($this->act == 'index')
			$this->skin->content .= $this->skin->fetch('index_stats.tpl');
			
		$this->skin->content =	$this->skin->fetch('header.tpl') . $this->skin->content . $this->skin->fetch('footer.tpl');
		
		$this->skin->display_all();
	}
	
	/**
    * Admin skin view
    *
    * @param None
    * @author denadai2 <denadai2@gmail.com>
    * @since v 1.0
    * @access Public
    * @return Void
    */	
	function display_admin_skin()
	{
		
		$this->skin->cache = false;
		if($this->_code!='index')
			$this->skin->content .= $this->skin->fetch('admincp/ad_'.$this->_code.'.tpl');
		else
			$this->skin->content .= $this->skin->fetch('admincp/'.$this->_code.'.tpl');
		
		//don't display the stats	
		$this->skin->assign('footer', array('queries' 	=> 0,
											'time'		=> 0
											));
		
		$this->skin->content = $this->skin->content . $this->skin->fetch('footer.tpl');
		
		$this->skin->display_all();
	}
	
	/**
    * Footer statistics
    *
    * @param None
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */
	function footer()
	{
		
		$time=(float)$this->microtime_float()-$this->time_count;
		
		$stats = array( 'queries' 		=> 		$this->db->num_query,
						'time'			=> 		number_format($time,4,',','.'),
						'version'		=>		$this->_config['board_version']
						);
		return $stats;
		//board_version
	}
	
	/**
    * Function to count the microseconds of execution
    *
    * @param None
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return float
    */
	function microtime_float()
	{
		list($usec, $sec) = explode(" ", microtime());
		return ((float)$usec + (float)$sec);
	}


}

?>