<?php
/*
+--------------------------------------------------------------------------+
|   RevokeBB 1.0											               |
|   ========================================                               | 
|   author: denadai2 <denadai2@gmail.com>                                  |
|   copyright (c) 2006 RevokeSoft                                          |
|   http://www.revokesoft.net 											   |
|   license: http://opensource.org/licenses/gpl-license.php 			   |
|   GNU Public License                                					   |
|   ========================================							   |
+--------------------------------------------------------------------------+


*/
if ( ! defined( 'IN_REVOKE' ) )
{
	print '<html><head><title>RevokeBB Error</title></head><body><h1>Incorrect access</h1>You cannot access this file directly.</body></html>';
	exit();
}

class RevokeBB
{
	/**
    * revokeBB path
    * @access Private
    * @var String
    */
	var $_path;



	/**
    * RevokeBB board configurations
    * @access Private
    * @var array
    */
	var $_config;

	/**
    * Basic constructor of RevokeBB
    *
    * @param None
    * @author denadai2 <denadai2@gmail.com>
    * @since v 0.1
    * @access Public
    * @return Void
    */
	function RevokeBB()
	{
	
		$this->_path='';
		
	
		
		define ( 'PHP_EXT',     '.php' );
		define ( 'SYSTEM_PATH', $this->_path );
		
		//---------------------------------
		// Fetch the essential core libraries:
		//---------------------------------
		require SYSTEM_PATH . 'inc/rev_classes'					. PHP_EXT;
		require SYSTEM_PATH . 'inc/t_lite/class.template'		. PHP_EXT;
		require SYSTEM_PATH . 'inc/class_skin'					. PHP_EXT;
		require SYSTEM_PATH . 'config'							. PHP_EXT;
		require SYSTEM_PATH . 'inc/db/class_'.$CONFIG['dbtype']	. PHP_EXT;
		require SYSTEM_PATH . 'inc/class_language'				. PHP_EXT;
		require SYSTEM_PATH . 'inc/class_status'				. PHP_EXT;
		require SYSTEM_PATH . 'inc/class_users'					. PHP_EXT;
		require SYSTEM_PATH . 'inc/class_var_filtrer'			. PHP_EXT;
		require SYSTEM_PATH . 'inc/class_cache'					. PHP_EXT;
		
		$act = $this->get_action();
		
		require SYSTEM_PATH . 'inc/acts/'.$act.'.module'		. PHP_EXT;
		
		//---------------------------------
		// Load RevokeBB core class
		//---------------------------------
		$module = new Module($CONFIG, $act);
		$module->execute();

	}

	/**
	* Function that get the server load if it is possible
	*
	* @param array none
	* @author denadai2 <denadai2@gmail.com>
	* @since v 1.0
	* @access Public
	* @return Void
	*/	
	function get_load()
	{
		$cpu_load = 0;
		
		if ( @file_exists('/proc/stat') )
		{
			$fd = @fopen("/proc/stat","r");
			if ($fd) 
			{
				$statinfo = explode("\n",fgets($fd, 1024));
				fclose($fd);
				foreach($statinfo as $line) 
				{
					$info = explode(" ",$line);
					if($info[0]=="cpu") 
					{
						array_shift($info);  // pop off "cpu"
						if(!$info[0]) array_shift($info); // pop off blank space (if any)
						$user = $info[0];
						$nice = $info[1];
						$system = $info[2];
						$idle = $info[3];
						return;
					}
			 	}
		   
			
			
			//printf("Delta - User: %f  Nice: %f  System: %f  Idle: %f<br>",$d_user,$d_nice,$d_system,$d_idle);
	
			$total=$d_user+$d_nice+$d_system+$d_idle;
			if ($total<1)
				$total=1;
			$scale = 100.0/$total;
			
			$cpu_load = ($user+$nice+$system)*$scale;
		   /* $this->load["user"] = $user*$scale;
			$this->load["nice"] = $nice*$scale;
			$this->load["system"] = $system*$scale;
			$this->load["idle"] = $d_idle*$scale;
			$this->load["cpu"] = ($d_user+$d_nice+$d_system)*$scale; */
			}
		}
		else
		{
			if(strstr(strtolower(PHP_OS), 'win'))
			{
				$serverstats = @shell_exec("typeperf \"Processor(_Total)\ Processor Time\" -sc 1");
							
				if( $serverstats )
				{
					$server_reply = explode( "\n", str_replace( "\r", "", $serverstats ) );
					$serverstats = array_slice( $server_reply, 2, 1 );
					
					$statline = explode( ",", str_replace( '"', '', $serverstats[0] ) );
					
					$cpu_load = round( $statline[1], 2 ); 
				}
			}
			else
			{
				$data = exec('uptime');
				$data = split('load average:', $data);
				$data = split(', ', $data[1]); 
				if($data[0] <= 0.99)
					$cpu_load = str_replace('0.', '', $data[0]);
				elseif($data[0] >= 1)
					$cpu_load = str_replace('.', '', $data[0]);     
			}
		}
		
		return $cpu_load;
	}
	
	function get_action()
	{
		$array = array_keys($_GET);
		
		switch ($array[0])
		{
			case 'showforum': break;
			case 'login': break;
			case 'user': break;
			case 'showthread': break;
			case 'register': break;
			case 'usercp': break;
			case 'memberlist': break;
			case 'search': break;
			case 'newmail': break;
			case 'admin': break;
			default: $array[0] = 'index'; break;
		}
		return $array[0];
	}


}

?>